import type { Material, MaterialDestroyOptions, MaterialOptions, MaterialRenderStates } from '../../types';
import { MaterialRenderType } from '../../types/Material';
import type { Immutable } from '../../types/type';
import { GLMaterial } from '../webgl/GLMaterial';
import type { MarsRenderer } from './MarsRenderer';
import { MarsMaterialDataBlock } from './MarsMaterialDataBlock';
export declare class MarsMaterial implements Material {
    readonly shaderCacheId: string;
    readonly options: Immutable<MaterialOptions>;
    readonly materialInternal?: GLMaterial;
    readonly name: string;
    readonly _dataBlocks: MarsMaterialDataBlock[];
    readonly renderType: MaterialRenderType;
    readonly states: Immutable<MaterialRenderStates>;
    readonly renderer?: MarsRenderer;
    private _dbMap;
    private _isDestroyed;
    get isDestroyed(): boolean;
    get dataBlocks(): MarsMaterialDataBlock[];
    get defaultDataBlock(): MarsMaterialDataBlock;
    constructor(options: MaterialOptions);
    createMaterialStates(states: MaterialRenderStates): Immutable<MaterialRenderStates>;
    addDataBlock(b: MarsMaterialDataBlock): void;
    getDataBlockByName(name: string): MarsMaterialDataBlock;
    removeDataBlock(b: MarsMaterialDataBlock): void;
    assignRenderer(renderer: MarsRenderer): MarsMaterial;
    destroy(options?: MaterialDestroyOptions): void;
}
