import type { InstancedMeshOptions, Mesh, MeshDestroyOptions, MeshOptions } from '../../types/Mesh';
import { MarsMaterial } from './MarsMaterial';
import { MarsGeometry } from './MarsGeometry';
import type { Material, MaterialDestroyOptions, MaterialOptions } from '../../types/Material';
import type { MarsRenderer } from './MarsRenderer';
import { DestroyOptions } from '../../types/constants';
import type { InstancedMesh } from '../../types/Mesh';
export declare class MarsMesh implements Mesh {
    readonly material: MarsMaterial;
    readonly geometries: MarsGeometry[];
    readonly name: string;
    priority: number;
    hide: boolean;
    renderer?: MarsRenderer;
    private _isDestroyed;
    get isDestroyed(): boolean;
    get geometry(): MarsGeometry;
    constructor(options: MeshOptions, renderer?: MarsRenderer);
    setMaterial(mtl: Material | MaterialOptions, destroyMtl?: MaterialDestroyOptions | DestroyOptions.keep): void;
    setGeometries(geos: MarsGeometry[], destroyGeometries?: DestroyOptions): void;
    destroy(options?: MeshDestroyOptions): void;
    assignRenderer(renderer: MarsRenderer): MarsMesh;
}
export declare class MarsInstancedMesh extends MarsMesh implements InstancedMesh {
    instanceCount: number;
    constructor(options: InstancedMeshOptions, renderer?: MarsRenderer);
}
