import type { RenderFrame, RenderFrameDestroyOptions, RenderFrameOptions, RenderPass, RenderPassLoadAction } from '../../types';
import type { MarsRenderer } from './MarsRenderer';
import { MarsSemanticMap } from './MarsSemanticMap';
export declare class MarsRenderFrame implements RenderFrame {
    loadAction: RenderPassLoadAction;
    readonly name: string;
    readonly semantics: MarsSemanticMap;
    _renderPasses: RenderPass[];
    private _renderer;
    private _isDestroyed;
    get renderPasses(): RenderPass[];
    get isDestroyed(): boolean;
    get renderer(): MarsRenderer;
    constructor(options: RenderFrameOptions, renderer?: MarsRenderer);
    assignRenderer(renderer: MarsRenderer): MarsRenderFrame;
    destroy(options?: RenderFrameDestroyOptions): void;
    render(): void;
    setRenderPasses(passes: RenderPass[]): void;
    addRenderPass(pass: RenderPass): void;
    removeRenderPass(pass: RenderPass): void;
    forEachRenderPass(callback: (renderPass: RenderPass, index: number, pipeline: MarsRenderFrame) => void): void;
}
