import type { RenderPassColorAttachment, RenderPassColorAttachmentOptions, RenderPassColorAttachmentTextureOptions } from '../../types/RenderPass';
import { RenderPassAttachmentStorageType } from '../../types/RenderPass';
import { MarsTexture } from './MarsTexture';
import type { MarsRenderer } from './MarsRenderer';
interface MarsRenderPassColorAttachmentOptions extends RenderPassColorAttachmentOptions {
    size?: [x: number, y: number];
    name?: string;
}
interface MarsRenderPassColorAttachmentTextureOptions extends RenderPassColorAttachmentTextureOptions {
    size?: [x: number, y: number];
}
export declare class MarsRenderPassColorAttachment implements RenderPassColorAttachment {
    readonly readable: boolean;
    texture: MarsTexture;
    readonly externalTexture: boolean;
    textureOptions?: MarsRenderPassColorAttachmentTextureOptions;
    private _isDestroyed;
    multisample: number;
    readonly storageType = RenderPassAttachmentStorageType.color;
    get isDestroyed(): boolean;
    constructor(options: MarsRenderPassColorAttachmentOptions);
    get size(): [x: number, y: number];
    get width(): number;
    get height(): number;
    assignRenderer(renderer: MarsRenderer): MarsRenderPassColorAttachment;
    destroy(): void;
}
export {};
