import type { GPUBuffer, GPUBufferOptions, GPUCapability, GPURenderer, RendererOptions, RenderFrameOptions, ShaderLibrary } from '../../types';
import { GLGPURenderer } from '../webgl/GLGPURenderer';
import { MarsRenderFrame } from './MarsRenderFrame';
import type { Canvas } from '../../types/Canvas';
import { MarsExtWrap } from './MarsExtWrap';
export declare class MarsRenderer implements GPURenderer {
    readonly gpu: GPUCapability;
    readonly shaderLibrary: ShaderLibrary;
    readonly internal: GLGPURenderer;
    readonly canvas: Canvas;
    readonly extension: MarsExtWrap;
    get isDestroyed(): boolean;
    get height(): number;
    get width(): number;
    constructor(options: RendererOptions);
    createBuffer(options: GPUBufferOptions): GPUBuffer;
    createRenderFrame(options?: RenderFrameOptions): MarsRenderFrame;
    destroy(haltGL?: boolean): void;
    resize(width: number, height: number): void;
    cancelAnimationFrame(id: number): void;
    resume(): void;
    getErrors(): string[];
    invalid(): void;
    requestAnimationFrame(cb: FrameRequestCallback): number;
}
