import type { GPUBuffer, RenderState, UniformValue, SemanticMap, SemanticGetter } from '../../types';
export declare class MarsSemanticMap implements SemanticMap {
    readonly semantics: Record<string, SemanticGetter>;
    constructor(semantics?: Record<string, SemanticGetter>);
    toObject(): Record<string, SemanticGetter>;
    setSemantic(name: string, value: SemanticGetter | undefined): void;
    getSemanticValue(name: string, state: RenderState): UniformValue | GPUBuffer | null | undefined;
    hasSemanticValue(name: string): boolean;
    destroy(): void;
}
