import type { Texture, TextureOptions, TextureSourceOptions } from '../../types/Texture';
import { TextureSourceType } from '../../types/Texture';
import type { GLGPURenderer } from '../webgl/GLGPURenderer';
import { GLTexture } from '../webgl/GLTexture';
import type { Immutable } from '../../types/type';
import type { MarsRenderer } from './MarsRenderer';
export declare function closeImageBitMap(img: any): void;
export declare class MarsTexture implements Texture {
    readonly id: string;
    readonly options: Immutable<TextureOptions>;
    readonly sourceType: TextureSourceType;
    readonly name: string;
    readonly renderer?: MarsRenderer;
    readonly internal?: GLTexture;
    private _offloaded;
    private _isDestroyed;
    get isDestroyed(): boolean;
    constructor(options: TextureOptions | GLTexture, renderer?: MarsRenderer);
    checkOptions(options: TextureOptions): Immutable<TextureOptions>;
    get width(): number;
    get height(): number;
    assignRenderer(renderer: MarsRenderer): MarsTexture;
    _assignRenderer(renderer: GLGPURenderer): void;
    uploadCurrentVideoFrame(): boolean;
    destroy(): void;
    reloadDataAsync(): Promise<Texture>;
    offloadData(): void;
    updateSource(options: TextureSourceOptions): void;
}
