import type { Texture, TextureConfigOptions, TextureCubeSourceURLMap, TextureFactory, TextureFactorySourceFrom, TextureOptions, TextureSourceCubeData } from '../../types/Texture';
import type { TypedArray, vec2 } from '../../types';
export declare class MarsTextureFactory implements TextureFactory {
    reloadPending: {
        [key: string]: Promise<Texture>;
    };
    constructor();
    loadMipmapImagesAsync(pointers: vec2[], bin: ArrayBuffer): Promise<(HTMLImageElement | ImageBitmap)[]>;
    loadImageAsync(url: string | HTMLImageElement | Blob): Promise<HTMLImageElement | ImageBitmap>;
    requestBinaryAsync(url: string): Promise<ArrayBuffer>;
    loadImageBinaryAsync(binary: ArrayBuffer | TypedArray | Blob, mime?: string): Promise<HTMLImageElement | ImageBitmap>;
    canOffloadTexture(texture: Texture): boolean;
    loadSourceAsync(sourceFrom: TextureFactorySourceFrom, config?: TextureConfigOptions): Promise<TextureOptions>;
    _loadVideoAsync(url: string | null | MediaProvider): Promise<HTMLVideoElement>;
    _loadCubeMapAsync(map: TextureCubeSourceURLMap | string[]): Promise<TextureSourceCubeData>;
    loadCompressedTextureFromArrayBuffer(arrayBuffer: ArrayBuffer, options?: TextureOptions): TextureOptions;
    reloadTextureAsync(texture: Texture): Promise<Texture>;
}
export declare function getDefaultTextureFactory(): TextureFactory;
export declare function setDefaultTextureFactory(factory: TextureFactory): void;
