import type { MarsRenderer } from '../render/MarsRenderer';
import type { GLTexture } from '../webgl/GLTexture';
export interface TextureStatistic {
    name: string;
    memory: number;
}
export interface BufferStatistic {
    name: string;
    memory: number;
}
export interface RendererStatistic {
    textures: TextureStatistic[];
    buffers: BufferStatistic[];
    memory: {
        texture: number;
        buffer: number;
    };
}
export declare function getRendererStatistic(renderer: MarsRenderer): RendererStatistic;
export declare function getTextureMemory(tex: GLTexture | undefined): number;
