import type { GPUBuffer, GPUBufferOptions, GPUBufferTarget } from '../../types/GPUBuffer';
import type { GLGPURenderer } from './GLGPURenderer';
import type { TypedArray } from '../../types/type';
import type { MarsRenderer } from '../render/MarsRenderer';
export declare class GLGPUBuffer implements GPUBuffer {
    readonly usage: WebGLRenderingContext['STATIC_DRAW'] | WebGLRenderingContext['DYNAMIC_DRAW'] | WebGLRenderingContext['STREAM_DRAW'];
    readonly renderer?: GLGPURenderer;
    readonly glBuffer: WebGLBuffer | null;
    readonly target: GPUBufferTarget;
    private _byteLength;
    private _isDestroyed;
    readonly name: string;
    get byteLength(): number;
    get isBuffer(): boolean;
    get level(): number;
    get isDestroyed(): boolean;
    constructor(options: GPUBufferOptions, renderer: GLGPURenderer);
    bind(): void;
    bufferData(typedArray: TypedArray | number): void;
    bufferSubData(elementOffset: number, typedArray: TypedArray): void;
    destroy(): void;
    readSubData(elementOffset: number, typedArray: TypedArray): boolean;
    getElementCount(bytePerElement: number): number;
    assignRenderer(renderer: MarsRenderer): GLGPUBuffer;
}
