import type { GPUCapability, GPUCapabilityDetail } from '../../types/GPUCapability';
import type { Immutable } from '../../types/type';
interface GLGPUCapabilityDetail extends GPUCapabilityDetail {
    vao: boolean;
    standardDerivatives: boolean;
    halfFloatLinear: boolean;
    floatLinear: boolean;
    maxShaderTexCount: number;
    instanceDraw: boolean;
}
export declare class GLGPUCapability implements GPUCapability {
    readonly capability: Immutable<GLGPUCapabilityDetail>;
    readonly level: number;
    readonly type: 'webgl' | 'webgl2' | 'node-gl' | 'none';
    drawBufferExtension: any;
    vaoExt: any;
    UNSIGNED_INT_24_8: number;
    internalFormatDepth16: number;
    internalFormatDepth24_stencil8: number;
    instanceDrawExt?: ANGLE_instanced_arrays;
    constructor(opt: {
        glType?: 'webgl' | 'webgl2';
        gl?: WebGLRenderingContext | WebGL2RenderingContext;
    });
    _setupCapability(gl?: WebGLRenderingContext | WebGL2RenderingContext): void;
    checkLinearTextureFilter(gl: WebGL2RenderingContext, type: number): boolean;
    framebufferTexture2D(gl: WebGLRenderingContext | WebGL2RenderingContext, target: GLenum, index: number, textarget: number, texture: WebGLTexture): void;
    vertexAttribDivisor(gl: WebGLRenderingContext | WebGL2RenderingContext, loc: number, divisor: number): void;
    drawElementsInstanced(gl: WebGLRenderingContext | WebGL2RenderingContext, mode: GLenum, count: GLsizei, type: GLenum, offset: GLintptr, instanceCount: GLsizei): void;
    drawArraysInstanced(gl: WebGLRenderingContext | WebGL2RenderingContext, mode: GLenum, first: GLint, count: GLsizei, instanceCount: GLsizei): void;
    drawBuffers(gl: WebGLRenderingContext | WebGL2RenderingContext, bufferStates: boolean[]): void;
    setTextureAnisotropic(gl: WebGLRenderingContext | WebGL2RenderingContext, target: GLenum, level: number): void;
    setup(gl: WebGLRenderingContext): void;
}
export declare function registerCompressedTexture(gl: WebGLRenderingContext | WebGL2RenderingContext): number;
export {};
