import type { MaterialRenderStates } from '../../types/Material';
import type { GLGPURenderer } from './GLGPURenderer';
import type { MarsMaterial } from '../render/MarsMaterial';
import type { Immutable } from '../../types/type';
import type { GLProgram } from './GLProgram';
export declare class GLMaterial {
    readonly renderer: GLGPURenderer;
    readonly shaderCacheId: string;
    readonly states: Immutable<MaterialRenderStates>;
    readonly material: MarsMaterial;
    constructor(renderer: GLGPURenderer, material: MarsMaterial);
    setupStates(): void;
    getProgram(): GLProgram | null;
    destroy(): void;
}
