import type { RenderPassStorageObject, RenderPassAttachmentStorageType } from '../../types/RenderPass';
import type { GLGPURenderer } from './GLGPURenderer';
interface GLRenderBufferOptions {
    storageType: RenderPassAttachmentStorageType;
    format: GLenum;
    attachment: GLenum;
    multisample?: number;
}
export declare class GLRenderBuffer implements RenderPassStorageObject {
    readonly renderer: GLGPURenderer;
    readonly storageType: RenderPassAttachmentStorageType;
    readonly internalFormat: GLenum;
    readonly glHandle: WebGLRenderbuffer;
    readonly size: [x: number, y: number];
    readonly ready: boolean;
    readonly format: GLenum;
    readonly attachment: GLenum;
    readonly multiSample: number;
    constructor(renderer: GLGPURenderer, options: GLRenderBufferOptions);
    setSize(width: number, height: number): GLRenderBuffer;
    destroy(): void;
}
export {};
