import type { Immutable } from './type';
export declare const COMPRESSED_TEXTURE_NONE = 0;
export declare const COMPRESSED_TEXTURE_PVRTC = 1;
export declare const COMPRESSED_TEXTURE_ASTC = 2;
export interface GPUCapabilityDetail {
    maxSample: number;
    floatTexture: number;
    halfFloatTexture: number;
    floatColorAttachment?: boolean;
    halfFloatColorAttachment?: boolean;
    maxVertexUniforms: number;
    maxVertexTextures: number;
    maxFragmentUniforms: number;
    maxFragmentTextures: number;
    maxShaderTexCount: number;
    maxTextureSize: number;
    maxTextureAnisotropy: number;
    compressedTexture: number;
    shaderTextureLod: boolean;
    instanceDraw?: boolean;
    drawBuffers?: boolean;
    asyncShaderCompile?: boolean;
    intIndexElementBuffer?: boolean;
    readableDepthStencilTextures?: boolean;
    writableFragDepth?: boolean;
}
export type GPUFramework = 'webgl' | 'webgl2' | 'opengles3' | 'opengles2' | 'node-gl' | 'metal' | 'none';
export interface GPUCapability {
    type: GPUFramework;
    level: number;
    capability: Immutable<GPUCapabilityDetail>;
    setup(gl: WebGLRenderingContext): void;
}
export declare class GPUCapabilityEmpty implements GPUCapability {
    type: GPUFramework;
    level: number;
    capability: {
        maxSample: number;
        floatTexture: number;
        halfFloatTexture: number;
        maxVertexUniforms: number;
        maxVertexTextures: number;
        maxFragmentUniforms: number;
        maxFragmentTextures: number;
        maxTextureSize: number;
        maxShaderTexCount: number;
        maxTextureAnisotropy: number;
        compressedTexture: number;
        shaderTextureLod: boolean;
    };
    constructor();
    setup(gl: WebGLRenderingContext): void;
}
