export interface IGPURenderer {
    readonly width: number;
    readonly height: number;
}
export interface IGPUResource {
    /**
     * 大部分的JS数据对象创建不依赖于GPU接口，数据被存储在JS对象中，
     * 当接收到GPU接口时，创建对应的GPU对象
     */
    readonly renderer?: IGPURenderer;
    readonly isDestroyed: boolean;
    assignRenderer(renderer: IGPURenderer): IGPUResource;
    destroy(): void;
}
