import type { ImageBitmapPixelFormat } from '../Texture';
export interface ImageBitmapConstructor {
    premultiplyAlpha?: boolean;
}
export declare abstract class ImageBitmapInternal {
    /**
       * 释放内存，释放后不可再用,
       * 释放后 width,height,byteLength都为0
       */
    abstract close(): void;
    /**
       * 将内存拷贝到指定的Uint8Array中
       * @param target
       */
    abstract copyTo(target: Uint8Array): void;
    abstract readonly width: number;
    abstract readonly height: number;
    abstract readonly byteLength: number;
    abstract readonly format: ImageBitmapPixelFormat;
}
export type ImageBitmapCallback = (error: Error | undefined, image: ImageBitmapInternal) => void;
