import type { ResourceInternal } from './ResourceInternal';
import type { GeometryInternal } from './GeometryInternal';
import type { MaterialInternal } from './MaterialInternal';
export interface MeshInternalOptions {
    name: string;
    geometries: GeometryInternal[];
    material: MaterialInternal;
    priority?: number;
    hide?: boolean;
}
export declare abstract class MeshInternal implements ResourceInternal {
    readonly isDestroyed: boolean;
    readonly name: string;
    geometries: GeometryInternal[];
    material: MaterialInternal;
    priority: number;
    hide: boolean;
    protected constructor(options: MeshInternalOptions);
    abstract destroy(): void;
}
