export type Immutable<O> = O extends Record<any, any> ? {
    readonly [key in keyof O]: Immutable<O[key]>;
} : O extends Array<infer X> ? ReadonlyArray<X> : O;
export type vec4 = [x: number, y: number, z: number, w: number];
export type vec3 = [x: number, y: number, z: number];
export type vec2 = [x: number, y: number];
export type mat2 = [m11: number, m12: number, m21: number, m22: number];
export type mat3 = [
    m11: number,
    m12: number,
    m13: number,
    m21: number,
    m22: number,
    m23: number,
    m31: number,
    m32: number,
    m33: number
];
export type mat4 = [
    m11: number,
    m12: number,
    m13: number,
    m14: number,
    m21: number,
    m22: number,
    m23: number,
    m24: number,
    m31: number,
    m32: number,
    m33: number,
    m34: number,
    m41: number,
    m42: number,
    m43: number,
    m44: number
];
export type TypedArray = Float32Array | Float64Array | Uint8Array | Uint32Array | Uint16Array | Int8Array | Int16Array | Int32Array;
