import type {
  TextureFactory, Texture, TextureConfigOptions, TextureOptions, TextureFactorySourceFrom,
} from './Texture';
import type { GPUCapability } from './GPUCapability';
import type { TypedArray } from './type';
export * from './native/index';
export * from './constants';
export * from './GPUCapability';
export * from './Renderer';
export * from './RenderFrame';
export * from './Texture';
export * from './Material';
export * from './GPUBuffer';
export * from './RenderPass';
export * from './Mesh';
export * from './Geometry';
export * from './ShaderLibrary';
export { GPURenderer as Renderer } from './Renderer';
export * from './type';

export declare function getDefaultTextureFactory (): TextureFactory;

export declare function setDefaultTextureFactory (factory: TextureFactory): void;

export declare function getDefaultGPUCapability (): GPUCapability;

export declare class MarsTextureFactory implements TextureFactory {
  canOffloadTexture (texture: Texture): boolean;

  loadSourceAsync (options: TextureFactorySourceFrom, config?: TextureConfigOptions): Promise<TextureOptions>;

  reloadTextureAsync (texture: Texture): Promise<Texture>;

  loadCompressedTextureFromArrayBuffer (arrayBuffer: ArrayBuffer, options?: TextureOptions): TextureOptions;

  loadImageBinaryAsync (binary: ArrayBuffer | TypedArray | Blob, mime?: string): Promise<HTMLImageElement | ImageBitmap>;
}
