import type { RenderPassAttachmentStorageType } from '../RenderPass';

type MetalRenderPassColorFormat = WebGL2RenderingContext['RGBA8'] |
WebGL2RenderingContext['RGBA16F'] |
WebGL2RenderingContext['RGBA32F'] |
WebGL2RenderingContext['R16F'] |
WebGL2RenderingContext['R32F'];
interface MetalRenderPassAttachmentFormat {
  colors: MetalRenderPassColorFormat[],
  depth: RenderPassAttachmentStorageType,
  stencil: RenderPassAttachmentStorageType,
  id?: string,
}
export interface MetalInternal {
  //通过RenderPass(RP) attachment具体数据算出id，并且返回
  //添加后，此attachment会在shader编译阶段提前创建出pipeline
  //对于添加到RP的Mesh，寻找此RP对应的pipeline，如果没有则创建
  //RP销毁时，不会销毁对应的pipeline，需要调用shaderLib删除shader的时候才会销毁
  //renderer启动时，会自动创建一个RPFormat，数据源于直接绘制到view的RP
  addRenderPassAttachmentFormat(format: MetalRenderPassAttachmentFormat): string,

}
