import type { ShaderLibrary, Shader, ShaderCompileResult } from '../ShaderLibrary';

export abstract class ShaderLibraryInternal implements ShaderLibrary {

  abstract readonly cacheIds: string[];

  abstract getShaderResult (cacheId: string): ShaderCompileResult;

  abstract addShader (shader: Shader): string;

  abstract compileAllShaders (asyncCallback?: (results: ShaderCompileResult[]) => void): void;

  abstract compileShader (shaderCacheId: string, asyncCallback?: (result: ShaderCompileResult) => void): ShaderCompileResult;

  abstract deleteShader (cacheId: string): void ;

  abstract destroy (): void;

}
