/*!
 * Name: @predy-js/render-interface
 * Description: undefined
 * Author: undefined
 * Version: v0.3.3
 */

'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol, Iterator */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

var prefix = '[Predy RI]';
function consoleLog(msg) {
    var data = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        data[_i - 1] = arguments[_i];
    }
    console.info.apply(console, __spreadArray([prefix + msg], data, false));
}
function consoleWarn(msg) {
    var data = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        data[_i - 1] = arguments[_i];
    }
    console.warn.apply(console, __spreadArray([prefix + msg], data, false));
}
function consoleError(msg) {
    var data = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        data[_i - 1] = arguments[_i];
    }
    console.error.apply(console, __spreadArray([prefix + msg], data, false));
}

exports.DestroyOptions = void 0;
(function (DestroyOptions) {
    DestroyOptions[DestroyOptions["destroy"] = 0] = "destroy";
    DestroyOptions[DestroyOptions["keep"] = 1] = "keep";
    DestroyOptions[DestroyOptions["force"] = 0] = "force";
})(exports.DestroyOptions || (exports.DestroyOptions = {}));
exports.PredyTextEncoding = void 0;
(function (PredyTextEncoding) {
    PredyTextEncoding[PredyTextEncoding["utf8"] = 0] = "utf8";
    PredyTextEncoding[PredyTextEncoding["ascii"] = 1] = "ascii";
})(exports.PredyTextEncoding || (exports.PredyTextEncoding = {}));
exports.PredyVideoCodec = void 0;
(function (PredyVideoCodec) {
    PredyVideoCodec["h264"] = "avc1";
    PredyVideoCodec["h265"] = "hev1";
    PredyVideoCodec["av1"] = "av1";
})(exports.PredyVideoCodec || (exports.PredyVideoCodec = {}));
exports.PredyResourceCacheStatus = void 0;
(function (PredyResourceCacheStatus) {
    PredyResourceCacheStatus[PredyResourceCacheStatus["noCache"] = 0] = "noCache";
    PredyResourceCacheStatus[PredyResourceCacheStatus["cached"] = 1] = "cached";
    PredyResourceCacheStatus[PredyResourceCacheStatus["preloaded"] = 2] = "preloaded";
    PredyResourceCacheStatus[PredyResourceCacheStatus["hitCDN"] = 3] = "hitCDN";
    PredyResourceCacheStatus[PredyResourceCacheStatus["missCDN"] = 4] = "missCDN";
})(exports.PredyResourceCacheStatus || (exports.PredyResourceCacheStatus = {}));

exports.RenderPassDestroyAttachmentType = void 0;
(function (RenderPassDestroyAttachmentType) {
    RenderPassDestroyAttachmentType[RenderPassDestroyAttachmentType["force"] = 0] = "force";
    RenderPassDestroyAttachmentType[RenderPassDestroyAttachmentType["keep"] = 1] = "keep";
    RenderPassDestroyAttachmentType[RenderPassDestroyAttachmentType["keepExternal"] = 2] = "keepExternal";
    RenderPassDestroyAttachmentType[RenderPassDestroyAttachmentType["destroy"] = 0] = "destroy";
})(exports.RenderPassDestroyAttachmentType || (exports.RenderPassDestroyAttachmentType = {}));
var RenderPassPriorityPrepare = 0;
var RenderPassPriorityNormal = 1000;
var RenderPassPriorityPostprocess = 3000;
exports.TextureLoadAction = void 0;
(function (TextureLoadAction) {
    TextureLoadAction[TextureLoadAction["whatever"] = 0] = "whatever";
    //preserve previous attachment
    TextureLoadAction[TextureLoadAction["load"] = 1] = "load";
    //clear attachment
    TextureLoadAction[TextureLoadAction["clear"] = 2] = "clear";
})(exports.TextureLoadAction || (exports.TextureLoadAction = {}));
exports.TextureStoreAction = void 0;
(function (TextureStoreAction) {
    TextureStoreAction[TextureStoreAction["store"] = 1] = "store";
    TextureStoreAction[TextureStoreAction["clear"] = 0] = "clear";
})(exports.TextureStoreAction || (exports.TextureStoreAction = {}));
exports.RenderPassAttachmentStorageType = void 0;
(function (RenderPassAttachmentStorageType) {
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["none"] = 0] = "none";
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["color"] = 1] = "color";
    //stencil 8 render buffer
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["stencil_8_opaque"] = 2] = "stencil_8_opaque";
    //stencil 16 render buffer
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["depth_16_opaque"] = 3] = "depth_16_opaque";
    //depth 16 & stencil 8 render buffer
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["depth_stencil_opaque"] = 4] = "depth_stencil_opaque";
    //depth 16 texture, need gpu.capability.readableDepthStencilTextures
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["depth_16_texture"] = 5] = "depth_16_texture";
    //depth 24 texture, need gpu.capability.readableDepthStencilTextures
    RenderPassAttachmentStorageType[RenderPassAttachmentStorageType["depth_24_stencil_8_texture"] = 6] = "depth_24_stencil_8_texture";
})(exports.RenderPassAttachmentStorageType || (exports.RenderPassAttachmentStorageType = {}));
exports.RenderPassMeshOrder = void 0;
(function (RenderPassMeshOrder) {
    RenderPassMeshOrder[RenderPassMeshOrder["none"] = 1] = "none";
    RenderPassMeshOrder[RenderPassMeshOrder["ascending"] = 2] = "ascending";
    RenderPassMeshOrder[RenderPassMeshOrder["descending"] = 3] = "descending";
})(exports.RenderPassMeshOrder || (exports.RenderPassMeshOrder = {}));

exports.TextureSourceType = void 0;
(function (TextureSourceType) {
    TextureSourceType[TextureSourceType["none"] = 0] = "none";
    TextureSourceType[TextureSourceType["data"] = 1] = "data";
    TextureSourceType[TextureSourceType["image"] = 2] = "image";
    TextureSourceType[TextureSourceType["compressed"] = 3] = "compressed";
    TextureSourceType[TextureSourceType["video"] = 4] = "video";
    TextureSourceType[TextureSourceType["canvas"] = 5] = "canvas";
    TextureSourceType[TextureSourceType["framebuffer"] = 6] = "framebuffer";
    TextureSourceType[TextureSourceType["mipmaps"] = 7] = "mipmaps";
})(exports.TextureSourceType || (exports.TextureSourceType = {}));

var GPUBufferOptionsMemoryShared = 1 << 1;

var _a$6, _b$3;
// @ts-expect-error safe to assign
var constants = {};
if (typeof WebGL2RenderingContext === 'function') {
    copy(WebGL2RenderingContext);
}
else if (typeof WebGLRenderingContext !== 'undefined') {
    copy(WebGLRenderingContext);
    copy(WebGLRenderingContext.prototype);
}
else {
    //ios 16 lockdown mode
    consoleError('WebGL not in global');
}
Object.assign(constants, {
    HALF_FLOAT: 5131,
    COMPRESSED_RGBA_ASTC_4x4_KHR: 0x93B0,
    COMPRESSED_RGBA_ASTC_5x4_KHR: 0x93B1,
    COMPRESSED_RGBA_ASTC_5x5_KHR: 0x93B2,
    COMPRESSED_RGBA_ASTC_6x5_KHR: 0x93B3,
    COMPRESSED_RGBA_ASTC_6x6_KHR: 0x93B4,
    COMPRESSED_RGBA_ASTC_8x5_KHR: 0x93B5,
    COMPRESSED_RGBA_ASTC_8x6_KHR: 0x93B6,
    COMPRESSED_RGBA_ASTC_8x8_KHR: 0x93B7,
    COMPRESSED_RGBA_ASTC_10x5_KHR: 0x93B8,
    COMPRESSED_RGBA_ASTC_10x6_KHR: 0x93B9,
    COMPRESSED_RGBA_ASTC_10x8_KHR: 0x93BA,
    COMPRESSED_RGBA_ASTC_10x10_KHR: 0x93BB,
    COMPRESSED_RGBA_ASTC_12x10_KHR: 0x93BC,
    COMPRESSED_RGBA_ASTC_12x12_KHR: 0x93BD,
    COMPRESSED_SRGB8_ALPHA8_ASTC_4x4_KHR: 0x93D0,
    COMPRESSED_SRGB8_ALPHA8_ASTC_5x4_KHR: 0x93D1,
    COMPRESSED_SRGB8_ALPHA8_ASTC_5x5_KHR: 0x93D2,
    COMPRESSED_SRGB8_ALPHA8_ASTC_6x5_KHR: 0x93D3,
    COMPRESSED_SRGB8_ALPHA8_ASTC_6x6_KHR: 0x93D4,
    COMPRESSED_SRGB8_ALPHA8_ASTC_8x5_KHR: 0x93D5,
    COMPRESSED_SRGB8_ALPHA8_ASTC_8x6_KHR: 0x93D6,
    COMPRESSED_SRGB8_ALPHA8_ASTC_8x8_KHR: 0x93D7,
    COMPRESSED_SRGB8_ALPHA8_ASTC_10x5_KHR: 0x93D8,
    COMPRESSED_SRGB8_ALPHA8_ASTC_10x6_KHR: 0x93D9,
    COMPRESSED_SRGB8_ALPHA8_ASTC_10x8_KHR: 0x93DA,
    COMPRESSED_SRGB8_ALPHA8_ASTC_10x10_KHR: 0x93DB,
    COMPRESSED_SRGB8_ALPHA8_ASTC_12x10_KHR: 0x93DC,
    COMPRESSED_SRGB8_ALPHA8_ASTC_12x12_KHR: 0x93DD,
});
function copy(target) {
    for (var name_1 in target) {
        if (/^[A-Z_]/.test(name_1)) {
            // @ts-expect-error safe to assign
            constants[name_1] = target[name_1];
        }
    }
}
var map = (_a$6 = {},
    _a$6[constants.INT] = Int32Array,
    _a$6[constants.FLOAT] = Float32Array,
    _a$6[constants.SHORT] = Int16Array,
    _a$6[constants.BYTE] = Int8Array,
    _a$6[constants.UNSIGNED_BYTE] = Uint8Array,
    _a$6[constants.UNSIGNED_INT] = Uint32Array,
    _a$6[constants.UNSIGNED_SHORT] = Uint16Array,
    _a$6);
function getBytesPerElementByGLType(type) {
    var _a;
    return ((_a = map[type]) === null || _a === void 0 ? void 0 : _a.BYTES_PER_ELEMENT) || 0;
}
var MatAttrLocPairMap = (_b$3 = {},
    _b$3[constants.FLOAT_MAT2] = [2, 2],
    _b$3[constants.FLOAT_MAT3] = [3, 3],
    _b$3[constants.FLOAT_MAT4] = [4, 4],
    _b$3);
function getMatAttrLocPair(type) {
    return MatAttrLocPairMap[type] || [1, 1];
}

exports.ShaderCompileResultStatus = void 0;
(function (ShaderCompileResultStatus) {
    ShaderCompileResultStatus[ShaderCompileResultStatus["noShader"] = 0] = "noShader";
    ShaderCompileResultStatus[ShaderCompileResultStatus["success"] = 1] = "success";
    ShaderCompileResultStatus[ShaderCompileResultStatus["fail"] = 2] = "fail";
    ShaderCompileResultStatus[ShaderCompileResultStatus["compiling"] = 3] = "compiling";
})(exports.ShaderCompileResultStatus || (exports.ShaderCompileResultStatus = {}));
var ShaderLibraryEmpty = /** @class */ (function () {
    function ShaderLibraryEmpty() {
    }
    Object.defineProperty(ShaderLibraryEmpty.prototype, "cacheIds", {
        get: function () {
            return [];
        },
        enumerable: false,
        configurable: true
    });
    ShaderLibraryEmpty.prototype.getShaderResult = function (cacheId) {
        return undefined;
    };
    ShaderLibraryEmpty.prototype.addShader = function (shader, marcos) {
        return '';
    };
    ShaderLibraryEmpty.prototype.compileAllShaders = function (asyncCallback) {
        return [];
    };
    ShaderLibraryEmpty.prototype.deleteShader = function (cacheId) {
    };
    ShaderLibraryEmpty.prototype.compileShader = function (shaderCacheId) {
        return { status: exports.ShaderCompileResultStatus.fail };
    };
    ShaderLibraryEmpty.prototype.destroy = function () {
    };
    return ShaderLibraryEmpty;
}());

function isFunc(val) {
    return typeof val === 'function';
}
function isObj(a) {
    return (typeof a === 'object') && a;
}
function isStr(a, withLength) {
    var str = typeof a === 'string';
    if (withLength) {
        return str && a.length > 0;
    }
    return str;
}
function arrRemove(arr, ele) {
    var idx = arr.indexOf(ele);
    if (idx > -1) {
        arr.splice(idx, 1);
        return true;
    }
    return false;
}
function arrAdd(arr, item) {
    if (!arr.includes(item)) {
        arr.push(item);
        return true;
    }
    return false;
}
function strHashCode() {
    var strings = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        strings[_i] = arguments[_i];
    }
    var h = 0;
    for (var j = 0; j < arguments.length; j++) {
        var s = strings[j];
        for (var i = 0; i < s.length; i++) {
            h = Math.imul(31, h) + s.charCodeAt(i) | 0;
        }
    }
    return h;
}
function arrAddByOrder(arr, item, order) {
    var itemOrder = order || exports.RenderPassMeshOrder.ascending;
    if (arr.includes(item)) {
        return true;
    }
    arr.push(item);
    if (arr.length === 1) {
        return true;
    }
    if (itemOrder !== exports.RenderPassMeshOrder.none) {
        //单次插入排序
        var index = arr.length - 1;
        if (index) {
            var currentItem = arr[index];
            if (itemOrder !== exports.RenderPassMeshOrder.ascending) {
                while (arr[index - 1].priority < currentItem.priority) {
                    arr[index] = arr[index - 1];
                    index--;
                    if (index === 0) {
                        break;
                    }
                }
            }
            else {
                while (arr[index - 1].priority > currentItem.priority) {
                    arr[index] = arr[index - 1];
                    index--;
                    if (index === 0) {
                        break;
                    }
                }
            }
            arr[index] = currentItem;
        }
    }
    return false;
}
function fastSort(arr, order, start, end) {
    var _a, _b;
    if (start === void 0) { start = 0; }
    if (end === void 0) { end = arr.length - 1; }
    // 终止条件
    if (start >= end) {
        return arr;
    }
    var left = start, right = end;
    var base = arr[start];
    while (left < right) {
        if (order === exports.RenderPassMeshOrder.ascending) {
            // 从右向左，寻找第一个小于base的值
            while (arr[right].priority > base.priority && right >= left) {
                right--;
            }
            // 从左向右，寻找第一个大于base的值
            while (arr[left].priority <= base.priority && left < right) {
                left++;
            }
        }
        else {
            // 从右向左，寻找第一个大于base的值
            while (arr[right].priority < base.priority && right >= left) {
                right--;
            }
            // 从左向右，寻找第一个小于base的值
            while (arr[left].priority >= base.priority && left < right) {
                left++;
            }
        }
        // 将两个值交换位置
        _a = [arr[right], arr[left]], arr[left] = _a[0], arr[right] = _a[1];
    }
    // 将最后两个游标相遇的位置的值与base值交换
    _b = [arr[left], arr[start]], arr[start] = _b[0], arr[left] = _b[1];
    fastSort(arr, order, start, left - 1);
    fastSort(arr, order, right + 1, end);
    return arr;
}
function sortByOrder(arr, order) {
    var itemOrder = order || exports.RenderPassMeshOrder.ascending;
    if (arr.length === 0 || arr.length === 1) {
        return arr;
    }
    if (itemOrder === exports.RenderPassMeshOrder.none) {
        return arr;
    }
    else {
        //30个以下的数据用插入排序
        if (arr.length <= 30) {
            var length_1 = arr.length;
            for (var i = 1; i < length_1; i++) {
                var currentItem = arr[i];
                var index = i;
                if (itemOrder !== exports.RenderPassMeshOrder.ascending) {
                    while (index >= 1 && arr[index - 1].priority < currentItem.priority) {
                        arr[index] = arr[index - 1];
                        index--;
                        if (index === 0) {
                            break;
                        }
                    }
                }
                else {
                    while (index >= 1 && arr[index - 1].priority > currentItem.priority) {
                        arr[index] = arr[index - 1];
                        index--;
                        if (index === 0) {
                            break;
                        }
                    }
                }
                arr[index] = currentItem;
            }
            return arr;
        }
        else {
            return fastSort(arr, itemOrder);
        }
    }
}
var hasOwnProperty = Object.prototype.hasOwnProperty;
function forEach(object, callback, thisObj) {
    if (isObj(object)) {
        if (thisObj === undefined) {
            thisObj = object;
        }
        for (var name_1 in object) {
            if (hasOwnProperty.call(object, name_1)) {
                callback.call(thisObj, object[name_1], name_1);
            }
        }
    }
    return object;
}
function throwDestroyedError() {
    throw Error('destroyed item cannot be used again');
}

var RenderFrameInternal = /** @class */ (function () {
    function RenderFrameInternal() {
    }
    RenderFrameInternal.render = function (frame) {
        var passes = frame._renderPasses;
        var renderer = frame.renderer;
        if (renderer.isDestroyed) {
            return consoleError('renderer is destroyed', renderer);
        }
        frame.renderer.shaderLibrary.compileAllShaders();
        clear(renderer.internal, frame.loadAction);
        //@ts-expect-error safe to assign
        var renderState = {
            currentFrame: frame,
        };
        for (var i = 0; i < passes.length; i++) {
            var pass = passes[i];
            var delegate = pass.delegate;
            if (pass.isDestroyed) {
                consoleError("render pass ".concat(pass.name, " destroyed"), pass);
            }
            else {
                delegate.willBeginRenderPass && (delegate === null || delegate === void 0 ? void 0 : delegate.willBeginRenderPass(pass, renderState));
                this.renderRenderPass(renderer, pass, renderState);
                delegate.didEndRenderPass && (delegate === null || delegate === void 0 ? void 0 : delegate.didEndRenderPass(pass, renderState));
            }
        }
    };
    RenderFrameInternal.renderRenderPass = function (renderer, pass, renderState) {
        renderState.currentPass = pass;
        setupRenderPass(renderer, pass);
        renderMeshes(renderer, renderState);
        endRenderPass(renderer, pass);
    };
    return RenderFrameInternal;
}());
function endRenderPass(renderer, renderPass) {
    if (renderPass.storeAction) {
        clear(renderer.internal, renderPass.storeAction);
    }
    renderPass.unbind();
}
function renderMeshes(renderer, state) {
    //assume meshes has been sorted
    var sortedMeshes = state.currentPass.meshes;
    var delegate = state.currentPass.delegate;
    for (var i = 0; i < sortedMeshes.length; i++) {
        var mesh = sortedMeshes[i];
        if (mesh.isDestroyed) {
            consoleError("mesh ".concat(mesh.name, " destroyed"), mesh);
        }
        else if (!mesh.hide) {
            delegate.willRenderMesh && delegate.willRenderMesh(mesh, state);
            renderMesh(renderer, mesh, state);
            delegate.didRenderMesh && delegate.didRenderMesh(mesh, state);
        }
    }
    for (var i = 0; i < sortedMeshes.length; i++) {
        var mtl = sortedMeshes[i].material;
        if (mtl) {
            mtl.dataBlocks.forEach(function (d) { return d.clearFlags(); });
        }
    }
}
function setupRenderPass(renderer, renderPass) {
    renderPass.assignRenderer(renderer);
    loadRenderPassAttachments(renderer.internal, renderPass);
}
function renderMesh(renderer, mesh, state) {
    state.currentMesh = mesh;
    mesh.material.assignRenderer(renderer);
    var material = (mesh.material).materialInternal;
    if (material) {
        var program_1 = material.getProgram();
        if (program_1) {
            material.setupStates();
            program_1.setupUniforms(state);
            mesh.geometries.forEach(function (geometry) {
                geometry.assignRenderer(renderer);
                geometry.flush();
                var vao = program_1.setupAttributes(geometry.internal);
                geometry.internal.draw(state);
                if (vao) {
                    vao.unbind();
                }
            });
        }
    }
}
function loadRenderPassAttachments(renderer, renderPass) {
    renderPass.bind();
    if (renderPass.loadAction) {
        clear(renderer, renderPass.loadAction);
    }
}
function clear(renderer, action) {
    var state = renderer.state;
    var bit = 0;
    if (action.colorAction === exports.TextureLoadAction.clear) {
        var clearColor = action.clearColor;
        if (clearColor) {
            state.clearColor(clearColor[0], clearColor[1], clearColor[2], clearColor[3]);
        }
        state.colorMask(true, true, true, true);
        bit = constants.COLOR_BUFFER_BIT;
    }
    if (action.stencilAction === exports.TextureLoadAction.clear) {
        state.stencilMask(0xff);
        state.clearStencil(action.clearStencil || 0);
        bit = bit | constants.STENCIL_BUFFER_BIT;
    }
    if (action.depthAction === exports.TextureLoadAction.clear) {
        var depth = action.clearDepth;
        state.depthMask(true);
        state.clearDepth(Number.isFinite(depth) ? depth : 1);
        bit = bit | constants.DEPTH_BUFFER_BIT;
    }
    if (bit) {
        state.clear(bit);
    }
}

var MarsSemanticMap = /** @class */ (function () {
    function MarsSemanticMap(semantics) {
        this.semantics = Object.assign({}, semantics || {});
    }
    MarsSemanticMap.prototype.toObject = function () {
        return Object.assign({}, this.semantics);
    };
    MarsSemanticMap.prototype.setSemantic = function (name, value) {
        if (value === undefined) {
            delete this.semantics[name];
        }
        else {
            this.semantics[name] = value;
        }
    };
    MarsSemanticMap.prototype.getSemanticValue = function (name, state) {
        var ret = this.semantics[name];
        if (isFunc(ret)) {
            return ret(state);
        }
        return ret;
    };
    MarsSemanticMap.prototype.hasSemanticValue = function (name) {
        return name in this.semantics;
    };
    MarsSemanticMap.prototype.destroy = function () {
        var c = this.semantics;
        forEach(c, function (va, name) {
            if (va && isFunc(va.destroy)) {
                va.destroy();
            }
            delete c[name];
        });
    };
    return MarsSemanticMap;
}());

var renderFrameSeed = 1;
var MarsRenderFrame = /** @class */ (function () {
    function MarsRenderFrame(options, renderer) {
        this._isDestroyed = false;
        this.setRenderPasses(options.renderPasses || []);
        this.semantics = new MarsSemanticMap(options.semantics);
        this.loadAction = options.loadAction || {};
        this.name = options.name || ('RenderFrame' + renderFrameSeed++);
        if (renderer) {
            this.assignRenderer(renderer);
        }
    }
    Object.defineProperty(MarsRenderFrame.prototype, "renderPasses", {
        get: function () {
            return this._renderPasses.slice();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderFrame.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderFrame.prototype, "renderer", {
        get: function () {
            return this._renderer;
        },
        enumerable: false,
        configurable: true
    });
    MarsRenderFrame.prototype.assignRenderer = function (renderer) {
        if (!this._renderer) {
            this._renderer = renderer;
        }
        return this;
    };
    MarsRenderFrame.prototype.destroy = function (options) {
        if ((options === null || options === void 0 ? void 0 : options.semantics) !== exports.DestroyOptions.keep) {
            this.semantics.destroy();
        }
        var pass = (options === null || options === void 0 ? void 0 : options.passes) ? options.passes : undefined;
        if (pass !== exports.DestroyOptions.keep) {
            this._renderPasses.forEach(function (renderPass) {
                renderPass.destroy(pass);
            });
        }
        this._renderPasses.length = 0;
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    MarsRenderFrame.prototype.render = function () {
        RenderFrameInternal.render(this);
    };
    MarsRenderFrame.prototype.setRenderPasses = function (passes) {
        this._renderPasses = sortByOrder(passes.slice());
    };
    MarsRenderFrame.prototype.addRenderPass = function (pass) {
        arrAddByOrder(this._renderPasses, pass);
    };
    MarsRenderFrame.prototype.removeRenderPass = function (pass) {
        arrRemove(this._renderPasses, pass);
    };
    MarsRenderFrame.prototype.forEachRenderPass = function (callback) {
        var passes = this._renderPasses;
        for (var i = 0; i < passes.length; i++) {
            callback.call(passes, passes[i], i, this);
        }
    };
    return MarsRenderFrame;
}());

var COMPRESSED_TEXTURE_PVRTC = 1;
var COMPRESSED_TEXTURE_ASTC = 2;
var GPUCapabilityEmpty = /** @class */ (function () {
    function GPUCapabilityEmpty() {
        this.level = 0;
        this.capability = {
            maxSample: 0,
            floatTexture: 0,
            halfFloatTexture: 0,
            maxVertexUniforms: 0,
            maxVertexTextures: 0,
            maxFragmentUniforms: 0,
            maxFragmentTextures: 0,
            maxTextureSize: 0,
            maxShaderTexCount: 0,
            maxTextureAnisotropy: 0,
            compressedTexture: 0,
            shaderTextureLod: false,
        };
        this.type = 'none';
    }
    GPUCapabilityEmpty.prototype.setup = function (gl) {
    };
    return GPUCapabilityEmpty;
}());

var GLGPUBuffer = /** @class */ (function () {
    function GLGPUBuffer(options, renderer) {
        this._isDestroyed = false;
        this.renderer = renderer;
        this.glBuffer = renderer.createGLBuffer(this, options.name);
        this.usage = options.usage || constants.STATIC_DRAW;
        this._byteLength = 0;
        this.name = options.name || '';
        this.target = options.target || constants.ARRAY_BUFFER;
        if (options.data) {
            this.bufferData(options.data);
        }
        else if (options.byteLength) {
            this.bufferData(options.byteLength);
        }
    }
    Object.defineProperty(GLGPUBuffer.prototype, "byteLength", {
        get: function () {
            return this._byteLength;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLGPUBuffer.prototype, "isBuffer", {
        get: function () {
            return true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLGPUBuffer.prototype, "level", {
        get: function () {
            var _a;
            return ((_a = this.renderer) === null || _a === void 0 ? void 0 : _a.level) || 1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLGPUBuffer.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    GLGPUBuffer.prototype.bind = function () {
        var _a;
        var gl = (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gl;
        gl.bindBuffer(this.target, this.glBuffer);
    };
    GLGPUBuffer.prototype.bufferData = function (typedArray) {
        var byteLength = Number.isInteger(typedArray) ? typedArray : typedArray.byteLength;
        if (this.renderer) {
            this._byteLength = byteLength;
            var gl = this.renderer.gl;
            var target = this.target;
            gl.bindBuffer(target, this.glBuffer);
            if (byteLength === 0) {
                // ios 12 13 cause error when byteLength == 0
                gl.bufferData(target, 1, this.usage);
            }
            else {
                gl.bufferData(target, byteLength, this.usage);
                if (isObj(typedArray)) {
                    gl.bufferSubData(target, 0, typedArray);
                }
            }
            gl.bindBuffer(target, null);
        }
        else {
            this._byteLength = 0;
        }
    };
    GLGPUBuffer.prototype.bufferSubData = function (elementOffset, typedArray) {
        if (this.renderer) {
            var gl = this.renderer.gl;
            var target = this.target;
            var byteOffset = elementOffset * typedArray.BYTES_PER_ELEMENT;
            gl.bindBuffer(target, this.glBuffer);
            var byteLength = byteOffset + typedArray.byteLength;
            if (byteLength > this._byteLength) {
                this._byteLength = byteLength;
                gl.bufferData(target, byteLength, this.usage);
            }
            gl.bufferSubData(target, byteOffset, typedArray);
            gl.bindBuffer(target, null);
        }
        else {
            this._byteLength = 0;
        }
    };
    GLGPUBuffer.prototype.destroy = function () {
        var _a;
        (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.deleteGPUBuffer(this);
        // @ts-expect-error safe to assign
        this.glBuffer = this.renderer = null;
        this._isDestroyed = true;
    };
    GLGPUBuffer.prototype.readSubData = function (elementOffset, typedArray) {
        var _a;
        if (this.level === 2) {
            var gl = (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gl;
            var target = this.target;
            if (gl) {
                gl.bindBuffer(target, this.glBuffer);
                gl.getBufferSubData(target, elementOffset * typedArray.BYTES_PER_ELEMENT, typedArray);
                gl.bindBuffer(target, null);
                return true;
            }
        }
        return false;
    };
    GLGPUBuffer.prototype.getElementCount = function (bytePerElement) {
        return this._byteLength / bytePerElement;
    };
    GLGPUBuffer.prototype.assignRenderer = function (renderer) {
        if (!this.renderer) {
            // @ts-expect-error safe to assign
            this.renderer = renderer.internal;
        }
        return this;
    };
    return GLGPUBuffer;
}());

/**
 * webgl的状态切换
 */
var WebGLState = /** @class */ (function () {
    function WebGLState(gl) {
        this.noCache = false;
        this._gl = gl;
        this._maxTextureCount = gl.TEXTURE0 + gl.getParameter(gl.MAX_COMBINED_TEXTURE_IMAGE_UNITS) - 1;
        this._reset();
    }
    WebGLState.prototype.destroy = function () {
        //@ts-expect-error save to assign
        this.gl = null;
    };
    WebGLState.prototype._reset = function () {
        this._dict = {};
        this._activeTextureIndex = constants.TEXTURE0;
        this._textureUnitDict = {};
        this._currentFramebuffer = {};
        this._pixelStorei = {};
        this._currentRenderBuffer = {};
    };
    WebGLState.prototype.toggle = function (capability, enable) {
        if (enable) {
            this.enable(capability);
        }
        else {
            this.disable(capability);
        }
    };
    /**
     * 对于该上下文开启某种特性
     * @param capability
     * example:
     * gl.enable(gl.DITHER);
     */
    WebGLState.prototype.enable = function (capability) {
        var value = this._dict[capability];
        if (value !== true) {
            this._dict[capability] = true;
            this._gl.enable(capability);
        }
    };
    /**
     * 基于某种上下文关闭特性
     * @param capability
     * example:
     * gl.disable(gl.DITHER);
     */
    WebGLState.prototype.disable = function (capability) {
        var value = this._dict[capability];
        if (value !== false) {
            this._dict[capability] = false;
            this._gl.disable(capability);
        }
    };
    /**
     * 绑定framebuffer webgl2新增: gl.DRAW_FRAMEBUFFER 和 gl.READ_FRAMEBUFFER
     * @param target
     * @param framebuffer
     * example:
     * const framebuffer = gl.createFramebuffer();
     * gl.bindFramebuffer(gl.FRAMEBUFFER, framebuffer);
     */
    WebGLState.prototype.bindFramebuffer = function (target, framebuffer) {
        if (this._currentFramebuffer[target] !== framebuffer) {
            this._currentFramebuffer[target] = framebuffer;
            this._gl.bindFramebuffer(target, framebuffer);
        }
    };
    WebGLState.prototype.bindRenderBuffer = function (target, renderBuffer) {
        if (this._currentRenderBuffer[target] !== renderBuffer) {
            this._currentRenderBuffer[target] = renderBuffer;
            this._gl.bindRenderbuffer(target, renderBuffer);
        }
    };
    /**
     * 绑定系统framebuffer
     */
    WebGLState.prototype.bindSystemFramebuffer = function () {
        this.bindFramebuffer(this._gl.FRAMEBUFFER, null);
    };
    /**
     * 将定义好的WebGLProgram 对象添加到当前的渲染状态中。
     * @param program
     * example:
     * gl.useProgram(program);
     * gl.useProgram(null);
     */
    WebGLState.prototype.useProgram = function (program) {
        this._set1('useProgram', program);
    };
    /**
     * 使用预设值来清空缓冲
     * @param mask
     * example:
     * gl.clear(gl.DEPTH_BUFFER_BIT);
     * gl.clear(gl.DEPTH_BUFFER_BIT | gl.COLOR_BUFFER_BIT);
     */
    WebGLState.prototype.clear = function (mask) {
        this._gl.clear(mask);
    };
    //depth start
    /**
     * 设置深度缓冲区的深度清除值
     * @param depth
     * example:
     * gl.clearDepth(0.5);
     */
    WebGLState.prototype.clearDepth = function (depth) {
        this._set1('clearDepth', depth);
    };
    /**
     * 指定将输入像素深度与当前深度缓冲区值进行比较的函数。
     * @param func
     * example:
     * gl.enable(gl.DEPTH_TEST);
     * gl.depthFunc(gl.NEVER);
     */
    WebGLState.prototype.depthFunc = function (func) {
        this._set1('depthFunc', func);
    };
    /**
     * 设置是否启用写入深度缓冲。
     * @param flag
     * example:
     * gl.depthMask(false);
     */
    WebGLState.prototype.depthMask = function (flag) {
        this._set1('depthMask', flag);
    };
    WebGLState.prototype.polygonOffset = function (factor, unit) {
        this._set2('polygonOffset', factor, unit);
    };
    /**
     * 将 z 值从规范化设备坐标映射到窗口坐标
     * @param zNear
     * @param zFar
     * example:
     * gl.depthRange(0.2, 0.6);
     */
    WebGLState.prototype.depthRange = function (zNear, zFar) {
        this._set2('depthRange', zNear, zFar);
    };
    //depth end
    //stencil start
    /**
     * 模版测试设置函数和引用值。
     * @param func
     * @param ref
     * @param mask
     * example:
     * gl.enable(gl.STENCIL_TEST);
     * gl.stencilFunc(gl.LESS, 0, 0b1110011);
     */
    WebGLState.prototype.clearStencil = function (s) {
        this._set1('clearStencil', s);
    };
    /**
     * 控制启用和禁用模板平面中单个位的正面和背面写入
     * @param mask
     * example:
     * gl.stencilMask(0xff);
     */
    WebGLState.prototype.stencilMask = function (mask) {
        this.stencilMaskSeparate(this._gl.FRONT, mask);
        this.stencilMaskSeparate(this._gl.BACK, mask);
    };
    /**
     * 模版测试设置函数和引用值。
     * @param func
     * @param ref
     * @param mask
     * example:
     * gl.enable(gl.STENCIL_TEST);
     * gl.stencilFunc(gl.LESS, 0, 0b1110011);
     */
    WebGLState.prototype.stencilFunc = function (func, ref, mask) {
        this.stencilFuncSeparate(this._gl.FRONT, func, ref, mask);
        this.stencilFuncSeparate(this._gl.BACK, func, ref, mask);
    };
    /**
     * 单面模版测试
     * @param face
     * @param func
     * @param ref
     * @param mask
     * example:
     * gl.enable(gl.STENCIL_TEST);
     * gl.stencilFuncSeparate(gl.FRONT, gl.LESS, 0.2, 1110011);
     */
    WebGLState.prototype.stencilFuncSeparate = function (face, func, ref, mask) {
        this._set4('stencilFuncSeparate', face, func, ref, mask);
    };
    /**
     * 单面的mask写入
     * @param face
     * @param mask
     * example:
     * gl.stencilMaskSeparate(gl.FRONT, 110101);
     */
    WebGLState.prototype.stencilMaskSeparate = function (face, mask) {
        this._set2('stencilMaskSeparate', face, mask);
    };
    /**
     * 设置正面和背面模板测试操作
     * @param fail
     * @param zfail
     * @param zpass
     * example:
     * gl.enable(gl.STENCIL_TEST);
     * gl.stencilOp(gl.INCR, gl.DECR, gl.INVERT);
     */
    WebGLState.prototype.stencilOp = function (fail, zfail, zpass) {
        this.stencilOpSeparate(this._gl.FRONT, fail, zfail, zpass);
        this.stencilOpSeparate(this._gl.BACK, fail, zfail, zpass);
    };
    /**
     * 设置正面和/或背面模板测试操作
     * @param face
     * @param fail
     * @param zfail
     * @param zpass
     * example:
     * gl.enable(gl.STENCIL_TEST);
     * gl.stencilOpSeparate(gl.FRONT, gl.INCR, gl.DECR, gl.INVERT);
     */
    WebGLState.prototype.stencilOpSeparate = function (face, fail, zfail, zpass) {
        this._set4('stencilOpSeparate', face, fail, zfail, zpass);
    };
    //stencil end
    //face start
    /**
     * 剔除方式
     * @param mode
     * example:
     * gl.enable(gl.CULL_FACE);
     * gl.cullFace(gl.FRONT_AND_BACK);
     */
    WebGLState.prototype.cullFace = function (mode) {
        this._set1('cullFace', mode);
    };
    /**
     * 设置卷绕方向
     * @param mode
     * example:
     * gl.frontFace(gl.CW);
     */
    WebGLState.prototype.frontFace = function (mode) {
        this._set1('frontFace', mode);
    };
    //face end
    //color start
    /**
     * 设置颜色写入
     * @param red
     * @param green
     * @param blue
     * @param alpha
     * example:
     * gl.colorMask(true, true, true, false);
     */
    WebGLState.prototype.clearColor = function (red, green, blue, alpha) {
        this._set4('clearColor', red, green, blue, alpha);
    };
    /**
     * 设置颜色写入
     * @param red
     * @param green
     * @param blue
     * @param alpha
     * example:
     * gl.colorMask(true, true, true, false);
     */
    WebGLState.prototype.colorMask = function (red, green, blue, alpha) {
        this._set4('colorMask', red, green, blue, alpha);
    };
    /**
     * 设置源和目标混合因子
     * @param red
     * @param green
     * @param blue
     * @param alpha
     * example:
     * gl.blendColor(0, 0.5, 1, 1);
     */
    WebGLState.prototype.blendColor = function (red, green, blue, alpha) {
        this._set4('blendColor', red, green, blue, alpha);
    };
    /**
     * 用于混合像素算法
     * @param sfactor
     * @param dfactor
     * example:
     * gl.enable(gl.BLEND);
     * gl.blendFunc(gl.SRC_COLOR, gl.DST_COLOR);
     */
    WebGLState.prototype.blendFunc = function (sfactor, dfactor) {
        this.blendFuncSeparate(sfactor, dfactor, sfactor, dfactor);
    };
    /**
     * 分别设置应用在 RGB 和 Alpha 上的 factor
     * @param srcRGB
     * @param dstRGB
     * @param srcAlpha
     * @param dstAlpha
     * example:
     * gl.enable(gl.BLEND);
     * gl.blendFuncSeparate(gl.SRC_COLOR, gl.DST_COLOR, gl.ONE, gl.ZERO);
     */
    WebGLState.prototype.blendFuncSeparate = function (srcRGB, dstRGB, srcAlpha, dstAlpha) {
        this._set4('blendFuncSeparate', srcRGB, dstRGB, srcAlpha, dstAlpha);
    };
    /**
     * 设置混合模式
     * @param mode
     * example:
     * gl.blendEquation(gl.FUNC_ADD);
     * gl.blendEquation(gl.FUNC_SUBTRACT);
     * gl.blendEquation(gl.FUNC_REVERSE_SUBTRACT);
     */
    WebGLState.prototype.blendEquation = function (mode) {
        this._set1('blendEquation', mode);
    };
    /**
     * 可以分别对 RGB 和 Alpha 做不同的操作处理
     * @param modeRGB
     * @param modeAlpha
     * example:
     * gl.blendEquationSeparate(gl.FUNC_ADD, gl.FUNC_SUBTRACT);
     */
    WebGLState.prototype.blendEquationSeparate = function (modeRGB, modeAlpha) {
        this._set2('blendEquationSeparate', modeRGB, modeAlpha);
    };
    //color end
    /**
     * 图像预处理
     * @param pname
     * @param param
     * example:
     * var tex = gl.createTexture();
     * gl.bindTexture(gl.TEXTURE_2D, tex);
     * gl.pixelStorei(gl.PACK_ALIGNMENT, 4);
     */
    WebGLState.prototype.pixelStorei = function (pname, param) {
        var currentParam = this._pixelStorei[pname];
        if (currentParam !== param) {
            this._pixelStorei[pname] = param;
            this._gl.pixelStorei(pname, param);
        }
    };
    /**
     * 用来设置视口，即指定从标准设备到窗口坐标的x、y仿射变换。
     * @param x
     * @param y
     * @param width
     * @param height
     * example:
     * gl.viewport(0, 0, width, height);
     */
    WebGLState.prototype.viewport = function (x, y, width, height) {
        this._set4('viewport', x, y, width, height);
    };
    /**
     * 激活指定的纹理单元
     * @param texture
     * example:
     * gl.activeTexture(gl.TEXTURE1);
     */
    WebGLState.prototype.activeTexture = function (texture) {
        texture = Math.min(texture, this._maxTextureCount);
        if (this._activeTextureIndex !== texture || this.noCache) {
            this._activeTextureIndex = texture;
            this._gl.activeTexture(texture);
        }
    };
    /**
     * 绑定WebGLTexture
     * @param target
     * @param texture
     * @param force
     * example:
     * var texture = gl.createTexture();
     * gl.bindTexture(gl.TEXTURE_2D, texture)
     */
    WebGLState.prototype.bindTexture = function (target, texture, force) {
        if (this._currentTextureBinding !== texture || force || this.noCache) {
            this._gl.bindTexture(target, texture);
            this._currentTextureBinding = texture;
        }
        this._textureUnitDict[this._activeTextureIndex] = texture;
    };
    WebGLState.prototype._set1 = function (name, param) {
        var value = this._dict[name];
        if (value !== param) {
            this._dict[name] = param;
            //@ts-expect-error save to assign
            this._gl[name](param);
        }
    };
    WebGLState.prototype._set2 = function (name, param0, param1) {
        var value = this._dict[name];
        if (!value) {
            value = this._dict[name] = { x: NaN, y: NaN };
        }
        if (value.x !== param0 || value.y !== param1) {
            //@ts-expect-error save to assign
            this._gl[name](value.x = param0, value.y = param1);
        }
    };
    WebGLState.prototype._set3 = function (name, param0, param1, param2) {
        var value = this._dict[name];
        if (!value) {
            value = this._dict[name] = { x: NaN, y: NaN, z: NaN };
        }
        if (value.x !== param0 || value.y !== param1 || value.z !== param2) {
            //@ts-expect-error safe to assign
            this._gl[name](value.x = param0, value.y = param1, value.z = param2);
        }
    };
    WebGLState.prototype._set4 = function (name, param0, param1, param2, param3) {
        var value = this._dict[name];
        if (!value) {
            value = this._dict[name] = {
                x: NaN, y: NaN, z: NaN, w: NaN,
            };
        }
        if (value.x !== param0 || value.y !== param1 || value.z !== param2 || value.w !== param3) {
            //@ts-expect-error safe to assign
            this._gl[name](value.x = param0, value.y = param1, value.z = param2, value.w = param3);
        }
    };
    WebGLState.prototype.get = function (name) {
        return this._dict[name];
    };
    return WebGLState;
}());

function requestAnimationFrame(cb) {
    return window.requestAnimationFrame(cb);
}

var _a$5;
var DATA_DICT = (_a$5 = {},
    _a$5[constants.FLOAT] = {
        name: constants.FLOAT,
        uniform: function (gl, info, value) {
            if (value.length != undefined) {
                gl.uniform1fv(info.loc, value);
            }
            else {
                gl.uniform1f(info.loc, value);
            }
        },
    },
    _a$5[constants.FLOAT_VEC2] = {
        name: constants.FLOAT_VEC2,
        uniform: function (gl, info, value) {
            gl.uniform2fv(info.loc, value);
        },
    },
    _a$5[constants.FLOAT_VEC3] = {
        name: constants.FLOAT_VEC3,
        uniform: function (gl, info, value) {
            gl.uniform3fv(info.loc, value);
        },
    },
    _a$5[constants.FLOAT_VEC4] = {
        name: constants.FLOAT_VEC4,
        uniform: function (gl, info, value) {
            gl.uniform4fv(info.loc, value);
        },
    },
    _a$5[constants.FLOAT_MAT2] = {
        name: constants.FLOAT_MAT2,
        uniform: function (gl, info, value) {
            gl.uniformMatrix2fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT2x3] = {
        name: constants.FLOAT_MAT2x3,
        uniform: function (gl, info, value) {
            gl.uniformMatrix2x3fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT2x4] = {
        name: constants.FLOAT_MAT2x4,
        uniform: function (gl, info, value) {
            gl.uniformMatrix2x3fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT3] = {
        name: constants.FLOAT_MAT3,
        uniform: function (gl, info, value) {
            gl.uniformMatrix3fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT3x2] = {
        name: constants.FLOAT_MAT3x2,
        uniform: function (gl, info, value) {
            gl.uniformMatrix3x2fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT3x4] = {
        name: constants.FLOAT_MAT3x4,
        uniform: function (gl, info, value) {
            gl.uniformMatrix3x4fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT4] = {
        name: constants.FLOAT_MAT4,
        uniform: function (gl, info, value) {
            gl.uniformMatrix4fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT4x3] = {
        name: constants.FLOAT_MAT4x3,
        uniform: function (gl, info, value) {
            gl.uniformMatrix4x3fv(info.loc, false, value);
        },
    },
    _a$5[constants.FLOAT_MAT4x2] = {
        name: constants.FLOAT_MAT4x2,
        uniform: function (gl, info, value) {
            gl.uniformMatrix4x2fv(info.loc, false, value);
        },
    },
    _a$5[constants.INT] = {
        name: constants.INT,
        uniform: function (gl, info, value) {
            if (value.length != undefined) {
                gl.uniform1iv(info.loc, value);
            }
            else {
                gl.uniform1i(info.loc, value);
            }
        },
    },
    _a$5[constants.INT_VEC2] = {
        name: constants.INT_VEC2,
        uniform: function (gl, info, value) {
            gl.uniform2iv(info.loc, value);
        },
    },
    _a$5[constants.INT_VEC3] = {
        name: constants.INT_VEC3,
        uniform: function (gl, info, value) {
            gl.uniform3iv(info.loc, value);
        },
    },
    _a$5[constants.INT_VEC4] = {
        name: constants.INT_VEC4,
        uniform: function (gl, info, value) {
            gl.uniform4iv(info.loc, value);
        },
    },
    _a$5[constants.UNSIGNED_INT] = {
        name: constants.UNSIGNED_INT,
        uniform: function (gl, info, value) {
            gl.uniform1uiv(info.loc, value);
        },
    },
    _a$5[constants.UNSIGNED_INT_VEC2] = {
        name: constants.UNSIGNED_INT_VEC2,
        uniform: function (gl, info, value) {
            gl.uniform2uiv(info.loc, value);
        },
    },
    _a$5[constants.UNSIGNED_INT_VEC3] = {
        name: constants.UNSIGNED_INT_VEC3,
        uniform: function (gl, info, value) {
            gl.uniform3uiv(info.loc, value);
        },
    },
    _a$5[constants.UNSIGNED_INT_VEC4] = {
        name: constants.UNSIGNED_INT_VEC4,
        uniform: function (gl, info, value) {
            gl.uniform4uiv(info.loc, value);
        },
    },
    _a$5[constants.BOOL] = {
        name: constants.BOOL,
        uniform: function (gl, info, value) {
            if (value.length != undefined) {
                gl.uniform1iv(info.loc, value);
            }
            else {
                gl.uniform1f(info.loc, value);
            }
        },
    },
    _a$5[constants.BOOL_VEC2] = {
        name: constants.BOOL_VEC2,
        uniform: function (gl, info, value) {
            gl.uniform2iv(info.loc, value);
        },
    },
    _a$5[constants.BOOL_VEC4] = {
        name: constants.BOOL_VEC4,
        uniform: function (gl, info, value) {
            gl.uniform4iv(info.loc, value);
        },
    },
    _a$5[constants.BOOL_VEC3] = {
        name: constants.BOOL_VEC3,
        uniform: function (gl, info, value) {
            gl.uniform3iv(info.loc, value);
        },
    },
    _a$5[constants.SAMPLER_2D] = {
        name: constants.SAMPLER_2D,
        uniform: assignTexUniform,
    },
    _a$5[constants.SAMPLER_CUBE] = {
        name: constants.SAMPLER_CUBE,
        uniform: assignTexUniform,
    },
    _a$5);
function assignTexUniform(gl, info, value, renderer) {
    if (value) {
        if (info.size > 1) {
            if (Array.isArray(value)) {
                value.forEach(function (tex, index) {
                    assignTextureLoc(gl, info, tex, renderer, index);
                });
            }
            else {
                consoleError("".concat(info.name, "[").concat(info.size, "] expect texture arrays"));
            }
        }
        else {
            assignTextureLoc(gl, info, value, renderer, 0);
        }
    }
}
function assignTextureLoc(gl, info, value, renderer, index) {
    if (value) {
        if (value.isDestroyed) {
            return consoleError("texture ".concat(value.name, " destroyed "), value);
        }
        renderer.state.activeTexture(gl.TEXTURE0 + info.textureIndex + index);
        var glTex = value.internal;
        if (glTex) {
            renderer.state.bindTexture(glTex.target, glTex.glHandle, true);
        }
        else {
            consoleWarn('texture not assigned to gl');
        }
    }
}

var _a$4, _b$2;
var BlockUniformInfoOffset = 1;
var BlockUniformInfoByteLength = 8;
var BlockUniformInfoType = 0;
var BlockUniformInfoArrayStride = 4;
var BlockUniformInfoArraySize = 2;
var BlockUniformInfoRowStride = 5;
function getUboHash(spec) {
    var ret = Object.keys(spec.uniforms).map(function (name) { return name + '[' + spec.uniforms[name].join(':') + ']'; }).join('+');
    return strHashCode(spec.name + '+', spec.size + '+', spec.uniformIndices.length + '+', ret);
}
function createUniformBlockSpecsFromProgram(gl, program, blockUniformNames) {
    var blockSpecs = [];
    var numUniformBlocks = gl.getProgramParameter(program, gl.ACTIVE_UNIFORM_BLOCKS);
    var _loop_1 = function (ii) {
        var name_1 = gl.getActiveUniformBlockName(program, ii);
        var blockSpec = {
            index: gl.getUniformBlockIndex(program, name_1),
            usedByVertexShader: gl.getActiveUniformBlockParameter(program, ii, gl.UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER),
            usedByFragmentShader: gl.getActiveUniformBlockParameter(program, ii, gl.UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER),
            size: gl.getActiveUniformBlockParameter(program, ii, gl.UNIFORM_BLOCK_DATA_SIZE),
            uniformIndices: gl.getActiveUniformBlockParameter(program, ii, gl.UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES),
            used: false,
            uniforms: {},
            name: name_1,
            id: '',
        };
        blockSpec.used = blockSpec.usedByVertexShader || blockSpec.usedByFragmentShader;
        blockSpecs[ii] = blockSpec;
        var indices = blockSpec.uniformIndices;
        var uniformNames = [];
        for (var i = 0; i < indices.length; i++) {
            var name_2 = gl.getActiveUniform(program, indices[i]).name.replace('[0]', '');
            blockSpec.uniforms[name_2] = [0, 0, 0, 0, 0, 0, 0, i, 0];
            uniformNames[i] = name_2;
            blockUniformNames.push(name_2);
        }
        [gl.UNIFORM_TYPE, gl.UNIFORM_OFFSET, gl.UNIFORM_SIZE, gl.UNIFORM_BLOCK_INDEX, gl.UNIFORM_ARRAY_STRIDE, gl.UNIFORM_MATRIX_STRIDE, gl.UNIFORM_IS_ROW_MAJOR].forEach(function (param, pi) {
            gl.getActiveUniforms(program, indices, param).forEach(function (value, idx) {
                var name = uniformNames[idx];
                blockSpec.uniforms[name][pi] = +value;
            });
        });
        for (var i = 0; i < uniformNames.length; i++) {
            var uniform = blockSpec.uniforms[uniformNames[i]];
            var nextUniform = blockSpec.uniforms[uniformNames[i + 1]];
            var size = nextUniform ? nextUniform[1] : blockSpec.size;
            uniform[8] = size - uniform[1];
        }
        blockSpec.id = getUboHash(blockSpec) + '';
    };
    for (var ii = 0; ii < numUniformBlocks; ++ii) {
        _loop_1(ii);
    }
    return blockSpecs;
}
function numberSetter(type) {
    return function (value, info, name, range) {
        var flag = {
            start: info[BlockUniformInfoOffset],
            dirty: true,
        };
        var arrSize = info[BlockUniformInfoArraySize];
        if (arrSize > 1) {
            var values = value;
            if (values.length) {
                var eleCount = range[1] || values.length;
                var vecLen = info[BlockUniformInfoArrayStride] / type.BYTES_PER_ELEMENT;
                var buffer = flag.buffer = new type(eleCount * vecLen);
                var start = range[0] || 0;
                for (var i = 0; i < eleCount; i++) {
                    buffer[i * vecLen] = values[i + start];
                }
                flag.start += start * vecLen;
            }
        }
        else {
            flag.buffer = new type([value]);
        }
        return flag;
    };
}
var arrSetter = function (type) { return function setArray(value, info, name, range) {
    var blockByteLen = info[BlockUniformInfoByteLength];
    var arrSize = info[BlockUniformInfoArraySize];
    var rowStride = info[BlockUniformInfoRowStride];
    var entryStride = arrSize === 1 ? blockByteLen : info[BlockUniformInfoArrayStride];
    var entryRowCount = rowStride ? entryStride / rowStride : 1;
    var rowNumPadding = entryStride / type.BYTES_PER_ELEMENT / entryRowCount;
    var maxRowCount = blockByteLen / type.BYTES_PER_ELEMENT / rowNumPadding;
    //set array
    var numPerEntry = ItemPerValueMap[info[BlockUniformInfoType]];
    var numPerRow = numPerEntry / entryRowCount;
    var valueStartIndex = (range[0] || 0) * numPerEntry;
    var totalRow = range[1] ? entryRowCount * range[1] : maxRowCount;
    var buffer = new type(rowNumPadding * totalRow);
    var flag = {
        start: info[BlockUniformInfoOffset] + entryStride * (range[0] || 0),
        dirty: true,
        buffer: buffer,
    };
    for (var i = 0, bufferTarget = 0, sourceIndex = valueStartIndex; i < totalRow; i++) {
        for (var j = 0; j < numPerRow; j++) {
            buffer[bufferTarget + j] = value[sourceIndex + j];
        }
        bufferTarget += rowNumPadding;
        sourceIndex += numPerRow;
    }
    return flag;
}; };
var setFloat32Array = arrSetter(Float32Array);
var setInt32Array = arrSetter(Int32Array);
var setUInt8Array = arrSetter(Uint8Array);
var MemorySetter = (_a$4 = {},
    _a$4[constants.FLOAT] = numberSetter(Float32Array),
    _a$4[constants.INT] = numberSetter(Int32Array),
    _a$4[constants.UNSIGNED_INT] = numberSetter(Uint32Array),
    _a$4[constants.SHORT] = numberSetter(Int16Array),
    _a$4[constants.BOOL] = numberSetter(Uint8Array),
    _a$4[constants.UNSIGNED_SHORT] = numberSetter(Uint16Array),
    _a$4[constants.FLOAT_VEC2] = setFloat32Array,
    _a$4[constants.FLOAT_VEC3] = setFloat32Array,
    _a$4[constants.FLOAT_VEC4] = setFloat32Array,
    _a$4[constants.FLOAT_MAT2] = setFloat32Array,
    _a$4[constants.FLOAT_MAT3] = setFloat32Array,
    _a$4[constants.FLOAT_MAT4] = setFloat32Array,
    _a$4[constants.FLOAT_MAT2x3] = setFloat32Array,
    _a$4[constants.FLOAT_MAT2x4] = setFloat32Array,
    _a$4[constants.FLOAT_MAT4x3] = setFloat32Array,
    _a$4[constants.FLOAT_MAT4x2] = setFloat32Array,
    _a$4[constants.FLOAT_MAT3x4] = setFloat32Array,
    _a$4[constants.FLOAT_MAT3x2] = setFloat32Array,
    _a$4[constants.INT_VEC2] = setInt32Array,
    _a$4[constants.INT_VEC3] = setInt32Array,
    _a$4[constants.INT_VEC4] = setInt32Array,
    _a$4[constants.UNSIGNED_INT_VEC2] = setInt32Array,
    _a$4[constants.UNSIGNED_INT_VEC3] = setInt32Array,
    _a$4[constants.UNSIGNED_INT_VEC4] = setInt32Array,
    _a$4[constants.BOOL_VEC2] = setUInt8Array,
    _a$4[constants.BOOL_VEC3] = setUInt8Array,
    _a$4[constants.BOOL_VEC4] = setUInt8Array,
    _a$4);
var ItemPerValueMap = (_b$2 = {},
    _b$2[constants.FLOAT] = 1,
    _b$2[constants.INT] = 1,
    _b$2[constants.UNSIGNED_INT] = 1,
    _b$2[constants.SHORT] = 1,
    _b$2[constants.BOOL] = 1,
    _b$2[constants.UNSIGNED_SHORT] = 1,
    _b$2[constants.FLOAT_VEC2] = 2,
    _b$2[constants.FLOAT_VEC3] = 3,
    _b$2[constants.FLOAT_VEC4] = 4,
    _b$2[constants.FLOAT_MAT2] = 4,
    _b$2[constants.FLOAT_MAT3] = 9,
    _b$2[constants.FLOAT_MAT4] = 16,
    _b$2[constants.FLOAT_MAT2x3] = 6,
    _b$2[constants.FLOAT_MAT2x4] = 8,
    _b$2[constants.FLOAT_MAT4x3] = 12,
    _b$2[constants.FLOAT_MAT4x2] = 8,
    _b$2[constants.FLOAT_MAT3x4] = 12,
    _b$2[constants.FLOAT_MAT3x2] = 6,
    _b$2[constants.INT_VEC2] = 2,
    _b$2[constants.INT_VEC3] = 3,
    _b$2[constants.INT_VEC4] = 4,
    _b$2[constants.UNSIGNED_INT_VEC2] = 2,
    _b$2[constants.UNSIGNED_INT_VEC3] = 3,
    _b$2[constants.UNSIGNED_INT_VEC4] = 4,
    _b$2[constants.BOOL_VEC2] = 2,
    _b$2[constants.BOOL_VEC3] = 3,
    _b$2[constants.BOOL_VEC4] = 4,
    _b$2);
var fullRange = [0, 0];
var UniformBlockBuffer = /** @class */ (function () {
    function UniformBlockBuffer(renderer, info) {
        this.buffer = new GLGPUBuffer({
            target: constants.UNIFORM_BUFFER,
            name: info.name,
            byteLength: info.size,
        }, renderer);
        this.dirtyFlags = {};
        this.info = info;
    }
    UniformBlockBuffer.prototype.setValues = function (uniformValues, dirtyFlags, uniformValueOffsets) {
        var _this = this;
        forEach(uniformValues, function (value, name) {
            var uniformInfo = _this.info.uniforms[name];
            if (uniformInfo && dirtyFlags[name]) {
                var range = uniformValueOffsets[name] || fullRange;
                var setter = MemorySetter[uniformInfo[BlockUniformInfoType]];
                _this.dirtyFlags[name] = setter(value, uniformInfo, name, range);
            }
        });
    };
    UniformBlockBuffer.prototype.bind = function (gl, program, bufferBindIndex) {
        var _this = this;
        var buffer = this.buffer;
        if (buffer) {
            buffer.bind();
            forEach(this.dirtyFlags, function (flag, name) {
                if (flag.dirty) {
                    buffer.bufferSubData(flag.start, new Uint8Array(flag.buffer.buffer));
                    if (!_this.keepData) {
                        delete flag.buffer;
                    }
                    flag.dirty = false;
                }
            });
            gl.uniformBlockBinding(program, bufferBindIndex, bufferBindIndex);
            gl.bindBufferRange(gl.UNIFORM_BUFFER, bufferBindIndex, buffer.glBuffer, 0, this.info.size);
        }
    };
    UniformBlockBuffer.prototype.destroy = function () {
        if (this.buffer) {
            this.buffer.destroy();
            this.buffer = undefined;
        }
    };
    return UniformBlockBuffer;
}());

var temArr = new Set();
var GLProgram = /** @class */ (function () {
    function GLProgram(renderer, program, shared, id) {
        this.glHandle = program;
        this.renderer = renderer;
        this.shared = shared;
        this.uniformBlockMap = {};
        this.id = id;
        this.init(renderer, program);
        this._vaos = [];
    }
    GLProgram.prototype.init = function (renderer, program) {
        var _this = this;
        var gl = renderer.gl;
        renderer.state.useProgram(program);
        var num = gl.getProgramParameter(program, gl.ACTIVE_ATTRIBUTES);
        var attrMap = {};
        for (var i = 0; i < num; i++) {
            var _a = gl.getActiveAttrib(program, i), name_1 = _a.name, type = _a.type, size = _a.size;
            var loc = gl.getAttribLocation(program, name_1);
            attrMap[name_1] = {
                type: type,
                name: name_1,
                size: size,
                loc: loc,
            };
        }
        this.attrInfoMap = attrMap;
        var uniformMap = {};
        num = gl.getProgramParameter(program, gl.ACTIVE_UNIFORMS);
        var textureIndex = 0;
        var emptyTexture2D = renderer.emptyTexture2D;
        var emptyTextureCube = renderer.emptyTextureCube;
        var blockUniformNames = [];
        if (renderer.level === 2) {
            this._uniformBlocks = createUniformBlockSpecsFromProgram(gl, program, blockUniformNames);
            this._uniformBlocks.forEach(function (b) { return _this.uniformBlockMap[b.name] = b; });
        }
        else {
            this._uniformBlocks = [];
        }
        for (var i = 0; i < num; i++) {
            var info = gl.getActiveUniform(program, i);
            var _b = gl.getActiveUniform(program, i), size = _b.size, type = _b.type;
            var name_2 = info.name;
            var location_1 = null;
            // BUG, webgl and node gl use different name
            if (/\[0\]$/.test(name_2)) {
                location_1 = gl.getUniformLocation(program, name_2);
            }
            name_2 = name_2.replace(/\[0\]$/, '');
            if (!location_1) {
                location_1 = gl.getUniformLocation(program, name_2);
            }
            if (!location_1) {
                if (!blockUniformNames.includes(name_2)) {
                    consoleWarn("get uniform ".concat(name_2, " loc fail"));
                }
                continue;
            }
            this.renderer._assignInspectorName(location_1, name_2);
            var locTexIndex = -1;
            if (type === gl.SAMPLER_2D || type === gl.SAMPLER_CUBE) {
                locTexIndex = textureIndex;
                for (var k = 0; k < size; k++) {
                    var subLoc = k > 0 ? gl.getUniformLocation(program, "".concat(name_2, "[").concat(k, "]")) : location_1;
                    var activeIndex = textureIndex + k;
                    if (activeIndex < renderer.gpu.capability.maxShaderTexCount) {
                        gl.activeTexture(gl.TEXTURE0 + activeIndex);
                        if (type === gl.SAMPLER_2D) {
                            gl.bindTexture(gl.TEXTURE_2D, emptyTexture2D.glHandle);
                        }
                        else {
                            gl.bindTexture(gl.TEXTURE_CUBE_MAP, emptyTextureCube.glHandle);
                        }
                        gl.uniform1i(subLoc, activeIndex);
                    }
                    else {
                        consoleError("texture index ".concat(activeIndex, " overflows max ").concat(renderer.gpu.capability.maxShaderTexCount));
                    }
                }
                textureIndex += size;
            }
            var subInfos = [];
            for (var j = 0; j < size; ++j) {
                var fullName = name_2 + '[' + j + ']';
                var loc = gl.getUniformLocation(program, fullName);
                if (loc !== null) {
                    subInfos.push({
                        name: fullName,
                        loc: loc,
                        subInfos: [],
                        type: type,
                        size: 1,
                        textureIndex: locTexIndex,
                        isTexture: locTexIndex > -1,
                    });
                }
            }
            uniformMap[name_2] = {
                name: name_2,
                loc: location_1,
                subInfos: subInfos,
                type: type,
                size: size,
                textureIndex: locTexIndex,
                isTexture: locTexIndex > -1,
            };
        }
        renderer.state.useProgram(null);
        gl.activeTexture(gl.TEXTURE0);
        renderer.state.activeTexture(gl.TEXTURE0);
        renderer.state.bindTexture(gl.TEXTURE_2D, emptyTexture2D.glHandle, true);
        this.uniformInfoMap = uniformMap;
    };
    GLProgram.prototype.bind = function () {
        var renderer = this.renderer;
        if (renderer) {
            renderer.state.useProgram(this.glHandle);
        }
    };
    GLProgram.prototype.getSemanticValue = function (state, semanticName) {
        if (typeof semanticName === 'function') {
            return semanticName(state);
        }
        else {
            var renderPassSemantics = state.currentPass.semantics;
            var renderFrameSemantics = state.currentFrame.semantics;
            if (renderPassSemantics.hasSemanticValue(semanticName)) {
                return renderPassSemantics.getSemanticValue(semanticName, state);
            }
            else if (renderFrameSemantics.hasSemanticValue(semanticName)) {
                return renderFrameSemantics.getSemanticValue(semanticName, state);
            }
        }
    };
    GLProgram.prototype.setupUniforms = function (state) {
        var _this = this;
        this.bind();
        var material = state.currentMesh.material;
        var gl = this.renderer.gl;
        var blocks = material._dataBlocks;
        var shared = this.shared;
        temArr.clear();
        forEach(this.uniformBlockMap, function (uboInfo, name) {
            if (uboInfo) {
                var block_1 = material.getDataBlockByName(uboInfo.name);
                if (block_1) {
                    forEach(block_1.uniformSemantics, function (semanticName, uniformName) {
                        if (uniformName in uboInfo.uniforms && !block_1.hasUniformValue(uniformName)) {
                            var val = _this.getSemanticValue(state, semanticName);
                            if (val || val === 0) {
                                block_1.setUniformValue(uniformName, val, true);
                            }
                        }
                    });
                    var uboBuffer = block_1.createUboBuffer(uboInfo);
                    if (uboBuffer) {
                        block_1.setUboBuffer(uboBuffer);
                        temArr.add(block_1);
                        return uboBuffer.bind(gl, _this.glHandle, uboInfo.index);
                    }
                }
            }
        });
        forEach(this.uniformInfoMap, function (info, name) {
            var val;
            for (var i = 0; i < blocks.length; i++) {
                var block = blocks[i];
                var semanticName = block.uniformSemantics[name];
                if (info.isTexture) {
                    if (block.hasUniformValue(name)) {
                        val = block.getUniformTexture(name);
                    }
                    else if (semanticName) {
                        val = _this.getSemanticValue(state, semanticName);
                    }
                }
                else if (temArr.has(block)) {
                    continue;
                }
                else if (block.hasUniformValue(name)) {
                    if (!shared && !block._uniformFlags[name] && info.textureIndex === -1) {
                        //not dirty, don't assign
                        return;
                    }
                    val = block.getUniformValue(name);
                }
                else if (semanticName) {
                    val = _this.getSemanticValue(state, semanticName);
                }
                if (val !== undefined && val !== null) {
                    return _this.setGLUniformValue(name, val, info, gl);
                }
            }
            if (!info.isTexture) {
                consoleWarn("mesh ".concat(state.currentMesh.name, " uniform ").concat(name, " value unset"));
            }
        });
    };
    GLProgram.prototype.setGLUniformValue = function (name, value, info, gl) {
        var uniformInfo = DATA_DICT[info.type];
        var subInfos = info.subInfos;
        if (subInfos.length > 0 && Array.isArray(value) && Array.isArray(value[0])) {
            for (var i = 0; i < subInfos.length && i < value.length; ++i) {
                var subInfo = subInfos[i];
                uniformInfo.uniform(gl, subInfo, value[i], this.renderer);
            }
            return;
        }
        uniformInfo.uniform(gl, info, value, this.renderer);
    };
    GLProgram.prototype.setupAttributes = function (geometry) {
        var _a;
        var gl = this.renderer.gl;
        var vao = geometry.createVao(this.id);
        var gpu = this.renderer.gpu;
        if (vao) {
            vao.bind();
            if (vao.ready) {
                return vao;
            }
            else {
                arrAdd(this._vaos, vao);
            }
        }
        forEach(this.attrInfoMap, function (attrInfo, name) {
            var attribute = geometry.attributes[name];
            if (attribute) {
                var buffer = geometry.getGPUBuffer(attribute.dataSource);
                if (!buffer) {
                    throw Error("no buffer named ".concat(attribute.dataSource || name));
                }
                buffer.bind();
                if (attribute.size > 4) {
                    var _a = getMatAttrLocPair(attrInfo.type), row = _a[0], col = _a[1];
                    var bytesPerRow = getBytesPerElementByGLType(attribute.type) * col;
                    var stride = row * bytesPerRow;
                    for (var i = 0; i < row; i++) {
                        var loc = attrInfo.loc + i;
                        gl.enableVertexAttribArray(loc);
                        gl.vertexAttribPointer(loc, col, attribute.type, attribute.normalize, stride, i * bytesPerRow);
                        if (attribute.instanceDivisor && gpu.capability.instanceDraw) {
                            gpu.vertexAttribDivisor(gl, loc, attribute.instanceDivisor);
                        }
                    }
                }
                else {
                    gl.enableVertexAttribArray(attrInfo.loc);
                    gl.vertexAttribPointer(attrInfo.loc, attribute.size, attribute.type, attribute.normalize, attribute.stride || 0, attribute.offset || 0);
                    if (attribute.instanceDivisor && gpu.capability.instanceDraw) {
                        gpu.vertexAttribDivisor(gl, attrInfo.loc, attribute.instanceDivisor);
                    }
                }
            }
        });
        (_a = geometry._indexBuffer) === null || _a === void 0 ? void 0 : _a.bind();
        if (vao) {
            vao.ready = true;
        }
        return vao;
    };
    GLProgram.prototype.destroy = function () {
        if (this.renderer) {
            this._vaos.forEach(function (vao) { return vao.destroy(); });
            this._vaos.length = 0;
            this.renderer.gl.deleteProgram(this.glHandle);
            //@ts-expect-error safe to assign
            this.renderer = null;
        }
    };
    return GLProgram;
}());

var _a$3;
var ShaderType;
(function (ShaderType) {
    ShaderType[ShaderType["vertex"] = 0] = "vertex";
    ShaderType[ShaderType["fragment"] = 1] = "fragment";
})(ShaderType || (ShaderType = {}));
var downgradeKeywords = (_a$3 = {},
    _a$3[ShaderType.vertex] = {
        in: 'attribute',
        out: 'varying',
    },
    _a$3[ShaderType.fragment] = {
        in: 'varying',
    },
    _a$3);
var shaderSeed = 1;
var GLShaderLibrary = /** @class */ (function () {
    function GLShaderLibrary(renderer) {
        this._shaderAllDone = false;
        this.renderer = renderer;
        this._shaderMap = {};
        this.shaderResults = {};
        this._programMap = {};
        this._glVertShaderMap = new Map();
        this._glFragShaderMap = new Map();
        var gl = this.renderer.gl;
        this._glAsyncCompileExt = gl.getExtension('KHR_parallel_shader_compile');
    }
    Object.defineProperty(GLShaderLibrary.prototype, "cacheIds", {
        get: function () {
            return Object.keys(this.shaderResults);
        },
        enumerable: false,
        configurable: true
    });
    GLShaderLibrary.prototype.getShaderResult = function (cacheId) {
        if (this.shaderResults) {
            return this.shaderResults[cacheId];
        }
    };
    GLShaderLibrary.prototype.compileAllShaders = function (asyncCallback) {
        var _this = this;
        if (!this._shaderAllDone) {
            var res_1 = this.shaderResults;
            var pendings_1 = [];
            forEach(this._shaderMap, function (result, id) {
                if (!res_1[id]) {
                    arrAdd(pendings_1, id);
                }
            });
            if (asyncCallback) {
                if (pendings_1.length) {
                    Promise.all(pendings_1.map(function (id) { return new Promise(function (resolve) { return _this.compileShader(id, resolve); }); }))
                        .then(asyncCallback)
                        .catch(function () { return 0; });
                }
                else {
                    asyncCallback([]);
                }
            }
            else {
                pendings_1.map(function (id) { return _this.compileShader(id); });
            }
            this._shaderAllDone = true;
        }
        else if (asyncCallback) {
            asyncCallback([]);
        }
    };
    GLShaderLibrary.prototype.getProgram = function (shaderCacheId) {
        if (this._programMap[shaderCacheId] == undefined) {
            if (this._shaderMap[shaderCacheId] !== undefined) {
                this.compileShader(shaderCacheId);
            }
        }
        return this._programMap[shaderCacheId];
    };
    GLShaderLibrary.prototype.addMarcosHeader = function (header, shader, type, downgrade) {
        var versionTag = /#version\s+\b\d{3}\b\s*(es)?/;
        var GLV = "WEBGL".concat(this.renderer.level);
        if (downgrade) {
            header = header + "\n#ifndef ".concat(GLV, "\n#define ").concat(GLV, "\n#endif");
        }
        var fullShader = header + '\n' + shader;
        var match = fullShader.match(versionTag);
        var version = match ? match[0] : '';
        var realVersion = version;
        if (version && version.includes('300') && this.renderer.level === 1 && downgrade) {
            realVersion = '';
            fullShader = fullShader.replace(/\b(in|out)\b/g, function (str) {
                return downgradeKeywords[type][str] || str;
            });
        }
        return realVersion + '\n' + fullShader.replace(version, '\n');
    };
    GLShaderLibrary.prototype.addShader = function (shader) {
        var marcosHead = shader.marcos ? combineMaterialMarcos(shader.marcos) : '';
        var vertex = shader.vertex ? this.addMarcosHeader(marcosHead, shader.vertex, ShaderType.vertex, shader.downgrade) : '';
        var fragment = shader.fragment ? this.addMarcosHeader(marcosHead, shader.fragment, ShaderType.fragment, shader.downgrade) : '';
        var shaderCacheId;
        var shared = false;
        if (shader.shared || shader.cacheId) {
            shaderCacheId = shader.cacheId || "shared_".concat(strHashCode(vertex, fragment));
            shared = true;
        }
        else {
            shaderCacheId = 'instanced_' + shaderSeed++;
        }
        if (!this._shaderMap[shaderCacheId]) {
            this._shaderAllDone = false;
            this._shaderMap[shaderCacheId] = {
                vertex: vertex,
                fragment: fragment,
                name: shader.name || shaderCacheId,
                shared: shared,
            };
        }
        return shaderCacheId;
    };
    GLShaderLibrary.prototype.compileShader = function (shaderCacheId, asyncCallback) {
        var _this = this;
        var shaderResult = this.shaderResults[shaderCacheId];
        if (!shaderResult) {
            var shader_1 = this._shaderMap[shaderCacheId];
            if (!shader_1) {
                return {
                    status: exports.ShaderCompileResultStatus.noShader,
                };
            }
            var gl_1 = this.renderer.gl;
            var result_1 = { shared: shader_1.shared, status: exports.ShaderCompileResultStatus.compiling };
            var linkProgram_1 = this.createProgram(gl_1, shader_1.vertex, shader_1.fragment, result_1);
            var ext_1 = this._glAsyncCompileExt;
            var startTime_1 = Date.now();
            var checkComplete_1 = function () {
                var shouldLink = !asyncCallback || !ext_1 || (ext_1 && gl_1.getProgramParameter(result_1.program, ext_1.COMPLETION_STATUS_KHR) == true);
                var program = shouldLink && linkProgram_1();
                if (program) {
                    if (result_1.status !== exports.ShaderCompileResultStatus.fail) {
                        _this.renderer._assignInspectorName(program, shader_1.name);
                        var glProgram = new GLProgram(_this.renderer, program, !!shader_1.shared, shaderCacheId);
                        gl_1.validateProgram(program);
                        var valid = gl_1.getProgramParameter(program, gl_1.VALIDATE_STATUS);
                        if (!valid) {
                            result_1.status = exports.ShaderCompileResultStatus.fail;
                        }
                        else {
                            result_1.status = exports.ShaderCompileResultStatus.success;
                            result_1.compileTime = Date.now() - startTime_1;
                            _this._programMap[shaderCacheId] = glProgram;
                        }
                    }
                    if (result_1.status === exports.ShaderCompileResultStatus.fail) {
                        var error = gl_1.getProgramInfoLog(program);
                        result_1.error = error;
                        consoleError('compileProgramError: ' + error, '\nvertex:\n', shader_1.vertex, '\nfragment:\n', shader_1.fragment);
                        gl_1.deleteProgram(program);
                    }
                    if (asyncCallback) {
                        asyncCallback(result_1);
                    }
                }
                else if (asyncCallback) {
                    requestAnimationFrame(checkComplete_1);
                }
            };
            this.shaderResults[shaderCacheId] = result_1;
            checkComplete_1();
        }
        else if (asyncCallback) {
            asyncCallback(shaderResult);
        }
        return this.shaderResults[shaderCacheId];
    };
    GLShaderLibrary.prototype.createProgram = function (gl, vs, fs, result) {
        var program = gl.createProgram();
        var vertexShader = this.createShader(gl, gl.VERTEX_SHADER, vs);
        var fragShader = this.createShader(gl, gl.FRAGMENT_SHADER, fs);
        if (program && vertexShader && fragShader) {
            gl.attachShader(program, vertexShader);
            gl.attachShader(program, fragShader);
            gl.linkProgram(program);
            result.program = program;
            result.status = exports.ShaderCompileResultStatus.compiling;
            return function () {
                delete result.program;
                var linked = gl.getProgramParameter(program, gl.LINK_STATUS);
                if (!linked) {
                    checkShader(vertexShader, 'vertex', vs);
                    checkShader(fragShader, 'fragment', fs);
                    result.status = exports.ShaderCompileResultStatus.fail;
                    return program;
                }
                return program;
            };
        }
        result.status = exports.ShaderCompileResultStatus.fail;
        return function () { return null; };
        function checkShader(shader, type, code) {
            if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS)) {
                var error = gl.getShaderInfoLog(shader);
                consoleError('compile ' + (type) + ' error: ' + error, code
                    .split('\n')
                    .map(function (line, index) { return "".concat(index + 1, " ").concat(line); })
                    .join('\n'));
                result.error = error;
                result.status = exports.ShaderCompileResultStatus.fail;
            }
        }
    };
    GLShaderLibrary.prototype.createShader = function (gl, shaderType, code) {
        var map = shaderType === gl.VERTEX_SHADER ? this._glVertShaderMap : this._glFragShaderMap;
        var strHash = strHashCode(code);
        var ret = map.get(strHash);
        if (ret) {
            return ret;
        }
        var shader = gl.createShader(shaderType);
        if (shader) {
            gl.shaderSource(shader, code);
            gl.compileShader(shader);
            map.set(strHash, shader);
        }
        return shader;
    };
    GLShaderLibrary.prototype.deleteShader = function (cacheId) {
        var program = this._programMap[cacheId];
        if (program !== undefined) {
            program.destroy();
            delete this._programMap[cacheId];
        }
        var result = this.shaderResults[cacheId];
        if (result !== undefined) {
            delete this.shaderResults[cacheId];
        }
    };
    GLShaderLibrary.prototype.destroy = function () {
        this._shaderMap = {};
        forEach(this._programMap, function (program) {
            program.destroy();
        });
        this._programMap = {};
        if (this.renderer) {
            var gl_2 = this.renderer.gl;
            this._glFragShaderMap.forEach(function (shader) {
                gl_2.deleteShader(shader);
            });
            this._glVertShaderMap.forEach(function (shader) {
                gl_2.deleteShader(shader);
            });
            this._glVertShaderMap = new Map();
            this._glFragShaderMap = new Map();
        }
        // @ts-expect-error safe to assign
        this['renderer'] = null;
    };
    return GLShaderLibrary;
}());
function combineMaterialMarcos(marcos) {
    var ret = [];
    if (marcos) {
        marcos.forEach(function (_a) {
            var key = _a[0], value = _a[1];
            if (value === true) {
                ret.push("#define ".concat(key));
            }
            else if (Number.isFinite(value)) {
                ret.push("#define ".concat(key, " ").concat(value));
            }
        });
        return ret.length ? (ret.join('\n') + '\n') : '';
    }
    return '';
}

function isAndroid() {
    {
        return /\b[Aa]ndroid\b/.test(navigator.userAgent);
    }
}

var textureMaxAnisotropyExt;
var webGL2ConstructorAvailable = typeof WebGL2RenderingContext === 'function';
var TYPE_WEBGL = 'webgl';
var TYPE_WEBGL2 = 'webgl2';
var GLGPUCapability = /** @class */ (function () {
    function GLGPUCapability(opt) {
        var _a;
        var gl = opt.gl;
        var type = 'none';
        opt = opt || {};
        var canvas;
        {
            if (!gl) {
                var prefix = TYPE_WEBGL;
                if (!isAndroid() && webGL2ConstructorAvailable) {
                    prefix = opt.glType || TYPE_WEBGL2;
                }
                canvas = document.createElement('canvas');
                gl = canvas.getContext(prefix);
                if (!gl) {
                    prefix = 'webgl';
                    gl = canvas.getContext(prefix);
                }
            }
            if (gl) {
                type = (webGL2ConstructorAvailable && (gl instanceof WebGL2RenderingContext)) ? TYPE_WEBGL2 : TYPE_WEBGL;
            }
        }
        this._setupCapability(gl);
        // @ts-expect-error safe to assign
        this.type = type;
        if (canvas && gl) {
            (_a = gl.getExtension('WEBGL_lose_context')) === null || _a === void 0 ? void 0 : _a.loseContext();
        }
    }
    GLGPUCapability.prototype._setupCapability = function (gl) {
        var _a;
        if (gl) {
            // @ts-expect-error safe to assign
            this['level'] = (webGL2ConstructorAvailable && gl instanceof WebGL2RenderingContext) ? 2 : 1;
            var level2 = this.level === 2;
            var textureAnisotropicExt = gl.getExtension('EXT_texture_filter_anisotropic') || gl.getExtension('WEBKIT_EXT_texture_filter_anisotropic');
            if (!level2) {
                this.vaoExt = gl.getExtension('OES_vertex_array_object');
            }
            else {
                this.UNSIGNED_INT_24_8 = gl.UNSIGNED_INT_24_8;
            }
            this.drawBufferExtension = gl.getExtension('WEBGL_draw_buffers');
            var depthTextureExtension = gl.getExtension('WEBGL_depth_texture');
            if (depthTextureExtension) {
                this.UNSIGNED_INT_24_8 = depthTextureExtension.UNSIGNED_INT_24_8_WEBGL;
            }
            var halfFloatLinear = !!gl.getExtension('OES_texture_half_float_linear');
            if (level2 && !halfFloatLinear) {
                halfFloatLinear = this.checkLinearTextureFilter(gl, gl.HALF_FLOAT);
            }
            var floatLinear = !!gl.getExtension('OES_texture_float_linear');
            if (level2 && !floatLinear) {
                floatLinear = this.checkLinearTextureFilter(gl, gl.FLOAT);
            }
            this.internalFormatDepth16 = level2 ? gl.DEPTH_COMPONENT16 : gl.DEPTH_COMPONENT;
            this.internalFormatDepth24_stencil8 = level2 ? gl.DEPTH24_STENCIL8 : gl.DEPTH_STENCIL;
            this.instanceDrawExt = gl.getExtension('ANGLE_instanced_arrays');
            var floatTexture = (level2 || gl.getExtension('OES_texture_float')) ? gl.FLOAT : 0;
            var halfFloatTexture = level2 ? WebGL2RenderingContext.HALF_FLOAT : (((_a = gl.getExtension('OES_texture_half_float')) === null || _a === void 0 ? void 0 : _a.HALF_FLOAT_OES) || 0);
            var detail = {
                floatTexture: floatTexture,
                halfFloatTexture: halfFloatTexture,
                maxSample: level2 ? gl.getParameter(gl.MAX_SAMPLES) : 1,
                maxVertexUniforms: gl.getParameter(gl.MAX_VERTEX_UNIFORM_VECTORS),
                maxVertexTextures: gl.getParameter(gl.MAX_VERTEX_TEXTURE_IMAGE_UNITS),
                maxFragmentUniforms: gl.getParameter(gl.MAX_FRAGMENT_UNIFORM_VECTORS),
                maxFragmentTextures: gl.getParameter(gl.MAX_TEXTURE_IMAGE_UNITS),
                floatColorAttachment: level2 ? !!gl.getExtension('EXT_color_buffer_float') : (floatTexture > 0 && !!gl.getExtension('WEBGL_color_buffer_float')),
                halfFloatColorAttachment: level2 ? !!gl.getExtension('EXT_color_buffer_float') : (halfFloatTexture > 0 && !!gl.getExtension('EXT_color_buffer_half_float')),
                maxTextureSize: gl.getParameter(gl.MAX_TEXTURE_SIZE),
                maxShaderTexCount: gl.getParameter(gl.MAX_COMBINED_TEXTURE_IMAGE_UNITS),
                compressedTexture: registerCompressedTexture(gl),
                halfFloatLinear: halfFloatLinear,
                floatLinear: floatLinear,
                maxTextureAnisotropy: textureAnisotropicExt ? gl.getParameter(textureAnisotropicExt.MAX_TEXTURE_MAX_ANISOTROPY_EXT) : 0,
                shaderTextureLod: level2 || !!gl.getExtension('EXT_shader_texture_lod'),
                instanceDraw: level2 || !!this.instanceDrawExt,
                drawBuffers: level2 || !!this.drawBufferExtension,
                asyncShaderCompile: !!gl.getExtension('KHR_parallel_shader_compile'),
                intIndexElementBuffer: !!gl.getExtension('OES_element_index_uint'),
                standardDerivatives: level2 || !!gl.getExtension('OES_standard_derivatives'),
                readableDepthStencilTextures: level2 || !!depthTextureExtension,
                vao: level2 || !!this.vaoExt,
                writableFragDepth: level2 || !!gl.getExtension('EXT_frag_depth'),
            };
            // @ts-expect-error safe to assign
            this['capability'] = detail;
            if (textureAnisotropicExt) {
                textureMaxAnisotropyExt = textureAnisotropicExt.TEXTURE_MAX_ANISOTROPY_EXT;
            }
            // @ts-expect-error safe to assign
            this['type'] = 'webgl' + (level2 ? '2' : '');
        }
        else {
            // @ts-expect-error safe to assign
            this['capability'] = {};
        }
    };
    GLGPUCapability.prototype.checkLinearTextureFilter = function (gl, type) {
        var ret = false;
        var tex = gl.createTexture();
        gl.getError();
        gl.bindTexture(gl.TEXTURE_2D, tex);
        gl.texImage2D(gl.TEXTURE_2D, 0, gl.R16F, 1, 1, 0, gl.RED, type, null);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
        if (!gl.getError()) {
            ret = true;
        }
        gl.deleteTexture(tex);
        return ret;
    };
    GLGPUCapability.prototype.framebufferTexture2D = function (gl, target, index, textarget, texture) {
        var ext = this.drawBufferExtension;
        if (this.level === 1 && !ext && index > 0) {
            throw Error('draw multiple color buffers not available');
        }
        // @ts-expect-error safe to assign
        var attachment = ext ? ext["COLOR_ATTACHMENT".concat(index, "_WEBGL")] : gl['COLOR_ATTACHMENT' + index];
        if (attachment) {
            gl.framebufferTexture2D(target, attachment, textarget, texture, 0);
        }
        else {
            consoleError('invalid color attachment index:' + index);
        }
    };
    GLGPUCapability.prototype.vertexAttribDivisor = function (gl, loc, divisor) {
        if (this.level === 2) {
            gl.vertexAttribDivisor(loc, divisor);
        }
        else if (this.instanceDrawExt) {
            this.instanceDrawExt.vertexAttribDivisorANGLE(loc, divisor);
        }
        else {
            consoleWarn('instance draw not support');
        }
    };
    GLGPUCapability.prototype.drawElementsInstanced = function (gl, mode, count, type, offset, instanceCount) {
        if (this.level === 2) {
            gl.drawElementsInstanced(mode, count, type, offset, instanceCount);
        }
        else if (this.instanceDrawExt) {
            this.instanceDrawExt.drawElementsInstancedANGLE(mode, count, type, offset, instanceCount);
        }
        else {
            consoleWarn('instance draw not support');
        }
    };
    GLGPUCapability.prototype.drawArraysInstanced = function (gl, mode, first, count, instanceCount) {
        if (this.level === 2) {
            gl.drawArraysInstanced(mode, first, count, instanceCount);
        }
        else if (this.instanceDrawExt) {
            this.instanceDrawExt.drawArraysInstancedANGLE(mode, first, count, instanceCount);
        }
        else {
            consoleWarn('instance draw not support');
        }
    };
    GLGPUCapability.prototype.drawBuffers = function (gl, bufferStates) {
        var ext = this.drawBufferExtension;
        if (this.level === 1 && !ext) {
            if (bufferStates.length > 1) {
                throw Error('draw buffers not available');
            }
            else {
                return;
            }
        }
        var buffers = bufferStates.map(function (enabled, index) {
            if (enabled) {
                // @ts-expect-error safe to assign
                return ext ? ext["COLOR_ATTACHMENT".concat(index, "_WEBGL")] : gl['COLOR_ATTACHMENT' + index];
            }
            return gl.NONE;
        });
        if (ext) {
            ext.drawBuffersWEBGL(buffers);
        }
        else {
            gl.drawBuffers(buffers);
        }
    };
    GLGPUCapability.prototype.setTextureAnisotropic = function (gl, target, level) {
        var max = this.capability.maxTextureAnisotropy;
        if (max) {
            gl.texParameterf(target, textureMaxAnisotropyExt, Math.min(max, level || 4));
        }
    };
    GLGPUCapability.prototype.setup = function (gl) {
        this._setupCapability(gl);
    };
    return GLGPUCapability;
}());
function registerCompressedTexture(gl) {
    if (gl.getExtension('WEBGL_compressed_texture_astc')) {
        return COMPRESSED_TEXTURE_ASTC;
    }
    if (gl.getExtension('WEBGL_compressed_texture_pvrtc') || gl.getExtension('WEBKIT_WEBGL_compressed_texture_pvrtc')) {
        return COMPRESSED_TEXTURE_PVRTC;
    }
    return 0;
}

var _a$2, _b$1;
var flipCanvas;
var imageBitMapAvailable$1 = typeof ImageBitmap === 'function' && typeof createImageBitmap == 'function';
var GLTexture = /** @class */ (function () {
    function GLTexture(option, renderer) {
        this._mipmapUsed = false;
        var gl = renderer.gl;
        this.renderer = renderer;
        this.gpuInfo = [0, 0, 0, []];
        this.glHandle = renderer.createGLTexture(this, option.name);
        this.options = option;
        this.target = option.target || gl.TEXTURE_2D;
        this.update(option);
    }
    GLTexture.prototype.setInspectorName = function (name) {
        var _a;
        (_a = this.renderer) === null || _a === void 0 ? void 0 : _a._assignInspectorName(this.glHandle, name);
    };
    GLTexture.prototype.errorLog = function () {
        consoleError('this this texture has been destroyed');
    };
    GLTexture.prototype.update = function (source) {
        var _a, _b;
        var _this = this;
        var renderer = this.renderer;
        var handle = this.glHandle;
        var target = this.target;
        var options = this.options;
        if (renderer && handle) {
            var width_1 = 0;
            var height_1 = 0;
            var gl_1 = renderer.gl;
            renderer.state.bindTexture(target, handle);
            var sourceType = options.sourceType, flipY = options.flipY;
            var format_1 = options.format;
            var type_1 = options.type;
            var internalFormat_1 = options.internalFormat;
            if (type_1 === constants.HALF_FLOAT) {
                type_1 = renderer.gpu.capability.halfFloatTexture;
                if (!type_1) {
                    consoleError('half float texture is not support');
                }
                if (renderer.gpu.level === 2 && internalFormat_1 === format_1) {
                    if (format_1 === constants.LUMINANCE) {
                        format_1 = constants.RED;
                    }
                    internalFormat_1 = FORMAT_HALF_FLOAT[format_1];
                }
                if (!renderer.gpu.capability.halfFloatLinear) {
                    options.minFilter = options.magFilter = gl_1.NEAREST;
                    consoleWarn('half float linear not support,change to NEAREST');
                }
            }
            else if (type_1 === gl_1.FLOAT) {
                type_1 = renderer.gpu.capability.floatTexture;
                if (!type_1) {
                    consoleError('float texture is not support');
                }
                if (renderer.gpu.level === 2 && internalFormat_1 === format_1) {
                    if (format_1 === constants.LUMINANCE) {
                        format_1 = constants.RED;
                    }
                    internalFormat_1 = FORMAT_FLOAT[format_1];
                }
                if (!renderer.gpu.capability.floatLinear) {
                    options.minFilter = options.magFilter = gl_1.NEAREST;
                    consoleWarn('float linear not support,change to NEAREST');
                }
            }
            var gpuInfo = this.gpuInfo;
            gpuInfo[0] = internalFormat_1;
            gpuInfo[1] = type_1;
            gpuInfo[2] = target;
            var pma = gl_1.getParameter(gl_1.UNPACK_PREMULTIPLY_ALPHA_WEBGL);
            //fucking pma conflicts for other webgl engine
            if (pma != options.premultiplyAlpha) {
                gl_1.pixelStorei(gl_1.UNPACK_PREMULTIPLY_ALPHA_WEBGL, options.premultiplyAlpha ? 1 : 0);
            }
            // renderer.state.pixelStorei(gl.UNPACK_PREMULTIPLY_ALPHA_WEBGL, options.premultiplyAlpha ? 1 : 0);
            renderer.state.pixelStorei(gl_1.UNPACK_FLIP_Y_WEBGL, flipY ? 1 : 0);
            if (sourceType === exports.TextureSourceType.framebuffer) {
                var data = source.data;
                if (data) {
                    width_1 = data.width || 0;
                    height_1 = data.height || 0;
                    if (width_1 && height_1 && (this.width !== width_1 || this.height !== height_1)) {
                        gl_1.texImage2D(target, 0, internalFormat_1, width_1, height_1, 0, format_1, type_1, null);
                    }
                }
            }
            else if (sourceType === exports.TextureSourceType.data) {
                if (target === gl_1.TEXTURE_CUBE_MAP) {
                    var ret_1;
                    var cubeData = source.cube;
                    cubeData.forEach(function (data, key) {
                        ret_1 = _this.texImage2DData(gl_1, gl_1.TEXTURE_CUBE_MAP_POSITIVE_X + key, 0, internalFormat_1, format_1, type_1, data);
                        width_1 = Math.max(ret_1[0], width_1);
                        height_1 = Math.max(ret_1[1], height_1);
                    });
                }
                else {
                    _a = this.texImage2DData(gl_1, target, 0, internalFormat_1, format_1, type_1, source.data), width_1 = _a[0], height_1 = _a[1];
                }
            }
            else if (sourceType === exports.TextureSourceType.image || sourceType === exports.TextureSourceType.video) {
                if (target === gl_1.TEXTURE_CUBE_MAP) {
                    var ret_2;
                    source.cube.forEach(function (image, key) {
                        ret_2 = _this.texImage2D(gl_1, gl_1.TEXTURE_CUBE_MAP_POSITIVE_X + key, 0, internalFormat_1, format_1, type_1, image);
                        width_1 = Math.max(ret_2[0], width_1);
                        height_1 = Math.max(ret_2[1], height_1);
                    });
                }
                else if (target === gl_1.TEXTURE_2D) {
                    var image = source.image || source.video;
                    _b = this.texImage2D(gl_1, target, 0, internalFormat_1, format_1, type_1, image), width_1 = _b[0], height_1 = _b[1];
                }
                if (options.generateMipmap) {
                    if ((isPowerOfTwo(width_1) && isPowerOfTwo(height_1)) || renderer.level == 2) {
                        gl_1.generateMipmap(target);
                        var mipmapSizes = [[width_1, height_1]];
                        var startWidth = width_1 / 2;
                        var startHeight = height_1 / 2;
                        while (startWidth >= 2 && startHeight >= 2) {
                            mipmapSizes.push([startWidth, startHeight]);
                            startWidth = Math.round(startWidth / 2);
                            startHeight = Math.round(startHeight / 2);
                        }
                        mipmapSizes.push([1, 1]);
                        this.gpuInfo[3] = mipmapSizes;
                        this._mipmapUsed = true;
                    }
                }
            }
            else if (sourceType === exports.TextureSourceType.mipmaps) {
                var ret_3;
                if (target === gl_1.TEXTURE_2D) {
                    var mipmaps = source.mipmaps;
                    var gpuMipmaps_1 = this.gpuInfo[3];
                    mipmaps.forEach(function (mipmap, level) {
                        if ('data' in mipmap) {
                            ret_3 = _this.texImage2DData(gl_1, target, level, internalFormat_1, format_1, type_1, mipmap);
                        }
                        else {
                            ret_3 = _this.texImage2D(gl_1, target, level, internalFormat_1, format_1, type_1, mipmap);
                        }
                        gpuMipmaps_1[level] = [ret_3[0], ret_3[1]];
                        if (level === 0) {
                            width_1 = ret_3[0], height_1 = ret_3[1];
                        }
                    });
                    this._mipmapUsed = mipmaps.length > 1;
                }
                else if (target === gl_1.TEXTURE_CUBE_MAP) {
                    var mipmaps = source.mipmaps;
                    var gpuMipmaps_2 = this.gpuInfo[3];
                    mipmaps.forEach(function (mipmap, level) {
                        mipmap.forEach(function (face, key) {
                            if ('data' in face) {
                                ret_3 = _this.texImage2DData(gl_1, gl_1.TEXTURE_CUBE_MAP_POSITIVE_X + key, level, internalFormat_1, format_1, type_1, face);
                            }
                            else {
                                ret_3 = _this.texImage2D(gl_1, gl_1.TEXTURE_CUBE_MAP_POSITIVE_X + key, level, internalFormat_1, format_1, type_1, face);
                            }
                            gpuMipmaps_2[level] = [ret_3[0], ret_3[1]];
                            if (level === 0) {
                                width_1 = ret_3[0], height_1 = ret_3[1];
                            }
                        });
                    });
                    this._mipmapUsed = mipmaps.length > 1;
                }
            }
            else if (sourceType === exports.TextureSourceType.compressed) {
                var mipmaps = source.mipmaps;
                if (mipmaps) {
                    var gpuMipmaps = this.gpuInfo[3];
                    width_1 = mipmaps[0].width;
                    height_1 = mipmaps[0].height;
                    for (var miplevel = 0; miplevel < mipmaps.length; miplevel++) {
                        var mipmap = mipmaps[miplevel];
                        gpuMipmaps[miplevel] = [mipmap.width, mipmap.height];
                        gl_1.compressedTexImage2D(target, miplevel, internalFormat_1, mipmap.width, mipmap.height, 0, mipmap.data);
                    }
                    this._mipmapUsed = mipmaps.length > 1;
                }
            }
            if (!this._mipmapUsed) {
                this.gpuInfo[3] = [[width_1, height_1]];
            }
            if (pma != options.premultiplyAlpha) {
                gl_1.pixelStorei(gl_1.UNPACK_PREMULTIPLY_ALPHA_WEBGL, pma);
            }
            this.width = width_1;
            this.height = height_1;
            this.setTextureFilters(gl_1, target, options);
        }
        else {
            this.width = this.height = 0;
        }
    };
    GLTexture.prototype.setTextureFilters = function (gl, target, options) {
        var _a, _b;
        if (this.target === gl.TEXTURE_2D) {
            (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gpu.setTextureAnisotropic(gl, this.target, options.anisotropic || 4);
        }
        var isPot = ((_b = this.renderer) === null || _b === void 0 ? void 0 : _b.level) == 2 || (isPowerOfTwo(this.width) && isPowerOfTwo(this.height));
        var minFiler = isPot ? (options.minFilter || gl.NEAREST) : gl.NEAREST;
        var magFilter = isPot ? (options.magFilter || gl.NEAREST) : gl.NEAREST;
        gl.texParameteri(target, gl.TEXTURE_MIN_FILTER, minFiler);
        gl.texParameteri(target, gl.TEXTURE_MAG_FILTER, magFilter);
        gl.texParameteri(target, gl.TEXTURE_WRAP_S, isPot ? (options.wrapS || gl.CLAMP_TO_EDGE) : gl.CLAMP_TO_EDGE);
        gl.texParameteri(target, gl.TEXTURE_WRAP_T, isPot ? (options.wrapT || gl.CLAMP_TO_EDGE) : gl.CLAMP_TO_EDGE);
    };
    GLTexture.prototype.texImage2D = function (gl, target, level, internalformat, format, type, image) {
        var _a;
        var options = this.options;
        var maxSize = ((_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gpu.capability.maxTextureSize) || 2048;
        var img = image;
        if (options.sourceType !== exports.TextureSourceType.video) {
            var shouldResize = options.minFilter !== gl.NEAREST || options.magFilter !== gl.NEAREST || options.wrapS !== gl.CLAMP_TO_EDGE || options.wrapT !== gl.CLAMP_TO_EDGE;
            shouldResize = shouldResize || image.width > maxSize || image.height > maxSize;
            if (shouldResize) {
                img = this.resizeImage(image);
            }
            if (imageBitMapAvailable$1 && img instanceof ImageBitmap && options.flipY) {
                img = this.flipImageBitmap(img);
            }
        }
        gl.texImage2D(target, level, internalformat, format, type, img);
        var size = [img.width, img.height];
        if (flipCanvas) {
            flipCanvas.width = flipCanvas.height = 1;
        }
        return options.sourceType === exports.TextureSourceType.video ? [image.videoWidth, image.videoHeight] : size;
    };
    GLTexture.prototype.flipImageBitmap = function (bitmap) {
        if (!flipCanvas) {
            flipCanvas = document.createElement('canvas');
        }
        var width = flipCanvas.width = bitmap.width;
        var height = flipCanvas.height = bitmap.height;
        var ctx = flipCanvas.getContext('2d');
        ctx.clearRect(0, 0, width, height);
        ctx.fillStyle = 'rgba(255,255,255,0.0039)';
        ctx.fillRect(0, 0, width, height);
        ctx.drawImage(bitmap, 0, 0);
        return flipCanvas;
    };
    GLTexture.prototype.texImage2DData = function (gl, target, level, internalformat, format, type, data) {
        var bufferView = data.data;
        // Uint8ClampedArray is incompatible in android
        var neoBuffer = type === gl.UNSIGNED_BYTE ? new Uint8Array(bufferView.buffer, bufferView.byteOffset, bufferView.byteLength / bufferView.BYTES_PER_ELEMENT) : bufferView;
        var channel = Math.round(neoBuffer.length / (data.width * data.height));
        gl.pixelStorei(gl.UNPACK_ALIGNMENT, channel);
        gl.texImage2D(target, level, internalformat, data.width, data.height, 0, format, type, neoBuffer);
        if (gl.getError()) {
            consoleError('texImage2D failed');
        }
        gl.pixelStorei(gl.UNPACK_ALIGNMENT, 4);
        return [data.width, data.height];
    };
    GLTexture.prototype.resizeImage = function (image, targetWidth, targetHeight) {
        var _a, _b;
        var maxSize = ((_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gpu.capability.maxTextureSize) || 2048;
        if (((_b = this.renderer) === null || _b === void 0 ? void 0 : _b.level) === 2 && (image.width < maxSize && image.height < maxSize)) {
            return image;
        }
        if (image) {
            var width = image.width;
            var height = image.height;
            var nw = Math.min(maxSize, targetWidth || nearestPowerOfTwo(width));
            var nh = Math.min(maxSize, targetHeight || nearestPowerOfTwo(height));
            if (nh !== height || nw !== width) {
                var canvas = document.createElement('canvas');
                canvas.width = nw;
                canvas.height = nh;
                var ctx = canvas.getContext('2d');
                ctx.drawImage(image, 0, 0, image.width, image.height, 0, 0, nw, nh);
                consoleWarn("image resize from ".concat(width, "x").concat(height, " to ").concat(nw, "x").concat(nh));
                return canvas;
            }
        }
        return image;
    };
    GLTexture.prototype.offloadData = function () {
        var renderer = this.renderer;
        var target = this.target;
        if (renderer && this.glHandle) {
            var gl = renderer.gl;
            renderer.state.bindTexture(target, this.glHandle);
            var data = new Uint8Array([255]);
            var info = this.gpuInfo;
            info[3] = [[1, 1]];
            info[0] = gl.LUMINANCE;
            info[1] = gl.UNSIGNED_BYTE;
            info[2] = target;
            if (target === gl.TEXTURE_2D) {
                gl.texImage2D(target, 0, gl.LUMINANCE, 1, 1, 0, gl.LUMINANCE, gl.UNSIGNED_BYTE, data);
            }
            else if (target === gl.TEXTURE_CUBE_MAP) {
                var faces = [
                    gl.TEXTURE_CUBE_MAP_NEGATIVE_X,
                    gl.TEXTURE_CUBE_MAP_NEGATIVE_Y,
                    gl.TEXTURE_CUBE_MAP_NEGATIVE_Z,
                    gl.TEXTURE_CUBE_MAP_POSITIVE_X,
                    gl.TEXTURE_CUBE_MAP_POSITIVE_Y,
                    gl.TEXTURE_CUBE_MAP_POSITIVE_Z,
                ];
                for (var i = 0; i < faces.length; i++) {
                    gl.texImage2D(faces[i], 0, gl.LUMINANCE, 1, 1, 0, gl.LUMINANCE, gl.UNSIGNED_BYTE, data);
                }
            }
            //rewrite mipmap
            gl.generateMipmap(target);
            this.width = this.height = 1;
        }
    };
    GLTexture.prototype.destroy = function () {
        if (this.renderer) {
            this.renderer.deleteGLTexture(this);
            //@ts-expect-error safe to assign
            this.renderer = this.options = this.glHandle = null;
            this.update = this.destroy = this.errorLog;
        }
    };
    GLTexture.prototype._assignRenderer = function (renderer) {
        throw new Error('Method not implemented.');
    };
    return GLTexture;
}());
function nearestPowerOfTwo(value) {
    return Math.pow(2, Math.round(Math.log(value) / Math.LN2));
}
function isPowerOfTwo(value) {
    return (value & (value - 1)) === 0 && value !== 0;
}
var FORMAT_HALF_FLOAT = (_a$2 = {},
    _a$2[constants.RGBA] = 34842,
    _a$2[constants.RGB] = 34843,
    _a$2[constants.ALPHA] = 33325,
    _a$2[constants.RED] = 33325,
    _a$2[constants.LUMINANCE_ALPHA] = 33327,
    _a$2[constants.LUMINANCE] = 33325,
    _a$2);
var FORMAT_FLOAT = (_b$1 = {},
    _b$1[constants.RGBA] = 34836,
    _b$1[constants.RGB] = 34837,
    _b$1[constants.ALPHA] = 33326,
    _b$1[constants.RED] = 33326,
    _b$1[constants.LUMINANCE_ALPHA] = 33328,
    _b$1[constants.LUMINANCE] = 33326,
    _b$1);

var GL_LOST_EVENT = 'webglcontextlost';
var GLGPURenderer = /** @class */ (function () {
    function GLGPURenderer(gl) {
        var _this = this;
        this._isDestroyed = false;
        this.extension = {};
        this.onContextLose = function (e) {
            consoleError('gl lost, destroy renderer by default', e.target);
            _this.destroy();
            if (e.target) {
                e.target.removeEventListener(GL_LOST_EVENT, _this.onContextLose);
            }
        };
        this.gl = gl;
        this.state = new WebGLState(gl);
        this.level = typeof WebGL2RenderingContext !== 'undefined' && gl instanceof WebGL2RenderingContext ? 2 : 1;
        this._buffers = [];
        this._textures = [];
        this._vaos = [];
        this._renderBuffers = [];
        this._frameBuffers = [];
        this.shaderLibrary = new GLShaderLibrary(this);
        this.gpu = new GLGPUCapability({ gl: gl });
        var d = { width: 1, height: 1, data: new Uint8Array([255]) };
        this.emptyTexture2D = new GLTexture({
            data: d,
            sourceType: exports.TextureSourceType.data,
            format: gl.LUMINANCE,
            internalFormat: gl.LUMINANCE,
            type: gl.UNSIGNED_BYTE,
        }, this);
        this.emptyTextureCube = new GLTexture({
            target: gl.TEXTURE_CUBE_MAP,
            cube: [d, d, d, d, d, d],
            sourceType: exports.TextureSourceType.data,
            format: gl.LUMINANCE,
            internalFormat: gl.LUMINANCE,
            type: gl.UNSIGNED_BYTE,
        }, this);
        this.bindVertexArray = this.level === 2 ? this._bindVertexArray : this._bindVertexArrayOES;
        if (gl.canvas) {
            gl.canvas.addEventListener(GL_LOST_EVENT, this.onContextLose);
        }
    }
    GLGPURenderer.prototype.requestAnimationFrame = function (cb) {
        return window.requestAnimationFrame(cb);
    };
    GLGPURenderer.prototype.cancelAnimationFrame = function (id) {
        return window.cancelAnimationFrame(id);
    };
    Object.defineProperty(GLGPURenderer.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    GLGPURenderer.prototype.copy2 = function (source, target) {
        var gl = this.gl;
        if (gl) {
            if (!this._sourceFbo) {
                this._sourceFbo = gl.createFramebuffer();
            }
            if (!this._targetFbo) {
                this._targetFbo = gl.createFramebuffer();
            }
            var state = this.state;
            var COLOR_ATTACHMENT0 = gl.COLOR_ATTACHMENT0;
            state.bindFramebuffer(gl.FRAMEBUFFER, this._sourceFbo);
            gl.framebufferTexture2D(gl.FRAMEBUFFER, COLOR_ATTACHMENT0, gl.TEXTURE_2D, source.glHandle, 0);
            state.bindFramebuffer(gl.FRAMEBUFFER, this._targetFbo);
            gl.framebufferTexture2D(gl.FRAMEBUFFER, COLOR_ATTACHMENT0, gl.TEXTURE_2D, target.glHandle, 0);
            state.bindFramebuffer(gl.READ_FRAMEBUFFER, this._sourceFbo);
            state.bindFramebuffer(gl.DRAW_FRAMEBUFFER, this._targetFbo);
            var filter = source.width === source.height && target.width == target.height ? gl.NEAREST : gl.LINEAR;
            gl.blitFramebuffer(0, 0, source.width, source.height, 0, 0, target.width, target.height, gl.COLOR_BUFFER_BIT, filter);
            state.bindFramebuffer(gl.FRAMEBUFFER, null);
            state.bindFramebuffer(gl.READ_FRAMEBUFFER, null);
            state.bindFramebuffer(gl.DRAW_FRAMEBUFFER, null);
        }
    };
    GLGPURenderer.prototype.resetColorAttachments = function (rp, colors) {
        rp.bind();
        rp.resetColorTextures(colors);
    };
    GLGPURenderer.prototype.createGLRenderBuffer = function (renderbuffer) {
        var rb = this.gl.createRenderbuffer();
        if (rb) {
            arrAdd(this._renderBuffers, renderbuffer);
        }
        return rb;
    };
    GLGPURenderer.prototype.createPipeline = function (options) {
        throw new Error('Method not implemented.');
    };
    GLGPURenderer.prototype.createBuffer = function (options) {
        return new GLGPUBuffer(options, this);
    };
    GLGPURenderer.prototype.resize = function (width, height) {
        var gl = this.gl;
        if (gl && gl.drawingBufferWidth !== width || gl.drawingBufferHeight !== height) {
            gl.canvas.width = width;
            gl.canvas.height = height;
            gl.viewport(0, 0, width, height);
            this._frameBuffers.forEach(function (frameBuffer) {
                var viewport = frameBuffer.viewport;
                if (!frameBuffer.isCustomViewport) {
                    frameBuffer.resize(viewport[0], viewport[1], width * frameBuffer.viewportScale, height * frameBuffer.viewportScale);
                }
            });
        }
    };
    GLGPURenderer.prototype._assignInspectorName = function (obj, name, id) {
        if (name) {
            obj.__SPECTOR_Metadata = { name: name };
            if (obj.__SPECTOR_Object_TAG) {
                obj.__SPECTOR_Object_TAG.displayText = name;
                if (id) {
                    obj.__SPECTOR_Object_TAG.id = id;
                }
            }
            else {
                obj.__SPECTOR_Object_TAG = {
                    displayText: name,
                    id: '',
                };
            }
        }
    };
    GLGPURenderer.prototype.createGLFrameBuffer = function (frameBuffer, name) {
        var fbo = this.gl.createFramebuffer();
        if (fbo) {
            arrAdd(this._frameBuffers, frameBuffer);
            this._assignInspectorName(fbo, name, name);
        }
        return fbo;
    };
    GLGPURenderer.prototype.createGLTexture = function (texture, name) {
        var tex = this.gl.createTexture();
        if (tex) {
            arrAdd(this._textures, texture);
            this._assignInspectorName(tex, name);
        }
        return tex;
    };
    GLGPURenderer.prototype.createGLBuffer = function (gpuBuffer, name) {
        var buffer = this.gl.createBuffer();
        if (buffer) {
            arrAdd(this._buffers, gpuBuffer);
            this._assignInspectorName(buffer, name);
        }
        return buffer;
    };
    GLGPURenderer.prototype.deleteGLTexture = function (texture) {
        if (texture.glHandle && !this._isDestroyed) {
            this.gl.deleteTexture(texture.glHandle);
            arrRemove(this._textures, texture);
            //@ts-expect-error safe to assign
            delete texture.glHandle;
        }
    };
    GLGPURenderer.prototype.deleteGPUBuffer = function (buffer) {
        if (buffer && !this._isDestroyed) {
            arrRemove(this._buffers, buffer);
            var handle = buffer.glBuffer;
            this.gl.deleteBuffer(handle);
            if (handle) {
                //@ts-expect-error safe to assign
                handle._isDestroyed = true;
            }
            //@ts-expect-error safe to assign
            delete buffer.glBuffer;
        }
    };
    GLGPURenderer.prototype.deleteGLFrameBuffer = function (frameBuffer) {
        if (frameBuffer && !this._isDestroyed) {
            var gl = this.gl;
            gl.deleteFramebuffer(frameBuffer.fbo);
            gl.deleteFramebuffer(frameBuffer.multisampleFbo);
            frameBuffer.multisampleRbs.forEach(function (rb) { return rb.destroy(); });
            arrRemove(this._frameBuffers, frameBuffer);
            delete frameBuffer.fbo;
        }
    };
    GLGPURenderer.prototype.deleteGLRenderBuffer = function (renderbuffer) {
        if (renderbuffer && !this._isDestroyed) {
            this.gl.deleteRenderbuffer(renderbuffer.glHandle);
            arrRemove(this._renderBuffers, renderbuffer);
            //@ts-expect-error safe to assign
            delete renderbuffer.glHandle;
        }
    };
    GLGPURenderer.prototype.createVertexArray = function (name) {
        var _a;
        var vao;
        if (this.level === 2) {
            vao = this.gl.createVertexArray();
        }
        if (!vao) {
            vao = (_a = this.gpu.vaoExt) === null || _a === void 0 ? void 0 : _a.createVertexArrayOES();
        }
        if (vao) {
            arrAdd(this._vaos, vao);
            this._assignInspectorName(vao, name);
        }
        return vao;
    };
    GLGPURenderer.prototype._bindVertexArray = function (vao) {
        this.gl.bindVertexArray(vao || null);
    };
    GLGPURenderer.prototype._bindVertexArrayOES = function (vao) {
        var _a;
        (_a = this.gpu.vaoExt) === null || _a === void 0 ? void 0 : _a.bindVertexArrayOES(vao);
    };
    GLGPURenderer.prototype.bindVertexArray = function (vao) {
        throw Error('xxx');
    };
    GLGPURenderer.prototype.deleteVertexArray = function (vao) {
        var _a;
        if (!this._isDestroyed) {
            if (this.level === 2) {
                this.gl.deleteVertexArray(vao);
            }
            else {
                (_a = this.gpu.vaoExt) === null || _a === void 0 ? void 0 : _a.deleteVertexArrayOES(vao);
            }
            arrRemove(this._vaos, vao);
        }
    };
    GLGPURenderer.prototype.destroy = function (haltGL) {
        var _this = this;
        var gl = this.gl;
        if (gl) {
            gl.deleteFramebuffer(this._sourceFbo);
            gl.deleteFramebuffer(this._targetFbo);
            this._buffers.forEach(function (buffer) { return _this.deleteGPUBuffer(buffer); });
            this._buffers.length = 0;
            this.state.destroy();
            this.shaderLibrary.destroy();
            this._vaos.forEach(function (vao) { return _this.deleteVertexArray(vao); });
            this.emptyTexture2D.destroy();
            this.emptyTextureCube.destroy();
            this._vaos.length = 0;
            this._frameBuffers.forEach(function (fb) { return _this.deleteGLFrameBuffer(fb); });
            this._frameBuffers.length = 0;
            this._renderBuffers.forEach(function (rb) { return _this.deleteGLRenderBuffer(rb); });
            this._renderBuffers.length = 0;
            this._textures.forEach(function (tex) { return _this.deleteGLTexture(tex); });
            this._textures.length = 0;
            gl.canvas.removeEventListener(GL_LOST_EVENT, this.onContextLose);
            if (haltGL) {
                var ex = gl.getExtension('WEBGL_lose_context');
                ex === null || ex === void 0 ? void 0 : ex.loseContext();
            }
            // @ts-expect-error safe to assign
            this.emptyTexture2D = this.shaderLibrary = this.state = this.gpu = this.gl = null;
            // @ts-expect-error safe to assign
            this.emptyTextureCube = null;
        }
        this._isDestroyed = true;
    };
    Object.defineProperty(GLGPURenderer.prototype, "height", {
        get: function () {
            var _a;
            return (_a = this.gl) === null || _a === void 0 ? void 0 : _a.drawingBufferHeight;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLGPURenderer.prototype, "width", {
        get: function () {
            var _a;
            return (_a = this.gl) === null || _a === void 0 ? void 0 : _a.drawingBufferWidth;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLGPURenderer.prototype, "canvas", {
        get: function () {
            return this.gl.canvas;
        },
        enumerable: false,
        configurable: true
    });
    GLGPURenderer.prototype.createRenderFrame = function (options) {
        throw Error();
    };
    return GLGPURenderer;
}());

var g$1;
function getDefaultGPUCapability() {
    if (!g$1) {
        g$1 = new GLGPUCapability({});
    }
    return g$1;
}

var CanvasEmpty = /** @class */ (function () {
    function CanvasEmpty() {
        this.width = 0;
        this.height = 0;
        this.style = {};
    }
    CanvasEmpty.prototype.addEventListener = function (name, handler) {
    };
    CanvasEmpty.prototype.removeEventListener = function (name, handler) {
    };
    return CanvasEmpty;
}());

var RendererLostReason;
(function (RendererLostReason) {
    RendererLostReason[RendererLostReason["unknown"] = 0] = "unknown";
    RendererLostReason[RendererLostReason["removeByParent"] = 1] = "removeByParent";
    RendererLostReason[RendererLostReason["glContextLost"] = 2] = "glContextLost";
})(RendererLostReason || (RendererLostReason = {}));

/**
 * 客户端创建对象，iOS和android
 */
var ResourcePlatform;
(function (ResourcePlatform) {
    ResourcePlatform[ResourcePlatform["iOS"] = 1] = "iOS";
    ResourcePlatform[ResourcePlatform["android"] = 2] = "android";
})(ResourcePlatform || (ResourcePlatform = {}));

var PredyVideoDecoderStatus;
(function (PredyVideoDecoderStatus) {
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["init"] = 0] = "init";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["loading"] = 1] = "loading";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["metadataReady"] = 2] = "metadataReady";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["seekingFrame"] = 3] = "seekingFrame";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["frameReady"] = 4] = "frameReady";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["destroyed"] = 5] = "destroyed";
    PredyVideoDecoderStatus[PredyVideoDecoderStatus["error"] = 44] = "error";
})(PredyVideoDecoderStatus || (PredyVideoDecoderStatus = {}));

var GLRenderBuffer = /** @class */ (function () {
    function GLRenderBuffer(renderer, options) {
        var _a;
        this.storageType = options.storageType;
        this.renderer = renderer;
        this.glHandle = renderer.createGLRenderBuffer(this);
        this.internalFormat = this.format = options.format;
        this.attachment = options.attachment;
        this.size = [0, 0];
        this.multiSample = (_a = options.multisample) !== null && _a !== void 0 ? _a : 0;
    }
    GLRenderBuffer.prototype.setSize = function (width, height) {
        if (width !== this.size[0] || height !== this.size[1]) {
            var internalFormat = this.internalFormat;
            var state = this.renderer.state;
            var gl = this.renderer.gl;
            state.bindRenderBuffer(gl.RENDERBUFFER, this.glHandle);
            if (width && height) {
                gl.renderbufferStorage(gl.RENDERBUFFER, internalFormat, this.size[0] = width, this.size[1] = height);
                if (this.multiSample > 1) {
                    var if2 = internalFormat === gl.DEPTH_STENCIL ? gl.DEPTH24_STENCIL8 : internalFormat;
                    gl.renderbufferStorageMultisample(gl.RENDERBUFFER, this.multiSample, if2, width, height);
                }
            }
            else {
                consoleError("invalid render buffer size ".concat(width, "x").concat(height));
            }
        }
        return this;
    };
    GLRenderBuffer.prototype.destroy = function () {
        if (this.renderer) {
            this.renderer.deleteGLRenderBuffer(this);
            //@ts-expect-error safe to assign
            this.renderer = this.glHandle = this.ready = null;
        }
    };
    return GLRenderBuffer;
}());

var seed$5 = 1;
var GLFrameBuffer = /** @class */ (function () {
    function GLFrameBuffer(options, renderer) {
        var _a;
        this.multisampleRbs = [];
        this.renderer = renderer;
        this.depthStencilStorageType = ((_a = options.depthStencilAttachment) === null || _a === void 0 ? void 0 : _a.storageType) || exports.RenderPassAttachmentStorageType.none;
        this.viewport = options.viewport;
        this.isCustomViewport = !!options.isCustomViewport;
        this.viewportScale = options.viewportScale || 1;
        this.name = options.name || ('GLFrameBuffer' + seed$5++);
        this.storeAction = options.storeAction;
        this._attachmentHandles = [];
        this.multisample = renderer.level > 1 ? options.multisample || 0 : 0;
        this.checkOptions(options);
    }
    Object.defineProperty(GLFrameBuffer.prototype, "stencilStorage", {
        get: function () {
            var storageType = this.depthStencilStorageType;
            if (storageType !== exports.RenderPassAttachmentStorageType.depth_16_opaque) {
                return this.depthStencilRenderBuffer;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GLFrameBuffer.prototype, "depthStorage", {
        get: function () {
            if (this.depthStencilStorageType !== exports.RenderPassAttachmentStorageType.stencil_8_opaque) {
                return this.depthStencilRenderBuffer;
            }
        },
        enumerable: false,
        configurable: true
    });
    GLFrameBuffer.prototype._getHandles = function () {
        var handles = this._attachmentHandles;
        handles.length = 0;
        this.colorTextures.forEach(function (c) { return arrAdd(handles, c.glHandle); });
        if (this.stencilTexture) {
            arrAdd(handles, this.stencilTexture.glHandle);
        }
        if (this.depthTexture) {
            arrAdd(handles, this.depthTexture.glHandle);
        }
    };
    GLFrameBuffer.prototype.checkOptions = function (options) {
        var _a, _b;
        var renderer = this.renderer;
        var capability = renderer.gpu.capability;
        var depthStencilAttachment = options.depthStencilAttachment || { storageType: exports.RenderPassAttachmentStorageType.none };
        var willUseFbo = options.attachments.length > 0;
        var willMultisample = this.multisample > 1;
        this.externalStorage = false;
        var separateDepthStencil = true;
        if (options.attachments.length > 1 && !capability.drawBuffers) {
            throw Error('multiple color attachments not support');
        }
        var optDepthStencilTex = (_b = (_a = options.depthStencilAttachment) === null || _a === void 0 ? void 0 : _a.texture) === null || _b === void 0 ? void 0 : _b.internal;
        var readableDepthStencilTextures = capability.readableDepthStencilTextures;
        this.colorTextures = options.attachments.slice();
        if (!willUseFbo && depthStencilAttachment.storageType !== exports.RenderPassAttachmentStorageType.none) {
            throw Error('use depth stencil attachment without color attachments');
        }
        if (willUseFbo) {
            this.fbo = renderer.createGLFrameBuffer(this, this.name);
        }
        if (willMultisample) {
            this.multisampleFbo = renderer.createGLFrameBuffer(this, this.name + '_multisample');
        }
        var storageType = depthStencilAttachment.storageType;
        if (storageType === exports.RenderPassAttachmentStorageType.depth_stencil_opaque) {
            if (depthStencilAttachment.storage) {
                if (depthStencilAttachment.storage instanceof GLRenderBuffer) {
                    if (this.multisample !== depthStencilAttachment.storage.multiSample && this.multisample > 1) {
                        throw Error('fbo multisample not eql depth stencil attachment');
                    }
                    this.depthStencilRenderBuffer = depthStencilAttachment.storage;
                    this.externalStorage = true;
                }
                else {
                    throw Error('invalid depth stencil attachment storage');
                }
            }
            else {
                this.depthStencilRenderBuffer = new GLRenderBuffer(renderer, {
                    format: constants.DEPTH_STENCIL,
                    attachment: constants.DEPTH_STENCIL_ATTACHMENT,
                    multisample: this.multisample,
                    storageType: storageType,
                });
            }
            separateDepthStencil = false;
        }
        else if (storageType === exports.RenderPassAttachmentStorageType.depth_16_opaque) {
            if (depthStencilAttachment.storage) {
                if (this.multisample !== depthStencilAttachment.storage.multiSample && this.multisample > 1) {
                    throw Error('fbo multisample not eql depth attachment');
                }
                if (depthStencilAttachment.storage instanceof GLRenderBuffer) {
                    this.depthStencilRenderBuffer = depthStencilAttachment.storage;
                    this.externalStorage = true;
                }
                else {
                    throw Error('invalid depth attachment storage');
                }
            }
            else {
                this.depthStencilRenderBuffer = new GLRenderBuffer(renderer, {
                    attachment: constants.DEPTH_ATTACHMENT,
                    multisample: this.multisample,
                    format: constants.DEPTH_COMPONENT16,
                    storageType: storageType,
                });
            }
        }
        else if (storageType === exports.RenderPassAttachmentStorageType.stencil_8_opaque) {
            if (depthStencilAttachment.storage) {
                if (depthStencilAttachment.storage instanceof GLRenderBuffer) {
                    if (this.multisample !== depthStencilAttachment.storage.multiSample && this.multisample > 1) {
                        throw Error('fbo multisample not eql stencil attachment');
                    }
                    this.depthStencilRenderBuffer = depthStencilAttachment.storage;
                    this.externalStorage = true;
                }
                else {
                    throw Error('invalid stencil attachment storage');
                }
            }
            else {
                this.depthStencilRenderBuffer = new GLRenderBuffer(renderer, {
                    attachment: constants.STENCIL_ATTACHMENT,
                    format: constants.STENCIL_INDEX8,
                    multisample: this.multisample,
                    storageType: storageType,
                });
            }
        }
        else if (storageType === exports.RenderPassAttachmentStorageType.depth_16_texture) {
            if (!readableDepthStencilTextures) {
                throw Error('depth texture is not support in framebuffer');
            }
            this.depthTexture = optDepthStencilTex || new GLTexture({
                sourceType: exports.TextureSourceType.framebuffer,
                format: constants.DEPTH_COMPONENT,
                internalFormat: renderer.gpu.internalFormatDepth16,
                type: constants.UNSIGNED_SHORT,
                name: "".concat(this.name, "##depthTex"),
            }, renderer);
        }
        else if (storageType === exports.RenderPassAttachmentStorageType.depth_24_stencil_8_texture) {
            if (!readableDepthStencilTextures) {
                throw Error('depth stencil texture is not support in framebuffer');
            }
            this.depthTexture = this.stencilTexture = optDepthStencilTex || new GLTexture({
                sourceType: exports.TextureSourceType.framebuffer,
                format: constants.DEPTH_STENCIL,
                internalFormat: renderer.gpu.internalFormatDepth24_stencil8,
                type: renderer.gpu.UNSIGNED_INT_24_8,
                name: "".concat(this.name, "##dpthStclTex"),
            }, renderer);
            separateDepthStencil = true;
        }
        this.storeInvalidAttachments = this.getStoreAttachments(this.storeAction, separateDepthStencil);
        this._getHandles();
    };
    GLFrameBuffer.prototype.getStoreAttachments = function (storeAction, separateDepthStencil) {
        var gl = this.renderer.gl;
        var colorLen = this.colorTextures.length;
        if (storeAction && this.renderer.gpu.level == 2 && colorLen > 0) {
            var attachments = [];
            if (storeAction.depthAction === exports.TextureStoreAction.clear && this.depthStorage) {
                arrAdd(attachments, separateDepthStencil ? gl.DEPTH_ATTACHMENT : gl.DEPTH_STENCIL_ATTACHMENT);
            }
            if (storeAction.stencilAction === exports.TextureStoreAction.clear && this.stencilStorage) {
                arrAdd(attachments, separateDepthStencil ? gl.STENCIL_ATTACHMENT : gl.DEPTH_STENCIL_ATTACHMENT);
            }
            if (storeAction.colorAction === exports.TextureStoreAction.clear) {
                for (var i = 0; i < colorLen; i++) {
                    arrAdd(attachments, gl["COLOR_ATTACHMENT".concat(i)]);
                }
            }
            return attachments;
        }
    };
    GLFrameBuffer.prototype.unbind = function () {
        var att = this.storeInvalidAttachments;
        this.resolveMultiSample();
        if (att && att.length) {
            var gl = this.renderer.gl;
            gl.invalidateFramebuffer(gl.FRAMEBUFFER, att);
        }
        var state = this.renderer.state;
        state.bindSystemFramebuffer();
    };
    GLFrameBuffer.prototype.bind = function () {
        var gl = this.renderer.gl;
        var state = this.renderer.state;
        var FRAMEBUFFER = gl.FRAMEBUFFER;
        var viewport = this.viewport;
        var multisampleFbo = this.multisampleFbo;
        if (multisampleFbo) {
            state.bindFramebuffer(FRAMEBUFFER, multisampleFbo);
            state.viewport(viewport[0], viewport[1], viewport[2], viewport[3]);
        }
        else if (this.fbo) {
            state.bindFramebuffer(FRAMEBUFFER, this.fbo);
            state.viewport(viewport[0], viewport[1], viewport[2], viewport[3]);
            var r_1 = this.renderer.emptyTexture2D.glHandle;
            var handles_1 = this._attachmentHandles;
            //in case frame texture loop
            forEach(state._textureUnitDict, function (t, unit) {
                if (t !== r_1 && handles_1.includes(t)) {
                    state.activeTexture(+unit);
                    state.bindTexture(constants.TEXTURE_2D, r_1, true);
                }
            });
        }
        if (!this.ready) {
            var _a = this, depthStencilRenderBuffer = _a.depthStencilRenderBuffer, depthTexture = _a.depthTexture, stencilTexture = _a.stencilTexture;
            state.activeTexture(gl.TEXTURE0);
            if (depthStencilRenderBuffer) {
                depthStencilRenderBuffer.setSize(viewport[2], viewport[3]);
                gl.framebufferRenderbuffer(FRAMEBUFFER, depthStencilRenderBuffer.attachment, gl.RENDERBUFFER, depthStencilRenderBuffer.glHandle);
            }
            else if (depthTexture) {
                if (multisampleFbo) {
                    var attachment_1 = gl.DEPTH_ATTACHMENT;
                    var format = gl.DEPTH_COMPONENT16;
                    if (this.depthStencilStorageType === exports.RenderPassAttachmentStorageType.depth_24_stencil_8_texture) {
                        attachment_1 = gl.DEPTH_STENCIL_ATTACHMENT;
                        format = gl.DEPTH24_STENCIL8;
                    }
                    var renderBuffer = new GLRenderBuffer(this.renderer, {
                        storageType: this.depthStencilStorageType,
                        attachment: attachment_1,
                        format: format,
                        multisample: this.multisample,
                    });
                    gl.bindFramebuffer(gl.FRAMEBUFFER, multisampleFbo);
                    this.multisampleRbs.push(renderBuffer);
                    renderBuffer.setSize(viewport[2], viewport[3]);
                    gl.framebufferRenderbuffer(gl.FRAMEBUFFER, attachment_1, gl.RENDERBUFFER, renderBuffer.glHandle);
                    gl.bindFramebuffer(gl.FRAMEBUFFER, this.fbo);
                }
                depthTexture.update({
                    sourceType: exports.TextureSourceType.framebuffer,
                    data: { width: viewport[2], height: viewport[3] },
                });
                var attachment = depthTexture && stencilTexture ? gl.DEPTH_STENCIL_ATTACHMENT : gl.DEPTH_ATTACHMENT;
                gl.framebufferTexture2D(FRAMEBUFFER, attachment, gl.TEXTURE_2D, depthTexture.glHandle, 0);
            }
            this.resetColorTextures(this.colorTextures);
            [multisampleFbo, this.fbo].forEach(function (fbo) {
                if (fbo) {
                    gl.bindFramebuffer(gl.FRAMEBUFFER, fbo);
                    var status_1 = gl.checkFramebufferStatus(FRAMEBUFFER);
                    if (status_1 !== gl.FRAMEBUFFER_COMPLETE) {
                        var error = gl.getError();
                        throw Error("framebuffer failed status ".concat(status_1, " error:").concat(error));
                    }
                }
            });
            //@ts-expect-error safe to assign
            this.ready = true;
        }
    };
    GLFrameBuffer.prototype.resolveMultiSample = function () {
        var multisampleFbo = this.multisampleFbo;
        var fbo = this.fbo;
        if (multisampleFbo && fbo) {
            var gl = this.renderer.gl;
            gl.bindFramebuffer(gl.READ_FRAMEBUFFER, multisampleFbo);
            gl.bindFramebuffer(gl.DRAW_FRAMEBUFFER, fbo);
            var vp = this.viewport;
            var bit = gl.COLOR_BUFFER_BIT;
            if (this.depthTexture) {
                bit = bit | gl.DEPTH_BUFFER_BIT;
            }
            gl.blitFramebuffer(0, 0, vp[2], vp[3], // Source region
            0, 0, vp[2], vp[3], // Destination region
            bit, gl.LINEAR // Buffer mask and filter
            );
            gl.bindFramebuffer(gl.FRAMEBUFFER, multisampleFbo);
        }
    };
    GLFrameBuffer.prototype.resetColorTextures = function (colors) {
        var _this = this;
        var gl = this.renderer.gl;
        var gpu = this.renderer.gpu;
        var viewport = this.viewport;
        var data = { width: viewport[2], height: viewport[3] };
        var buffers = [];
        if (colors) {
            this.colorTextures = colors.slice();
        }
        this.renderer.state.activeTexture(gl.TEXTURE0);
        var multisampleFBO = this.multisampleFbo;
        this.colorTextures.forEach(function (tex, index) {
            tex.update({ sourceType: exports.TextureSourceType.framebuffer, data: data });
            if (multisampleFBO) {
                gl.bindFramebuffer(gl.FRAMEBUFFER, multisampleFBO);
                var renderBuffer = new GLRenderBuffer(_this.renderer, {
                    format: gl.RGBA8,
                    attachment: gl.COLOR_ATTACHMENT0 + index,
                    storageType: exports.RenderPassAttachmentStorageType.color,
                    multisample: _this.multisample,
                });
                _this.multisampleRbs.push(renderBuffer);
                renderBuffer.setSize(tex.width, tex.height);
                gl.framebufferRenderbuffer(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0 + index, gl.RENDERBUFFER, renderBuffer.glHandle);
            }
            gl.bindFramebuffer(gl.FRAMEBUFFER, _this.fbo);
            gpu.framebufferTexture2D(gl, gl.FRAMEBUFFER, index, gl.TEXTURE_2D, tex.glHandle);
            buffers.push(true);
        });
        gpu.drawBuffers(gl, buffers);
        this._getHandles();
    };
    GLFrameBuffer.prototype.destroy = function (opt) {
        var _a, _b;
        var renderer = this.renderer;
        if (renderer) {
            renderer.deleteGLFrameBuffer(this);
            delete this.fbo;
            var clearAttachment = (opt === null || opt === void 0 ? void 0 : opt.depthStencilAttachment) ? opt.depthStencilAttachment : exports.RenderPassDestroyAttachmentType.force;
            if (clearAttachment === exports.RenderPassDestroyAttachmentType.force || (clearAttachment === exports.RenderPassDestroyAttachmentType.keepExternal && !this.externalStorage)) {
                (_a = this.depthStencilRenderBuffer) === null || _a === void 0 ? void 0 : _a.destroy();
                (_b = this.depthTexture) === null || _b === void 0 ? void 0 : _b.destroy();
            }
            //@ts-expect-error safe to assign
            this.renderer = this.depthStencilRenderBuffer = null;
        }
    };
    GLFrameBuffer.prototype.resize = function (x, y, width, height) {
        var vp = this.viewport;
        if (vp[0] !== x || vp[1] !== y || vp[2] !== width || vp[3] !== height) {
            //@ts-expect-error safe to assign
            this.viewport = [x, y, width, height];
            //@ts-expect-error safe to assign
            this.ready = false;
            this.bind();
        }
    };
    return GLFrameBuffer;
}());

// const imageBitMapAvailable = typeof ImageBitmap === 'function' && typeof createImageBitmap == 'function';
var imageBitMapAvailable = false; //never use imagebitmap because its dark edge
function requestAsync(url, options) {
    var opt = options || {};
    return new Promise(function (resolve, reject) {
        var xhr = new XMLHttpRequest();
        xhr.responseType = opt.responseType || 'json';
        xhr.addEventListener('load', function () { return resolve(xhr.response); });
        xhr.addEventListener('error', reject);
        xhr.open(opt.method || 'get', url);
        xhr.send(opt.data);
    });
}
function loadImageAsync(imgOrURL, options) {
    var img;
    var revoke = options === null || options === void 0 ? void 0 : options.revokeURL;
    if (typeof imgOrURL === 'string') {
        if ((options === null || options === void 0 ? void 0 : options.asImageBitMap) && imageBitMapAvailable) {
            return requestAsync(imgOrURL, { responseType: 'blob' }).then(function (blob) { return createImageBitmap(blob); });
        }
        var src = imgOrURL;
        img = new Image();
        if (!/^data:/.test(src)) {
            img.crossOrigin = '*';
        }
        img.src = src;
    }
    else {
        img = imgOrURL;
        if ((options === null || options === void 0 ? void 0 : options.asImageBitMap) && imageBitMapAvailable) {
            return createImageBitmap(img);
        }
        if (imgOrURL instanceof Blob) {
            img = new Image();
            img.src = URL.createObjectURL(imgOrURL);
            revoke = true;
        }
    }
    if (img.complete) {
        return Promise.resolve(img);
    }
    return new Promise(function (resolve, reject) {
        img.onload = function () {
            img.onload = null;
            if (revoke) {
                URL.revokeObjectURL(img.src);
            }
            return resolve(img);
        };
        img.onerror = function (err) {
            img.onerror = null;
            if (revoke) {
                URL.revokeObjectURL(img.src);
            }
            return reject(err);
        };
    });
}

var HEADER_LEN = 12 + 13 * 4; // identifier + header elements (not including key value meta-data pairs)
var COMPRESSED_2D = 0; // uses a gl.compressedTexImage2D()
//const COMPRESSED_3D = 1; // uses a gl.compressedTexImage3D()
var TEX_2D = 2; // uses a gl.texImage2D()
//const TEX_3D = 3; // uses a gl.texImage3D()
var KhronosTextureContainer = /** @class */ (function () {
    function KhronosTextureContainer(arrayBuffer, baseOffset) {
        if (baseOffset === void 0) { baseOffset = 0; }
        this.arrayBuffer = arrayBuffer;
        this.baseOffset = baseOffset;
        // Test that it is a ktx formatted file, based on the first 12 bytes, character representation is:
        // '´', 'K', 'T', 'X', ' ', '1', '1', 'ª', '\r', '\n', '\x1A', '\n'
        // 0xAB, 0x4B, 0x54, 0x58, 0x20, 0x31, 0x31, 0xBB, 0x0D, 0x0A, 0x1A, 0x0A
        var identifier = new Uint8Array(this.arrayBuffer, this.baseOffset, 12);
        if (identifier[0] !== 0xab ||
            identifier[1] !== 0x4b ||
            identifier[2] !== 0x54 ||
            identifier[3] !== 0x58 ||
            identifier[4] !== 0x20 ||
            identifier[5] !== 0x31 ||
            identifier[6] !== 0x31 ||
            identifier[7] !== 0xbb ||
            identifier[8] !== 0x0d ||
            identifier[9] !== 0x0a ||
            identifier[10] !== 0x1a ||
            identifier[11] !== 0x0a) {
            throw Error('texture missing KTX 1.1 identifier');
        }
        // load the reset of the header in native 32 bit uint
        var dataSize = Uint32Array.BYTES_PER_ELEMENT;
        var headerDataView = new DataView(this.arrayBuffer, this.baseOffset + 12, 13 * dataSize);
        var endianness = headerDataView.getUint32(0, true);
        var littleEndian = endianness === 0x04030201;
        this.glType = headerDataView.getUint32(1 * dataSize, littleEndian); // must be 0 for compressed textures
        this.glTypeSize = headerDataView.getUint32(2 * dataSize, littleEndian); // must be 1 for compressed textures
        this.glFormat = headerDataView.getUint32(3 * dataSize, littleEndian); // must be 0 for compressed textures
        this.glInternalFormat = headerDataView.getUint32(4 * dataSize, littleEndian); // the value of arg passed to gl.compressedTexImage2D(,,x,,,,)
        this.glBaseInternalFormat = headerDataView.getUint32(5 * dataSize, littleEndian); // specify GL_RGB, GL_RGBA, GL_ALPHA, etc (un-compressed only)
        this.pixelWidth = headerDataView.getUint32(6 * dataSize, littleEndian); // level 0 value of arg passed to gl.compressedTexImage2D(,,,x,,,)
        this.pixelHeight = headerDataView.getUint32(7 * dataSize, littleEndian); // level 0 value of arg passed to gl.compressedTexImage2D(,,,,x,,)
        this.pixelDepth = headerDataView.getUint32(8 * dataSize, littleEndian); // level 0 value of arg passed to gl.compressedTexImage3D(,,,,,x,,)
        this.numberOfArrayElements = headerDataView.getUint32(9 * dataSize, littleEndian); // used for texture arrays
        this.numberOfFaces = headerDataView.getUint32(10 * dataSize, littleEndian); // used for cubemap textures, should either be 1 or 6
        this.numberOfMipmapLevels = headerDataView.getUint32(11 * dataSize, littleEndian); // number of levels; disregard possibility of 0 for compressed textures
        this.bytesOfKeyValueData = headerDataView.getUint32(12 * dataSize, littleEndian); // the amount of space after the header for meta-data
        // value of zero is an indication to generate mipmaps @ runtime.  Not usually allowed for compressed, so disregard.
        this.numberOfMipmapLevels = Math.max(1, this.numberOfMipmapLevels);
        if (this.pixelHeight === 0 || this.pixelDepth !== 0) {
            //consoleWarn('only 2D textures currently supported');
            return;
        }
        if (this.numberOfArrayElements !== 0) {
            //consoleWarn('texture arrays not currently supported');
            return;
        }
        // we now have a completely validated file, so could use existence of loadType as success
        // would need to make this more elaborate & adjust checks above to support more than one load type
        if (this.glType === 0) {
            this.loadType = COMPRESSED_2D;
        }
        else {
            this.loadType = TEX_2D;
        }
    }
    KhronosTextureContainer.prototype.mipmaps = function (loadMipmaps) {
        var mipmaps = [];
        // initialize width & height for level 1
        var dataOffset = HEADER_LEN + this.bytesOfKeyValueData;
        var width = this.pixelWidth;
        var height = this.pixelHeight;
        var mipmapCount = loadMipmaps ? this.numberOfMipmapLevels : 1;
        for (var level = 0; level < mipmapCount; level++) {
            var imageSize = new Int32Array(this.arrayBuffer, this.baseOffset + dataOffset, 1)[0]; // size per face, since not supporting array cubemaps
            for (var face = 0; face < this.numberOfFaces; face++) {
                var byteArray = new Uint8Array(this.arrayBuffer, this.baseOffset + dataOffset + 4, imageSize);
                mipmaps.push({
                    data: byteArray,
                    width: width,
                    height: height,
                });
                dataOffset += imageSize + 4; // size of the image + 4 for the imageSize field
                dataOffset += 3 - ((imageSize + 3) % 4); // add padding for odd sized image
            }
            width = Math.max(1.0, width * 0.5);
            height = Math.max(1.0, height * 0.5);
        }
        return mipmaps;
    };
    return KhronosTextureContainer;
}());
function getCompressedTextureOptions(data) {
    var ktx = new KhronosTextureContainer(data);
    var useMipmaps = ktx.numberOfMipmapLevels >= Math.floor(Math.log2(Math.max(ktx.pixelWidth, ktx.pixelHeight)) + 1);
    return {
        sourceType: exports.TextureSourceType.compressed,
        type: constants.UNSIGNED_BYTE,
        target: ktx.numberOfFaces === 6 ? constants.TEXTURE_CUBE_MAP : constants.TEXTURE_2D,
        format: ktx.glInternalFormat,
        internalFormat: ktx.glInternalFormat,
        mipmaps: ktx.mipmaps(useMipmaps),
    };
}

var loadOptions = { asImageBitMap: true };
var MarsTextureFactory = /** @class */ (function () {
    function MarsTextureFactory() {
        this.reloadPending = {};
    }
    MarsTextureFactory.prototype.loadMipmapImagesAsync = function (pointers, bin) {
        return Promise.all(pointers.map(function (pointer) {
            var blob = new Blob([new Uint8Array(bin, pointer[0], pointer[1])]);
            return loadImageAsync(blob, { asImageBitMap: true });
        }));
    };
    MarsTextureFactory.prototype.loadImageAsync = function (url) {
        return loadImageAsync(url, loadOptions);
    };
    MarsTextureFactory.prototype.requestBinaryAsync = function (url) {
        return requestAsync(url, { responseType: 'arraybuffer' });
    };
    MarsTextureFactory.prototype.loadImageBinaryAsync = function (binary, mime) {
        var blob = binary;
        if (!(binary instanceof Blob)) {
            blob = new Blob([binary], { type: mime || 'image/png' });
        }
        if (imageBitMapAvailable$1) {
            return createImageBitmap(blob);
        }
        var url = URL.createObjectURL(blob);
        return loadImageAsync(url, { revokeURL: true });
    };
    MarsTextureFactory.prototype.canOffloadTexture = function (texture) {
        var data = texture.options.sourceFrom;
        if (data) {
            var type = data.type;
            if (type === exports.TextureSourceType.compressed || type === exports.TextureSourceType.image) {
                if (data.target === constants.TEXTURE_CUBE_MAP) {
                    return isObj(data.map);
                }
                return isStr(data.url, true);
            }
            if (type === exports.TextureSourceType.mipmaps) {
                if (data.bin) {
                    return data.mipmaps.length > 0;
                }
                if (data.target === constants.TEXTURE_CUBE_MAP) {
                    return data.maps.every(function (map) { return isObj(map); });
                }
                return data.urls.every(function (url) { return isStr(url, true); });
            }
        }
        return false;
    };
    MarsTextureFactory.prototype.loadSourceAsync = function (sourceFrom, config) {
        var _this = this;
        // cube without mipmap
        if (sourceFrom.target === constants.TEXTURE_CUBE_MAP && sourceFrom.type !== exports.TextureSourceType.mipmaps) {
            return this._loadCubeMapAsync(sourceFrom.map).then(function (cube) {
                return Object.assign({}, config, {
                    sourceType: exports.TextureSourceType.image,
                    cube: cube,
                    sourceFrom: {
                        type: exports.TextureSourceType.image,
                        map: Object.assign({}, sourceFrom.map),
                        target: constants.TEXTURE_CUBE_MAP,
                    },
                    target: constants.TEXTURE_CUBE_MAP,
                });
            }, catchError);
        }
        else if (sourceFrom.type === exports.TextureSourceType.image) {
            // image without mipmap
            return this.loadImageAsync(sourceFrom.url).then(function (image) { return Object.assign({}, config, {
                image: image,
                sourceType: exports.TextureSourceType.image,
                sourceFrom: {
                    url: sourceFrom.url,
                    type: sourceFrom.type,
                    target: constants.TEXTURE_2D,
                },
            }); }, catchError);
        }
        else if (sourceFrom.type === exports.TextureSourceType.video) {
            return this._loadVideoAsync((sourceFrom).url).then(function (video) { return Object.assign({}, config, {
                video: video,
                sourceType: exports.TextureSourceType.video,
            }); }, catchError);
        }
        else if (sourceFrom.type === exports.TextureSourceType.compressed) {
            return this.requestBinaryAsync(sourceFrom.url).then(function (arrayBuffer) {
                return Object.assign(getCompressedTextureOptions(arrayBuffer), config, {
                    sourceFrom: { url: sourceFrom.url, type: exports.TextureSourceType.compressed },
                });
            }, catchError);
        }
        else if (sourceFrom.type === exports.TextureSourceType.mipmaps) {
            var target = sourceFrom.target;
            if (sourceFrom.bin) {
                return requestAsync(sourceFrom.bin, { responseType: 'arraybuffer' })
                    .then(function (data) {
                    if (sourceFrom.target === constants.TEXTURE_CUBE_MAP) {
                        var source = sourceFrom;
                        return Promise.all(source.mipmaps.map(function (mipmaps) { return _this.loadMipmapImagesAsync(mipmaps, data); }));
                    }
                    else {
                        var source = sourceFrom;
                        return _this.loadMipmapImagesAsync(source.mipmaps, data);
                    }
                }).then(function (mipmaps) {
                    var target = sourceFrom.target || constants.TEXTURE_2D;
                    var mipmapsSource = sourceFrom.mipmaps;
                    var source = {
                        mipmaps: mipmaps,
                        target: target,
                        sourceType: exports.TextureSourceType.mipmaps,
                        sourceFrom: {
                            bin: sourceFrom.bin,
                            mipmaps: target === constants.TEXTURE_2D ? mipmapsSource.slice() : mipmapsSource.map(function (s) { return s.slice(); }),
                            target: target,
                            type: exports.TextureSourceType.mipmaps,
                        },
                    };
                    return Object.assign({}, config, source);
                });
            }
            if (target === constants.TEXTURE_2D || !target) {
                var urls_1 = sourceFrom.urls;
                return Promise.all(urls_1.map(function (url) { return _this.loadImageAsync(url); })).then(function (mipmaps) {
                    return Object.assign({}, config, {
                        target: constants.TEXTURE_2D,
                        sourceType: exports.TextureSourceType.mipmaps,
                        mipmaps: mipmaps,
                        sourceFrom: {
                            type: sourceFrom.type,
                            urls: urls_1.slice(),
                            target: constants.TEXTURE_2D,
                        },
                    });
                }, catchError);
            }
            else if (target === constants.TEXTURE_CUBE_MAP) {
                var maps = sourceFrom.maps;
                return Promise.all(maps.map(function (map) { return _this._loadCubeMapAsync(map); })).then(function (mipmaps) {
                    return Object.assign({}, config, {
                        sourceType: exports.TextureSourceType.mipmaps,
                        target: constants.TEXTURE_CUBE_MAP,
                        mipmaps: mipmaps,
                        sourceFrom: {
                            target: constants.TEXTURE_CUBE_MAP,
                            type: sourceFrom.type,
                            maps: sourceFrom.maps.map(function (map) { return Object.assign({}, map); }),
                        },
                    });
                }, catchError);
            }
        }
        return Promise.reject(new Error('invalid resource type:' + sourceFrom.type));
        function catchError(error) {
            throw Error('loadFail:' + JSON.stringify(config));
        }
    };
    MarsTextureFactory.prototype._loadVideoAsync = function (url) {
        var video = document.createElement('video');
        video.setAttribute('renderer', 'standard');
        if (isObj(url)) {
            video.srcObject = url;
        }
        else {
            video.src = url;
        }
        video.crossOrigin = 'anonymous';
        video.muted = true;
        video.setAttribute('playsinline', 'playsinline');
        var p = video.play();
        return p ? p.then(function () { return video; }) : new Promise(function (resolve, reject) {
            video.addEventListener('loadeddata', function h() {
                resolve(video);
                video.removeEventListener('loadeddata', h);
            }, true);
            video.addEventListener('error', function (e) {
                reject(e);
            });
        });
    };
    MarsTextureFactory.prototype._loadCubeMapAsync = function (map) {
        var _this = this;
        return Promise.all(map.map(function (key) { return _this.loadImageAsync(key); }));
    };
    MarsTextureFactory.prototype.loadCompressedTextureFromArrayBuffer = function (arrayBuffer, options) {
        return Object.assign(getCompressedTextureOptions(arrayBuffer), options);
    };
    MarsTextureFactory.prototype.reloadTextureAsync = function (texture) {
        var _this = this;
        var id = texture.id;
        var o = this.reloadPending[id];
        if (o) {
            return o;
        }
        if (texture.options.sourceFrom) {
            return this.reloadPending[id] = this.loadSourceAsync(texture.options.sourceFrom).then(function (opt) {
                texture.updateSource(opt);
                delete _this.reloadPending[id];
                return texture;
            }).catch(function (ex) {
                delete _this.reloadPending[id];
                throw ex;
            });
        }
        return Promise.reject('no source from');
    };
    return MarsTextureFactory;
}());
var g;
function getDefaultTextureFactory() {
    if (!g) {
        g = new MarsTextureFactory();
    }
    return g;
}
function setDefaultTextureFactory(factory) {
    g = factory;
}

function closeImageBitMap(img) {
    if (imageBitMapAvailable$1) {
        if (img instanceof ImageBitmap) {
            img.close();
        }
        else if (img instanceof Array) {
            img.forEach(closeImageBitMap);
        }
        else if (isObj(img)) {
            forEach(img, closeImageBitMap);
        }
    }
}
var seed$4 = 1;
var MarsTexture = /** @class */ (function () {
    function MarsTexture(options, renderer) {
        this._isDestroyed = false;
        this.id = 'Tex' + seed$4++;
        if (options instanceof GLTexture) {
            this.sourceType = options.options.sourceType;
            this.options = options.options;
            if (!renderer) {
                throw Error('copy texture should assign renderer');
            }
            this.internal = options;
            this.renderer = renderer;
            this.name = '';
        }
        else {
            var opt = this.checkOptions(options);
            this.sourceType = opt.sourceType;
            this.options = opt;
            this.name = options.name || '';
            if (renderer) {
                this.assignRenderer(renderer);
            }
        }
    }
    Object.defineProperty(MarsTexture.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    MarsTexture.prototype.checkOptions = function (options) {
        var opt = Object.assign({
            minFilter: constants.NEAREST,
            magFilter: constants.NEAREST,
            wrapS: constants.CLAMP_TO_EDGE,
            wrapT: constants.CLAMP_TO_EDGE,
            target: options.target || constants.TEXTURE_2D,
            format: constants.RGBA,
            internalFormat: options.format || constants.RGBA,
            type: constants.UNSIGNED_BYTE,
        }, options);
        if (!opt.sourceType) {
            if (opt.image) {
                opt.sourceType = exports.TextureSourceType.image;
            }
            else if (opt.data) {
                opt.sourceType = exports.TextureSourceType.data;
            }
            else if (opt.video) {
                opt.sourceType = exports.TextureSourceType.video;
            }
            else {
                opt.sourceType = exports.TextureSourceType.none;
            }
        }
        if (!opt.sourceType) {
            throw Error('invalid source type');
        }
        return opt;
    };
    Object.defineProperty(MarsTexture.prototype, "width", {
        get: function () {
            var _a;
            return ((_a = this.internal) === null || _a === void 0 ? void 0 : _a.width) || 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsTexture.prototype, "height", {
        get: function () {
            var _a;
            return ((_a = this.internal) === null || _a === void 0 ? void 0 : _a.height) || 0;
        },
        enumerable: false,
        configurable: true
    });
    MarsTexture.prototype.assignRenderer = function (renderer) {
        // @ts-expect-error safe to assign
        this['renderer'] = renderer;
        this._assignRenderer(renderer.internal);
        return this;
    };
    MarsTexture.prototype._assignRenderer = function (renderer) {
        if (!this.internal) {
            var option = this.options;
            // @ts-expect-error safe to assign
            this['internal'] = new GLTexture(option, renderer);
            var releaseImageSource = !option.keepImageSource;
            if (option.sourceType === exports.TextureSourceType.image) {
                if (releaseImageSource) {
                    closeImageBitMap(option.image);
                    closeImageBitMap(option.cube);
                }
                //@ts-expect-error delete image memory
                delete option.image;
                //@ts-expect-error delete image memory
                delete option.cube;
            }
            else if (option.sourceType === exports.TextureSourceType.data) {
                //@ts-expect-error delete image memory
                delete option.data;
            }
            else if (option.sourceType === exports.TextureSourceType.compressed) {
                //@ts-expect-error delete image memory
                delete option.mipmaps;
            }
            else if (option.sourceType === exports.TextureSourceType.mipmaps) {
                //@ts-expect-error delete image memory
                delete option.mipmaps;
                if (releaseImageSource) {
                    closeImageBitMap(option.mipmaps);
                }
            }
        }
    };
    MarsTexture.prototype.uploadCurrentVideoFrame = function () {
        if (this.options.sourceType === exports.TextureSourceType.video && this.options.video && this.internal) {
            this.internal.update({ sourceType: exports.TextureSourceType.video, video: this.options.video });
            return true;
        }
        return false;
    };
    MarsTexture.prototype.destroy = function () {
        var _a;
        if (this.internal) {
            (_a = this.internal) === null || _a === void 0 ? void 0 : _a.destroy();
            //@ts-expect-error safe to assign
            this['internal'] = this['renderer'] = undefined;
        }
        this._isDestroyed = true;
        this._assignRenderer = throwDestroyedError;
    };
    MarsTexture.prototype.reloadDataAsync = function () {
        if (this._offloaded) {
            return getDefaultTextureFactory().reloadTextureAsync(this);
        }
        return Promise.resolve(this);
    };
    MarsTexture.prototype.offloadData = function () {
        var _a;
        if (this.internal && getDefaultTextureFactory().canOffloadTexture(this)) {
            (_a = this.internal) === null || _a === void 0 ? void 0 : _a.offloadData();
            this._offloaded = true;
        }
    };
    MarsTexture.prototype.updateSource = function (options) {
        var _a;
        // @ts-expect-error safe to assign
        this['options'] = this.checkOptions(Object.assign(this.options, options));
        // @ts-expect-error safe to assign
        this['sourceType'] = this.options.sourceType;
        (_a = this.internal) === null || _a === void 0 ? void 0 : _a.update(this.options);
    };
    return MarsTexture;
}());

var MarsRenderPassColorAttachment = /** @class */ (function () {
    function MarsRenderPassColorAttachment(options) {
        this.storageType = exports.RenderPassAttachmentStorageType.color;
        if (options.texture instanceof MarsTexture) {
            this.texture = options.texture;
            this.externalTexture = true;
        }
        else if (options.texture) {
            var texOpt = options.texture;
            this.externalTexture = false;
            this.textureOptions = {
                size: options.size,
                format: texOpt.format || constants.RGBA,
                type: texOpt.type || constants.UNSIGNED_BYTE,
                internalFormat: texOpt.internalFormat || texOpt.format || constants.RGBA,
                wrapT: texOpt.wrapT,
                wrapS: texOpt.wrapS,
                minFilter: texOpt.minFilter,
                magFilter: texOpt.magFilter,
                name: options.name,
            };
        }
        else {
            throw Error('color attachment must use texture');
        }
        this._isDestroyed = false;
        this.readable = true;
    }
    Object.defineProperty(MarsRenderPassColorAttachment.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPassColorAttachment.prototype, "size", {
        get: function () {
            var tex = this.texture;
            return tex ? [tex.width, tex.height] : [0, 0];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPassColorAttachment.prototype, "width", {
        get: function () {
            var _a;
            return ((_a = this.texture) === null || _a === void 0 ? void 0 : _a.width) || 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPassColorAttachment.prototype, "height", {
        get: function () {
            var _a;
            return ((_a = this.texture) === null || _a === void 0 ? void 0 : _a.height) || 0;
        },
        enumerable: false,
        configurable: true
    });
    MarsRenderPassColorAttachment.prototype.assignRenderer = function (renderer) {
        if (this.textureOptions) {
            var size = this.textureOptions.size || [renderer.width, renderer.height];
            this.texture = new MarsTexture(__assign(__assign({}, this.textureOptions), { sourceType: exports.TextureSourceType.framebuffer, data: { width: size[0], height: size[1] } }));
        }
        if (this.texture) {
            this.texture.assignRenderer(renderer);
        }
        if (this.multisample > 1) {
            this.multisample = Math.min(renderer.gpu.capability.maxSample, this.multisample);
        }
        return this;
    };
    MarsRenderPassColorAttachment.prototype.destroy = function () {
        var _a;
        (_a = this.texture) === null || _a === void 0 ? void 0 : _a.destroy();
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    return MarsRenderPassColorAttachment;
}());

var seed$3 = 1;
var defStoreAction = {
    colorAction: exports.TextureStoreAction.store,
    depthAction: exports.TextureStoreAction.store,
    stencilAction: exports.TextureStoreAction.store,
};
var defLoadAction = {
    colorAction: exports.TextureLoadAction.load,
    depthAction: exports.TextureLoadAction.load,
    stencilAction: exports.TextureLoadAction.load,
};
var MarsRenderPass = /** @class */ (function () {
    function MarsRenderPass(options, renderer) {
        var _a;
        this._isDestroyed = false;
        this.name = options.name || ('MarsRenderPass_' + seed$3++);
        this.priority = options.priority || 0;
        this.meshOrder = options.meshOrder || exports.RenderPassMeshOrder.ascending;
        this.meshes = (options.meshes || []).slice();
        sortByOrder(this.meshes, this.meshOrder);
        this.options = options;
        this.loadAction = Object.assign({}, defLoadAction, options.loadAction);
        this._attachments = [];
        this.semantics = new MarsSemanticMap(options.semantics);
        this.depthStencilType = ((_a = options.depthStencilAttachment) === null || _a === void 0 ? void 0 : _a.storageType) || exports.RenderPassAttachmentStorageType.none;
        this._setViewportOptions(options);
        if (renderer) {
            this.assignRenderer(renderer);
        }
        this.delegate = options.delegate || {};
        this.storeAction = Object.assign({}, defStoreAction, options.storeAction);
    }
    Object.defineProperty(MarsRenderPass.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPass.prototype, "multisample", {
        get: function () {
            var _a;
            return ((_a = this.frameBuffer) === null || _a === void 0 ? void 0 : _a.multisample) || 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPass.prototype, "attachments", {
        get: function () {
            return this._attachments;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPass.prototype, "viewport", {
        get: function () {
            var _a;
            var ret = ((_a = this.frameBuffer) === null || _a === void 0 ? void 0 : _a.viewport) || this._customViewport;
            if (ret) {
                return ret;
            }
            var renderer = this.renderer;
            var vs = this.viewportScale;
            return renderer ? [0, 0, renderer.width * vs, renderer.height * vs] : [0, 0, 0, 0];
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPass.prototype, "stencilAttachment", {
        get: function () {
            var frameBuffer = this.frameBuffer;
            if (frameBuffer) {
                return {
                    storageType: frameBuffer.depthStencilStorageType,
                    storage: frameBuffer.stencilStorage,
                    texture: frameBuffer.stencilTexture ? this._getStencilTexture(frameBuffer.stencilTexture, frameBuffer.externalStorage) : undefined,
                };
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderPass.prototype, "depthAttachment", {
        get: function () {
            var frameBuffer = this.frameBuffer;
            if (frameBuffer) {
                return {
                    storageType: frameBuffer.depthStencilStorageType,
                    storage: frameBuffer.depthStorage,
                    texture: frameBuffer.depthTexture ? this._getDepthTexture(frameBuffer.depthTexture, frameBuffer.externalStorage) : undefined,
                };
            }
        },
        enumerable: false,
        configurable: true
    });
    MarsRenderPass.prototype.bind = function () {
        if (this.frameBuffer) {
            this.frameBuffer.bind();
        }
        else {
            var state = this.renderer.internal.state;
            //在绑定的时候renderpass进行viewport的动态改变
            var vp = this.viewport;
            state.viewport(vp[0], vp[1], vp[2], vp[3]);
        }
    };
    MarsRenderPass.prototype._getDepthTexture = function (texture, external) {
        var _a;
        if (!this._depthTexture) {
            var outTex = (_a = this.options.depthStencilAttachment) === null || _a === void 0 ? void 0 : _a.texture;
            var tex = texture === (outTex === null || outTex === void 0 ? void 0 : outTex.internal) ? outTex : new MarsTexture(texture, this.renderer);
            if (!external) {
                this._depthTexture = tex;
            }
            return tex;
        }
        return this._depthTexture;
    };
    MarsRenderPass.prototype._getStencilTexture = function (texture, external) {
        var _a;
        if (!this._stencilTexture) {
            var outTex = (_a = this.options.depthStencilAttachment) === null || _a === void 0 ? void 0 : _a.texture;
            var tex = texture === (outTex === null || outTex === void 0 ? void 0 : outTex.internal) ? outTex : new MarsTexture(texture, this.renderer);
            if (!external) {
                this._stencilTexture = tex;
            }
            return tex;
        }
        return this._stencilTexture;
    };
    MarsRenderPass.prototype._setViewportOptions = function (options) {
        if (options.viewport) {
            this._isCustomViewport = true;
            this.viewportScale = 1;
            this._customViewport = options.viewport.slice(0, 4);
            if (this.frameBuffer) {
                var vp = this._customViewport;
                this.frameBuffer.isCustomViewport = false;
                this.frameBuffer.resize(vp[0], vp[1], vp[2], vp[3]);
            }
        }
        else {
            this._isCustomViewport = false;
            this.viewportScale = options.viewportScale || 1;
            if (this.frameBuffer) {
                this.frameBuffer.isCustomViewport = true;
                this.frameBuffer.viewportScale = this.viewportScale;
            }
        }
    };
    MarsRenderPass.prototype.resetColorAttachments = function (colors) {
        var _this = this;
        if (!colors.length) {
            this.resetAttachments({ attachments: [] });
        }
        if (!this.attachments.length) {
            this.resetAttachments({ attachments: colors.map(function (t) { return ({ texture: t }); }) });
        }
        else {
            var attachments = colors.map(function (texture) {
                texture.updateSource({ sourceType: exports.TextureSourceType.framebuffer });
                return new MarsRenderPassColorAttachment({ texture: texture.assignRenderer(_this.renderer) });
            });
            this._attachments.forEach(function (att) { return !att.externalTexture && att.destroy(); });
            this._attachments = attachments;
            if (this.frameBuffer) {
                this.frameBuffer.bind();
                this.frameBuffer.resetColorTextures(colors.map(function (color) { return color.internal; }));
            }
        }
    };
    MarsRenderPass.prototype.resetAttachments = function (options) {
        var ret = this.options;
        //@ts-expect-error safe to assign
        this.options = options;
        this._setViewportOptions(options);
        if (this.renderer) {
            this._resetAttachments();
        }
        return ret;
    };
    MarsRenderPass.prototype._resetAttachments = function () {
        var _a, _b;
        var renderer = this.renderer;
        var options = this.options;
        if (this._attachments.length) {
            this._attachments.forEach(function (att) { return !att.externalTexture && att.destroy(); });
            this._attachments.length = 0;
            (_a = this.frameBuffer) === null || _a === void 0 ? void 0 : _a.destroy({ depthStencilAttachment: exports.RenderPassDestroyAttachmentType.keepExternal });
            //@ts-expect-error safe to assign
            this.frameBuffer = null;
        }
        var vs = this.viewportScale;
        //renderpass的viewport相关参数都需要动态的修改
        var viewport = (this._isCustomViewport ? this._customViewport : [0, 0, renderer.width * vs, renderer.height * vs]);
        var size = [viewport[2], viewport[3]];
        var name = this.name;
        if ((_b = options.attachments) === null || _b === void 0 ? void 0 : _b.length) {
            var attachments = options.attachments.map(function (att, index) {
                var _a;
                return new MarsRenderPassColorAttachment(Object.assign({
                    size: size,
                    name: ((_a = att.texture) === null || _a === void 0 ? void 0 : _a.name) || "".concat(name, "##color_").concat(index),
                }, att)).assignRenderer(renderer);
            });
            this._attachments = attachments;
            var framebuffer = new GLFrameBuffer({
                storeAction: this.storeAction,
                name: name,
                viewport: viewport,
                multisample: options.multiSample,
                viewportScale: this.viewportScale,
                isCustomViewport: this._isCustomViewport,
                attachments: attachments.map(function (att) { return (att.texture).internal; }),
                depthStencilAttachment: options.depthStencilAttachment || { storageType: exports.RenderPassAttachmentStorageType.none },
            }, renderer.internal);
            framebuffer.bind();
            framebuffer.unbind();
            //@ts-expect-error safe to assign
            this.frameBuffer = framebuffer;
        }
        else {
            this._attachments.length = 0;
        }
    };
    MarsRenderPass.prototype.unbind = function () {
        var state = this.renderer.internal.state;
        if (this.frameBuffer) {
            this.frameBuffer.unbind();
        }
        else {
            state.bindSystemFramebuffer();
        }
    };
    MarsRenderPass.prototype.assignRenderer = function (renderer) {
        if (!this.renderer) {
            //@ts-expect-error safe to assign
            this.renderer = renderer;
            this._resetAttachments();
        }
        return this;
    };
    MarsRenderPass.prototype.destroy = function (options) {
        var _a, _b;
        var destroyMeshOption = (options === null || options === void 0 ? void 0 : options.meshes) || undefined;
        if (destroyMeshOption !== exports.DestroyOptions.keep) {
            this.meshes.forEach(function (mesh) {
                mesh.destroy(destroyMeshOption);
            });
        }
        this.meshes.length = 0;
        var colorOpt = (options === null || options === void 0 ? void 0 : options.colorAttachment) ? options.colorAttachment : exports.RenderPassDestroyAttachmentType.force;
        this._attachments.forEach(function (att) {
            var keep = (att.externalTexture && colorOpt === exports.RenderPassDestroyAttachmentType.keepExternal) || colorOpt === exports.RenderPassDestroyAttachmentType.keep;
            if (!keep) {
                att.destroy();
            }
        });
        this._attachments.length = 0;
        if ((options === null || options === void 0 ? void 0 : options.semantics) !== exports.DestroyOptions.keep) {
            this.semantics.destroy();
        }
        var depthStencilOpt = (options === null || options === void 0 ? void 0 : options.depthStencilAttachment) ? options.depthStencilAttachment : exports.RenderPassDestroyAttachmentType.force;
        var fbo = this.frameBuffer;
        if (fbo) {
            fbo.destroy({ depthStencilAttachment: depthStencilOpt });
            var keep = (fbo.externalStorage && depthStencilOpt === exports.RenderPassDestroyAttachmentType.keepExternal) || depthStencilOpt === exports.RenderPassDestroyAttachmentType.keep;
            if (!keep) {
                (_a = this._stencilTexture) === null || _a === void 0 ? void 0 : _a.destroy();
                (_b = this._depthTexture) === null || _b === void 0 ? void 0 : _b.destroy();
            }
        }
        //@ts-expect-error safe to assign
        this.options = this.renderer = null;
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    MarsRenderPass.prototype.addMesh = function (mesh) {
        arrAddByOrder(this.meshes, mesh, this.meshOrder);
    };
    MarsRenderPass.prototype.removeMesh = function (mesh) {
        arrRemove(this.meshes, mesh);
    };
    MarsRenderPass.prototype.setMeshes = function (meshes) {
        var _a;
        this.meshes.length = 0;
        (_a = this.meshes).splice.apply(_a, __spreadArray([0, 0], meshes, false));
        return sortByOrder(this.meshes, this.meshOrder);
    };
    return MarsRenderPass;
}());

var GLMaterial = /** @class */ (function () {
    function GLMaterial(renderer, material) {
        this.renderer = renderer;
        this.shaderCacheId = material.shaderCacheId;
        this.states = material.states;
        this.material = material;
    }
    GLMaterial.prototype.setupStates = function () {
        var _a, _b;
        var webGLState = this.renderer.state;
        var currentState = this.states;
        //在之前已经给过默认值 这里就不用再判断undefined和null了
        webGLState.toggle(constants.SAMPLE_ALPHA_TO_COVERAGE, currentState.sampleAlphaToCoverage);
        webGLState.toggle(constants.BLEND, currentState.blending);
        webGLState.toggle(constants.DEPTH_TEST, currentState.depthTest);
        webGLState.toggle(constants.STENCIL_TEST, currentState.stencilTest);
        webGLState.toggle(constants.CULL_FACE, currentState.cullFaceEnabled);
        webGLState.toggle(constants.POLYGON_OFFSET_FILL, currentState.polygonOffsetFill);
        if (currentState.stencilTest) {
            //stencil
            webGLState.stencilMaskSeparate(constants.BACK, currentState.stencilMaskBack);
            webGLState.stencilMaskSeparate(constants.FRONT, currentState.stencilMaskFront);
            var stencilBackFunc = currentState.stencilFuncBack;
            webGLState.stencilFuncSeparate(constants.BACK, stencilBackFunc[0], stencilBackFunc[1], stencilBackFunc[2]);
            var stencilFrontFunc = currentState.stencilFuncFront;
            webGLState.stencilFuncSeparate(constants.FRONT, stencilFrontFunc[0], stencilFrontFunc[1], stencilFrontFunc[2]);
            var stencilOpBack = currentState.stencilOpBack;
            webGLState.stencilOpSeparate(constants.BACK, stencilOpBack[0], stencilOpBack[1], stencilOpBack[2]);
            var stencilOpFront = currentState.stencilOpFront;
            webGLState.stencilOpSeparate(constants.FRONT, stencilOpFront[0], stencilOpFront[1], stencilOpFront[2]);
        }
        if (currentState.blending) {
            //blend
            var blendColor = currentState.blendColor;
            webGLState.blendColor(blendColor[0], blendColor[1], blendColor[2], blendColor[3]);
            webGLState.blendEquationSeparate(currentState.blendEquationRGB, currentState.blendEquationAlpha);
            webGLState.blendFuncSeparate(currentState.blendSrc, currentState.blendDst, currentState.blendSrcAlpha, currentState.blendDstAlpha);
        }
        //color depth
        var colorMask = currentState.colorMask;
        webGLState.colorMask(colorMask[0], colorMask[1], colorMask[2], colorMask[3]);
        if (currentState.depthTest) {
            webGLState.depthMask(currentState.depthMask);
            webGLState.depthFunc(currentState.depthFunc);
            webGLState.depthRange((_a = currentState.depthRange) === null || _a === void 0 ? void 0 : _a[0], (_b = currentState.depthRange) === null || _b === void 0 ? void 0 : _b[1]);
        }
        webGLState.frontFace(currentState.frontFace);
        if (currentState.cullFaceEnabled) {
            //face
            webGLState.cullFace(currentState.cullFace);
        }
        if (currentState.polygonOffsetFill) {
            var polygonOffset = currentState.polygonOffset || [0, 0];
            webGLState.polygonOffset(polygonOffset[0], polygonOffset[1]);
        }
        // set gl states
    };
    GLMaterial.prototype.getProgram = function () {
        return this.renderer.shaderLibrary.getProgram(this.shaderCacheId);
    };
    GLMaterial.prototype.destroy = function () {
        var _a;
        var lib = (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.shaderLibrary;
        if (lib) {
            var shader = lib.getShaderResult(this.shaderCacheId);
            if (shader && !shader.shared) {
                lib.deleteShader(this.shaderCacheId);
            }
        }
        //@ts-expect-error safe to assign
        this.renderer = null;
    };
    return GLMaterial;
}());

function isUniformStruct(value) {
    return (isObj(value)) && (value.length === undefined);
}
function isUniformStructArray(value) {
    return (value) && (value.length !== undefined) && isUniformStruct(value[0]);
}
var MarsMaterialDataBlock = /** @class */ (function () {
    function MarsMaterialDataBlock(props, renderer) {
        var _this = this;
        this._isDestroyed = false;
        this._isDestroyed = false;
        this.name = props.name || 'defDataBlock';
        this._uniformValues = {};
        this._uniformFlags = {};
        this.uboBufferMap = {};
        this._uniformTextures = {};
        this._uniformValueRanges = {};
        this._keepUboData = !!props.keepUboData;
        this.uniformSemantics = props.uniformSemantics || {};
        this._uniformPrivate = {};
        if (props.uniformValues) {
            this.setUniformValues(props.uniformValues);
        }
        forEach(props.uniformTextures, function (tex, name) { return _this.setUniformTexture(name, tex); });
        if (renderer) {
            this.assignRenderer(renderer);
        }
    }
    MarsMaterialDataBlock.prototype._assignUniformValueRenderer = function (value, renderer) {
        if (renderer) {
            var assign = function (value) { return isObj(value) && value.assignRenderer && value.assignRenderer(renderer); };
            if (value instanceof Array) {
                value.forEach(assign);
            }
            else {
                assign(value);
            }
        }
    };
    MarsMaterialDataBlock.prototype.invalidAllFlags = function () {
        var f = this._uniformFlags;
        var range = this._uniformValueRanges;
        forEach(this._uniformValues, function (val, key) {
            f[key] = true;
            range[key] = [0, 0];
        });
    };
    MarsMaterialDataBlock.prototype.clearFlags = function () {
        // @ts-expect-error safe to assign
        this._uniformFlags = {};
    };
    MarsMaterialDataBlock.prototype.isDirty = function (shaderCacheId, name) {
        return this._uniformFlags[name] === true;
    };
    Object.defineProperty(MarsMaterialDataBlock.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    MarsMaterialDataBlock.prototype.setUniformTexture = function (uniformName, texture) {
        if (texture) {
            this._uniformTextures[uniformName] = texture;
            this._assignUniformValueRenderer(texture, this.renderer);
            this._uniformPrivate[uniformName] = true;
        }
        else {
            delete this._uniformTextures[uniformName];
            delete this._uniformPrivate[uniformName];
        }
    };
    MarsMaterialDataBlock.prototype.getUniformTexture = function (uniformName) {
        return this._uniformTextures[uniformName];
    };
    MarsMaterialDataBlock.prototype.assignRenderer = function (renderer) {
        var _this = this;
        if (this.renderer && renderer !== this.renderer) {
            throw Error('assign different renderer');
        }
        if (renderer && !this.renderer) {
            // @ts-expect-error safe to assign
            this.renderer = renderer;
            forEach(this._uniformTextures, function (value) {
                _this._assignUniformValueRenderer(value, renderer);
            });
        }
        return this;
    };
    MarsMaterialDataBlock.prototype.createUboBuffer = function (spec) {
        if (!this.uboBufferMap[spec.id] && this.renderer && this.name === spec.name) {
            var ubo = this.uboBufferMap[spec.id] = new UniformBlockBuffer(this.renderer.internal, spec);
            ubo.keepData = this._keepUboData;
        }
        return this.uboBufferMap[spec.id];
    };
    MarsMaterialDataBlock.prototype.setUboBuffer = function (uboBuffer) {
        uboBuffer.setValues(this._uniformValues, this._uniformFlags, this._uniformValueRanges);
    };
    MarsMaterialDataBlock.prototype.updateUniformSubData = function (name, start, count) {
        throw Error('this method has been deprecated');
    };
    MarsMaterialDataBlock.prototype.hasUniformValue = function (name) {
        return !!this._uniformPrivate[name];
    };
    MarsMaterialDataBlock.prototype.destroy = function (options) {
        if ((options === null || options === void 0 ? void 0 : options.textures) !== exports.DestroyOptions.keep) {
            forEach(this._uniformTextures, function (uniform) {
                if (uniform instanceof MarsTexture) {
                    uniform.destroy();
                }
            });
        }
        forEach(this.uboBufferMap, function (ubo) {
            ubo === null || ubo === void 0 ? void 0 : ubo.destroy();
        });
        // @ts-expect-error safe to assign
        this.uboBufferMap = {};
        this._uniformPrivate = {};
        // @ts-expect-error safe to assign
        this._uniformFlags = {};
        // @ts-expect-error safe to assign
        this._uniformValues = {};
        // @ts-expect-error safe to assign
        this._uniformTextures = {};
        // @ts-expect-error safe to assign
        this.uniformSemantics = {};
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    MarsMaterialDataBlock.prototype.getUniformValue = function (name) {
        return this._uniformValues[name];
    };
    MarsMaterialDataBlock.prototype.getUniformValues = function () {
        return this._uniformValues;
    };
    MarsMaterialDataBlock.prototype.setUniformValue = function (name, value, isSemantic) {
        var _this = this;
        if (value === undefined) {
            var originValue = this._uniformValues[name];
            if (isUniformStruct(originValue)) {
                forEach(originValue, function (data, key) {
                    var nameInStruct = name + '.' + key;
                    delete _this._uniformPrivate[nameInStruct];
                });
            }
            else if (isUniformStructArray(originValue)) {
                originValue.forEach(function (valueData, i) {
                    forEach(valueData, function (valueInStruct, key) {
                        var nameInStruct = name + '[' + i + ']' + '.' + key;
                        delete _this._uniformPrivate[nameInStruct];
                    });
                });
            }
            delete this._uniformValues[name];
            this._uniformFlags[name] = false;
            delete this._uniformPrivate[name];
        }
        else if (value instanceof MarsTexture) {
            throw Error('setUniformValue not accept texture:' + name);
        }
        else {
            this._uniformPrivate[name] = !isSemantic;
            if (isUniformStruct(value)) {
                forEach(value, function (data, key) {
                    var nameInStruct = name + '.' + key;
                    _this._uniformValues[nameInStruct] = data;
                    _this._uniformFlags[nameInStruct] = true;
                    _this._uniformPrivate[nameInStruct] = true;
                });
                // 只是用来保存结构体对象
                this._uniformValues[name] = value;
                this._uniformFlags[name] = false;
            }
            else if (isUniformStructArray(value)) {
                value.forEach(function (valueData, i) {
                    forEach(valueData, function (valueInStruct, key) {
                        var nameInStruct = name + '[' + i + ']' + '.' + key;
                        _this._uniformValues[nameInStruct] = valueInStruct;
                        _this._uniformFlags[nameInStruct] = true;
                        _this._uniformPrivate[nameInStruct] = true;
                    });
                });
                // 只是用来保存结构体对象
                this._uniformValues[name] = value;
                this._uniformFlags[name] = false;
            }
            else {
                this._uniformValues[name] = value;
                this._uniformFlags[name] = true;
            }
        }
        return true;
    };
    MarsMaterialDataBlock.prototype.setUniformValues = function (map) {
        var _this = this;
        forEach(map, function (val, key) {
            _this.setUniformValue(key, val);
        });
    };
    MarsMaterialDataBlock.prototype.setUniformSemantic = function (name, semantic) {
        if (semantic) {
            this.uniformSemantics[name] = semantic;
        }
        else {
            delete this.uniformSemantics[name];
        }
    };
    MarsMaterialDataBlock.prototype.clone = function (name) {
        return new MarsMaterialDataBlock({
            name: name,
            uniformValues: __assign({}, this._uniformValues),
            uniformTextures: __assign({}, this._uniformTextures),
            uniformSemantics: __assign({}, this.uniformSemantics),
            keepUboData: this._keepUboData,
        }, this.renderer);
    };
    return MarsMaterialDataBlock;
}());

var seed$2 = 1;
var MarsMaterial = /** @class */ (function () {
    function MarsMaterial(options) {
        this._isDestroyed = false;
        this.name = options.name || ('Material' + seed$2++);
        this._dataBlocks = (options.dataBlocks || []).map(function (b) { return (b instanceof MarsMaterialDataBlock) ? b : new MarsMaterialDataBlock(b); });
        this.renderType = 0 /* MaterialRenderType.normal */;
        this.states = this.createMaterialStates(options.states);
        this.options = options;
        this._dbMap = {};
        if (!this._dataBlocks.length) {
            this._dataBlocks[0] = new MarsMaterialDataBlock({ name: 'main' });
        }
    }
    Object.defineProperty(MarsMaterial.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsMaterial.prototype, "dataBlocks", {
        get: function () {
            return this._dataBlocks;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsMaterial.prototype, "defaultDataBlock", {
        get: function () {
            return this._dataBlocks[0];
        },
        enumerable: false,
        configurable: true
    });
    MarsMaterial.prototype.createMaterialStates = function (states) {
        var ret = {
            blending: !!states.blending,
            sampleAlphaToCoverage: !!states.sampleAlphaToCoverage,
            depthTest: !!states.depthTest,
            stencilTest: !!states.stencilTest,
            cullFaceEnabled: !!states.cullFaceEnabled,
            polygonOffsetFill: !!states.polygonOffsetFill,
        };
        if (states.stencilMask === undefined || states.stencilMask === null) {
            ret.stencilMaskBack = valIfUndefined(states.stencilMaskBack, 0xff);
            ret.stencilMaskFront = valIfUndefined(states.stencilMaskFront, 0xff);
        }
        else {
            var stencilMaskBack = valIfUndefined(states.stencilMaskBack, states.stencilMask);
            ret.stencilMaskBack = valIfUndefined(stencilMaskBack, 0xff);
            var stencilMaskFront = valIfUndefined(states.stencilMaskFront, states.stencilMask);
            ret.stencilMaskFront = valIfUndefined(stencilMaskFront, 0xff);
        }
        if (states.stencilFunc === undefined || states.stencilFunc === null) {
            ret.stencilFuncBack = valIfUndefined(states.stencilFuncBack, [constants.ALWAYS, 0, 0xff]);
            ret.stencilFuncFront = valIfUndefined(states.stencilFuncFront, [constants.ALWAYS, 0, 0xff]);
        }
        else {
            var stencilFuncFront = valIfUndefined(states.stencilFuncFront, states.stencilFunc);
            ret.stencilFuncFront = valIfUndefined(stencilFuncFront, [constants.ALWAYS, 0, 0xff]);
            var stencilFuncBack = valIfUndefined(states.stencilFuncBack, states.stencilFunc);
            ret.stencilFuncBack = valIfUndefined(stencilFuncBack, [constants.ALWAYS, 0, 0xff]);
        }
        if (states.stencilOp === undefined || states.stencilOp === null) {
            ret.stencilOpFront = valIfUndefined(states.stencilOpFront, [constants.KEEP, constants.KEEP, constants.KEEP]);
            ret.stencilOpBack = valIfUndefined(states.stencilOpBack, [constants.KEEP, constants.KEEP, constants.KEEP]);
        }
        else {
            var stencilOpFront = valIfUndefined(states.stencilOpFront, states.stencilOp);
            ret.stencilOpFront = valIfUndefined(stencilOpFront, [constants.KEEP, constants.KEEP, constants.KEEP]);
            var stencilOpBack = valIfUndefined(states.stencilOpBack, states.stencilOp);
            ret.stencilOpBack = valIfUndefined(stencilOpBack, [constants.KEEP, constants.KEEP, constants.KEEP]);
        }
        //blend
        ret.blendSrc = valIfUndefined(states.blendSrc, constants.ONE);
        ret.blendSrcAlpha = valIfUndefined(states.blendSrcAlpha, ret.blendSrc);
        ret.blendDst = valIfUndefined(states.blendDst, constants.ZERO);
        ret.blendDstAlpha = valIfUndefined(states.blendDstAlpha, ret.blendDst);
        ret.blendEquationRGB = valIfUndefined(states.blendEquationRGB, constants.FUNC_ADD);
        ret.blendEquationAlpha = valIfUndefined(states.blendEquationAlpha, ret.blendEquationRGB);
        ret.blendColor = valIfUndefined(states.blendColor, [0, 0, 0, 0]);
        //color
        ret.colorMask = valIfUndefined(states.colorMask, [true, true, true, true]);
        //depth
        ret.depthMask = valIfUndefined(states.depthMask, true);
        ret.depthFunc = valIfUndefined(states.depthFunc, constants.LESS);
        ret.depthRange = valIfUndefined(states.depthRange, [0, 1]);
        ret.cullFace = valIfUndefined(states.cullFace, constants.BACK);
        ret.frontFace = valIfUndefined(states.frontFace, constants.CCW);
        ret.polygonOffset = states.polygonOffset || [0, 0];
        //ret
        return Object.freeze(ret);
    };
    MarsMaterial.prototype.addDataBlock = function (b) {
        if (this.getDataBlockByName(b.name)) {
            throw Error('dataBlock with same name:' + b.name);
        }
        if (arrAdd(this._dataBlocks, b)) {
            b.invalidAllFlags();
            var r = this.renderer;
            if (r) {
                b.assignRenderer(r);
            }
        }
    };
    MarsMaterial.prototype.getDataBlockByName = function (name) {
        var cache = this._dbMap[name];
        if (!cache) {
            var db = this._dataBlocks.find(function (db) { return db.name === name; });
            if (db) {
                return this._dbMap[name] = db;
            }
        }
        return cache;
    };
    MarsMaterial.prototype.removeDataBlock = function (b) {
        arrRemove(this._dataBlocks, b);
        delete this._dbMap[b.name];
    };
    MarsMaterial.prototype.assignRenderer = function (renderer) {
        if (!this.materialInternal) {
            var shader = this.options.shader;
            // @ts-expect-error safe to assign
            this.shaderCacheId = renderer.internal.shaderLibrary.addShader(shader);
            // @ts-expect-error safe to assign
            this.materialInternal = new GLMaterial(renderer.internal, this);
            // @ts-expect-error safe to assign
            this['renderer'] = renderer;
            this._dataBlocks.forEach(function (d) { return d.assignRenderer(renderer); });
        }
        return this;
    };
    MarsMaterial.prototype.destroy = function (options) {
        var _a;
        if ((options === null || options === void 0 ? void 0 : options.blocks) !== exports.DestroyOptions.keep) {
            this._dataBlocks.forEach(function (b) { return b.destroy({ textures: options === null || options === void 0 ? void 0 : options.textures }); });
        }
        (_a = this.materialInternal) === null || _a === void 0 ? void 0 : _a.destroy();
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    return MarsMaterial;
}());
function valIfUndefined(val, def) {
    if (val === undefined || val === null) {
        return def;
    }
    return val;
}

function createVAO(renderer, name) {
    if (renderer.gpu.capability.vao) {
        var ret = new GLVertexArrayObject(renderer, name);
        if (ret.vao) {
            return ret;
        }
    }
}
var GLVertexArrayObject = /** @class */ (function () {
    function GLVertexArrayObject(renderer, name) {
        this.ready = false;
        this.renderer = renderer;
        this.vao = renderer.createVertexArray(name);
    }
    GLVertexArrayObject.prototype.destroy = function () {
        if (this.vao) {
            var renderer = this.renderer;
            if (renderer.state.bindingVAO == this.vao) {
                renderer.state.bindingVAO = undefined;
                renderer.bindVertexArray(null);
            }
            renderer.deleteVertexArray(this.vao);
            //@ts-expect-error safe to assign
            this.vao = this.renderer = null;
        }
    };
    GLVertexArrayObject.prototype.bind = function () {
        var renderer = this.renderer;
        if (this.vao && renderer.state.bindingVAO !== this.vao) {
            renderer.state.bindingVAO = this.vao;
            renderer.bindVertexArray(this.vao);
        }
    };
    GLVertexArrayObject.prototype.unbind = function () {
        var renderer = this.renderer;
        renderer.bindVertexArray(null);
        renderer.state.bindingVAO = undefined;
    };
    return GLVertexArrayObject;
}());

var _a$1, _b;
var INDEX_TYPE_MAP = (_a$1 = {},
    _a$1[Uint16Array.BYTES_PER_ELEMENT] = constants.UNSIGNED_SHORT,
    _a$1[Uint32Array.BYTES_PER_ELEMENT] = constants.UNSIGNED_INT,
    _a$1);
var TYPE_BYTE_MAP = (_b = {},
    _b[constants.UNSIGNED_SHORT] = Uint16Array.BYTES_PER_ELEMENT,
    _b[constants.UNSIGNED_INT] = Uint32Array.BYTES_PER_ELEMENT,
    _b);
/**
 * GLGeometry对象，保存GLGPUBuffer对象。
 *
 */
var GLGeometry = /** @class */ (function () {
    function GLGeometry(option, renderer) {
        this.renderer = renderer;
        this.drawStart = option.drawStart;
        this.drawCount = option.drawCount;
        this.mode = isNaN(option.mode) ? constants.TRIANGLES : option.mode;
        this.name = option.name;
        var buffers = {};
        var inAttributes = option.attributes;
        var attributes = {};
        if (option instanceof GLGeometry) {
            forEach(option._buffersMap, function (buffer, name) {
                buffers[name] = buffer;
            });
        }
        else {
            // 创建GPUBuffer
            forEach(option.buffers, function (opt, name) {
                buffers[name] = new GLGPUBuffer(opt, renderer);
            });
            if (option.index && option.index.data) {
                var ret = this.createIndexBuffer(option.index.data, renderer);
                this.setIndexBuffer(ret[0], ret[1]);
            }
        }
        this._buffersMap = buffers;
        // 记录顶点属性
        forEach(inAttributes, function (attribute, name) {
            attributes[name] = attribute;
        });
        this.attributes = attributes;
        this.vaoMap = {};
    }
    GLGeometry.prototype.createVao = function (name) {
        if (!this.vaoMap[name]) {
            this.vaoMap[name] = createVAO(this.renderer, "".concat(this.name, "-").concat(name));
        }
        return this.vaoMap[name];
    };
    GLGeometry.prototype.destroyVao = function (name) {
        var _a;
        (_a = this.vaoMap[name]) === null || _a === void 0 ? void 0 : _a.destroy();
        this.vaoMap[name] = undefined;
    };
    GLGeometry.prototype.setIndexBuffer = function (buffer, indexBufferType) {
        this._indexBuffer = buffer;
        this.indexBufferType = indexBufferType;
    };
    GLGeometry.prototype.createIndexBuffer = function (data, renderer) {
        var type = INDEX_TYPE_MAP[data.BYTES_PER_ELEMENT];
        var indexOption = {
            data: data,
            target: constants.ELEMENT_ARRAY_BUFFER,
            name: "".concat(this.name, "##index"),
        };
        return [new GLGPUBuffer(indexOption, renderer), type];
    };
    GLGeometry.prototype.getGPUBuffer = function (name) {
        return this._buffersMap[name];
    };
    GLGeometry.prototype.destroy = function () {
        var _a;
        if (this.renderer) {
            forEach(this._buffersMap, function (buffer) {
                buffer.destroy();
            });
            this._buffersMap = {};
            (_a = this._indexBuffer) === null || _a === void 0 ? void 0 : _a.destroy();
            var m_1 = this.vaoMap;
            forEach(m_1, function (vao, key) {
                vao === null || vao === void 0 ? void 0 : vao.destroy();
                m_1[key] = undefined;
            });
        }
        this.attributes = {};
        this._indexBuffer = undefined;
        this.renderer = undefined;
    };
    GLGeometry.prototype.setAttributeBuffer = function (name, buffer) {
        this._buffersMap[name] = buffer;
        // update vao bind
    };
    GLGeometry.prototype.getAttributeBuffer = function (name) {
        if (this._buffersMap != undefined) {
            return this._buffersMap[name];
        }
        return null;
    };
    GLGeometry.prototype.draw = function (state) {
        var _a, _b;
        var index = this._indexBuffer;
        var gl = (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.gl;
        var gpu = (_b = this.renderer) === null || _b === void 0 ? void 0 : _b.gpu;
        var useInstancedDraw = (gpu === null || gpu === void 0 ? void 0 : gpu.capability.instanceDraw) && state.currentMesh.instanceCount > 0;
        if (gl && gpu) {
            var drawCount = this.drawCount;
            if (index) {
                var type = this.indexBufferType;
                //bind by vao
                //this._indexBuffer?.bind();
                var dc = isNaN(drawCount) ? index.getElementCount(TYPE_BYTE_MAP[type]) : drawCount;
                if (dc > 0) {
                    if (useInstancedDraw) {
                        gpu.drawElementsInstanced(gl, this.mode, dc, type, this.drawStart || 0, state.currentMesh.instanceCount);
                    }
                    else {
                        gl.drawElements(this.mode, dc, type, this.drawStart || 0);
                    }
                }
            }
            else if (drawCount > 0) {
                if (useInstancedDraw) {
                    gpu.drawArraysInstanced(gl, this.mode, this.drawStart, this.drawCount, state.currentMesh.instanceCount);
                }
                else {
                    gl.drawArrays(this.mode, this.drawStart, this.drawCount);
                }
            }
        }
    };
    return GLGeometry;
}());

var _a;
var BYTES_TYPE_MAP = (_a = {},
    _a[constants.FLOAT] = Float32Array.BYTES_PER_ELEMENT,
    _a[constants.INT] = Int32Array.BYTES_PER_ELEMENT,
    _a[constants.SHORT] = Int16Array.BYTES_PER_ELEMENT,
    _a[constants.BYTE] = Int8Array.BYTES_PER_ELEMENT,
    _a);
function isIndexDataType(data) {
    var result = (data instanceof Uint8Array) || (data instanceof Uint16Array) ||
        (data instanceof Uint32Array);
    return result;
}
function attributeData2GLType(data) {
    if (data instanceof Float32Array) {
        return constants.FLOAT;
    }
    else {
        return constants.INT;
    }
}
function emptyTypedArrayByGLType(type) {
    if (type === constants.INT) {
        return new Int32Array(0);
    }
    if (type === constants.SHORT) {
        return new Int16Array(0);
    }
    return new Float32Array(0);
}
// 根据attribute的datasource获取js端buffer
function getAttributeBufferOption(geom, name) {
    var attribute = geom._attributes[name];
    if (attribute) {
        return geom._buffers[attribute.dataSource];
    }
    return undefined;
}
var seed$1 = 1;
/**
 * 应用层Geometry对象，本身不直接保存GPU资源而是通过geometryInternal成员保存GPU资源。
 *
 */
var MarsGeometry = /** @class */ (function () {
    function MarsGeometry(option) {
        var _a, _b;
        this._attributesName = [];
        this._indexReleasable = false;
        this._isDestroyed = false;
        this._drawStart = option.drawStart ? option.drawStart : 0;
        this._drawCount = isNaN(+option.drawCount) ? NaN : option.drawCount;
        this._mode = (isNaN(option.mode) ? constants.TRIANGLES : option.mode);
        this.name = option.name || ('MarsGeometry:' + seed$1++);
        var usage = option.bufferUsage || constants.STATIC_DRAW;
        this.options = option;
        // 记录顶点属性，需要与Shader中attribute进行关联
        var buffers = {};
        var attributesName = [];
        var attributes = {};
        // key为buffer的名字
        var dirtyFlags = {};
        var attributesReleasable = {};
        forEach(option.attributes, function (attr, name) {
            var data = attr.data;
            var type = attr.type || constants.FLOAT;
            var releasable = attr.releasable;
            if (type && !attr.dataSource && !data) {
                data = emptyTypedArrayByGLType(type);
            }
            if (data) {
                // 使用AttributeWithData构造的attribute
                buffers[name] = {
                    data: data,
                    usage: usage,
                    name: name,
                };
                var gltype = attributeData2GLType(data);
                attributes[name] = {
                    size: attr.size,
                    stride: attr.stride,
                    offset: attr.offset,
                    type: type || gltype,
                    normalize: !!attr.normalize,
                    dataSource: (name),
                    instanceDivisor: attr.instanceDivisor,
                };
                attributesReleasable[name] = releasable || false;
                dirtyFlags[name] = {
                    dirty: true,
                    discard: true,
                    start: Number.POSITIVE_INFINITY,
                    end: 0,
                };
            }
            else {
                // 使用AttributeWithType构造的attribute
                var datasource = attr.dataSource;
                if (datasource) {
                    // 属性共享buffer
                    attributes[name] = {
                        size: attr.size,
                        stride: attr.stride,
                        offset: attr.offset,
                        type: type,
                        dataSource: datasource,
                        normalize: !!attr.normalize,
                    };
                }
            }
            attributesName.push(name);
        });
        // 顶点索引
        this._index = (_a = option.index) === null || _a === void 0 ? void 0 : _a.data;
        if (this._index instanceof Uint8Array) {
            throw Error('Uint8 Index not support');
        }
        dirtyFlags['index'] = {
            dirty: true,
            discard: true,
            start: Number.POSITIVE_INFINITY,
            end: 0,
        };
        this._indexReleasable = ((_b = option.index) === null || _b === void 0 ? void 0 : _b.releasable) === true;
        this._buffers = buffers;
        this._attributes = attributes;
        this._attributesName = attributesName;
        this._attributesReleasable = attributesReleasable;
        this._dirtyFlags = dirtyFlags;
    }
    Object.defineProperty(MarsGeometry.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsGeometry.prototype, "mode", {
        get: function () {
            return this._mode;
        },
        set: function (n) {
            this._mode = n;
            if (this.internal) {
                this.internal.mode = n;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsGeometry.prototype, "attributes", {
        get: function () {
            return this._attributes;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsGeometry.prototype, "drawCount", {
        get: function () {
            return this._drawCount;
        },
        set: function (n) {
            this._drawCount = +n;
            if (this.internal) {
                this.internal.drawCount = +n;
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsGeometry.prototype, "drawStart", {
        get: function () {
            return this._drawStart;
        },
        set: function (n) {
            this._drawStart = n;
            if (this.internal) {
                this.internal.drawStart = n;
            }
        },
        enumerable: false,
        configurable: true
    });
    MarsGeometry.prototype.destroy = function () {
        this.drawStart = 0;
        this.drawCount = NaN;
        // @ts-expect-error destroyed set null
        this._buffers = undefined;
        // @ts-expect-error destroyed set null
        this.options = undefined;
        this._attributes = {};
        this._attributesName = [];
        if (this.internal) {
            this.internal.destroy();
            // @ts-expect-error destroyed set null
            this['internal'] = undefined;
            this.renderer = undefined;
        }
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    // 出入GPUBuffer对象，
    MarsGeometry.prototype.setAttributeBuffer = function (name, buffer) {
        if (this.internal == undefined) {
            return;
        }
        var gpuBuffers = this.internal._buffersMap;
        var gpuBufferName = this._attributes[name].dataSource;
        if (gpuBuffers[gpuBufferName]) {
            gpuBuffers[gpuBufferName] = buffer;
        }
    };
    MarsGeometry.prototype.getAttributeBuffer = function (name) {
        if (this.internal == undefined) {
            return undefined;
        }
        var gpuBuffers = this.internal._buffersMap;
        var gpuBufferName = this._attributes[name].dataSource;
        return gpuBuffers[gpuBufferName];
    };
    MarsGeometry.prototype.setAttributeData = function (name, data) {
        var buffers = this._buffers;
        if (buffers == undefined) {
            return;
        }
        var gpuBufferOption = getAttributeBufferOption(this, name);
        var gpuBufferName = this._attributes[name].dataSource;
        if (gpuBufferOption) {
            var option = {
                data: data,
                usage: gpuBufferOption.usage,
                target: gpuBufferOption.target,
            };
            buffers[gpuBufferName] = option;
            this._dirtyFlags[gpuBufferName].discard = true;
            this._dirtyFlags[gpuBufferName].dirty = true;
        }
    };
    MarsGeometry.prototype.getAttributeData = function (name) {
        var buffers = this._buffers;
        if (buffers == undefined) {
            return;
        }
        var gpuBufferOption = getAttributeBufferOption(this, name);
        if (gpuBufferOption) {
            return gpuBufferOption.data;
        }
        return undefined;
    };
    MarsGeometry.prototype.setAttributeSubData = function (name, offset, data) {
        var buffers = this._buffers;
        if (buffers == undefined) {
            return;
        }
        var gpuBufferOption = getAttributeBufferOption(this, name);
        if (gpuBufferOption) {
            var attribute = gpuBufferOption;
            if (attribute.data != undefined) {
                var start = offset;
                var length_1 = offset + data.length;
                // this._dirtyFlags[name].discard = false;
                if (attribute.data.length < length_1) {
                    // @ts-expect-error safe to use
                    var newData = new data.constructor(length_1);
                    newData.set(attribute.data);
                    attribute.data = newData;
                    this._dirtyFlags[name].discard = true;
                }
                else if (!this._dirtyFlags[name].discard) {
                    var dirtyFlag = this._dirtyFlags[name];
                    dirtyFlag.start = Math.min(dirtyFlag.start, start);
                    dirtyFlag.end = Math.max(dirtyFlag.end, length_1 - 1);
                }
                attribute.data.set(data, start);
                this._dirtyFlags[name].dirty = true;
            }
        }
    };
    MarsGeometry.prototype.getIndexData = function () {
        return this._index;
    };
    MarsGeometry.prototype.setIndexData = function (data) {
        if (isIndexDataType(data)) {
            this._index = data;
            this._dirtyFlags['index'].discard = true;
            this._dirtyFlags['index'].dirty = true;
        }
    };
    MarsGeometry.prototype.setIndexSubData = function (offset, data) {
        var _a;
        if (this._index) {
            // this._dirtyFlags['index'].discard = false;
            var start = offset;
            var length_2 = offset + data.length;
            if (this._index.length < length_2) {
                // @ts-expect-error safe to use
                var newData = new data.constructor(end);
                newData.set(this._index);
                this._index = newData;
                this._dirtyFlags['index'].discard = true;
            }
            else if (!this._dirtyFlags['index'].discard) {
                var dirtyFlag = this._dirtyFlags['index'];
                dirtyFlag.start = Math.min(dirtyFlag.start, start);
                dirtyFlag.end = Math.max(dirtyFlag.end, length_2 - 1);
            }
            (_a = this._index) === null || _a === void 0 ? void 0 : _a.set(data, start);
            this._dirtyFlags['index'].dirty = true;
        }
    };
    MarsGeometry.prototype.getAttributeStride = function (name) {
        var attr = this._attributes[name];
        if (attr.stride) {
            return attr.stride;
        }
        return attr.size * BYTES_TYPE_MAP[attr.type];
    };
    MarsGeometry.prototype.getAttributeDataLength = function (name) {
        var _a;
        if (this._buffers) {
            var gpuBufferOption = getAttributeBufferOption(this, name);
            if (gpuBufferOption) {
                return (_a = gpuBufferOption.data) === null || _a === void 0 ? void 0 : _a.length;
            }
        }
        return 0;
    };
    MarsGeometry.prototype.getAttributeNames = function () {
        return this._attributesName;
    };
    MarsGeometry.prototype.assignRenderer = function (renderer) {
        if (!this.internal) {
            // 索引缓冲区参数
            var indexBufferOption = undefined;
            if (this._index) {
                var data = this._index;
                indexBufferOption = {
                    data: data,
                    usage: constants.STATIC_DRAW,
                };
                if (data instanceof Uint16Array) {
                    this.indexDataType = constants.UNSIGNED_SHORT;
                }
                else if (data instanceof Uint32Array) {
                    this.indexDataType = constants.UNSIGNED_INT;
                }
            }
            // 顶点属性参数
            var options = {
                drawStart: this.drawStart,
                drawCount: this.drawCount,
                // 传给GLGeometry用于绑定顶点属性
                attributes: this._attributes,
                buffers: this._buffers,
                mode: this.mode,
                index: indexBufferOption,
                indexDataType: this.indexDataType,
                name: this.name,
            };
            //@ts-expect-error safe to set
            this['internal'] = new GLGeometry(options, renderer.internal);
            this.renderer = renderer;
            this.flush();
            //@ts-expect-error safe to set
            this.options = undefined;
        }
        return this;
    };
    MarsGeometry.prototype.flush = function () {
        var internal = this.internal;
        if (internal) {
            var attributes_1 = this._attributes;
            var attributesBuffer_1 = this._buffers;
            var indexBuffer_1 = this._index;
            forEach(this._dirtyFlags, function (flag, name) {
                var gpuBuffer;
                var data;
                if (name == 'index') {
                    gpuBuffer = internal._indexBuffer;
                    data = indexBuffer_1;
                }
                else {
                    var bufferName = attributes_1[name].dataSource;
                    gpuBuffer = internal.getGPUBuffer(bufferName);
                    data = attributesBuffer_1[bufferName].data;
                }
                if ((flag.dirty || flag.discard) && gpuBuffer && data) {
                    if (flag.discard) {
                        gpuBuffer.bufferData(data);
                    }
                    else {
                        var offset = flag.start * data.BYTES_PER_ELEMENT + data.byteOffset;
                        var length_3 = flag.end - flag.start + 1;
                        // @ts-expect-error safe to use
                        var subData = new data.constructor(data.buffer, offset, length_3);
                        gpuBuffer.bufferSubData(flag.start, subData);
                    }
                    flag.start = Number.POSITIVE_INFINITY;
                    flag.end = 0;
                    flag.dirty = flag.discard = false;
                }
            });
            // 需要释放的attributes数据
            forEach(this._attributesReleasable, function (releasable, name) {
                var bufferName = attributes_1[name].dataSource;
                if (attributesBuffer_1[bufferName] && releasable) {
                    attributesBuffer_1[bufferName].data = undefined;
                }
            });
            // 释放indexbuffer
            if (this._indexReleasable) {
                this._index = undefined;
            }
        }
        return false;
    };
    return MarsGeometry;
}());

var seed = 1;
var MarsMesh = /** @class */ (function () {
    function MarsMesh(options, renderer) {
        this._isDestroyed = false;
        this.material = options.material instanceof MarsMaterial ? options.material : new MarsMaterial(options.material);
        var geo = options.geometry;
        if (geo) {
            this.geometries = [geo instanceof MarsGeometry ? geo : new MarsGeometry(geo)];
        }
        else if (options.geometries) {
            this.geometries = options.geometries.map(function (geo) { return geo instanceof MarsGeometry ? geo : new MarsGeometry(geo); });
        }
        else {
            this.geometries = [];
        }
        this.name = options.name || ('MarsMesh_' + seed++);
        this.priority = options.priority || 0;
        this.hide = false;
        if (renderer) {
            this.assignRenderer(renderer);
        }
    }
    Object.defineProperty(MarsMesh.prototype, "isDestroyed", {
        get: function () {
            return this._isDestroyed;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsMesh.prototype, "geometry", {
        get: function () {
            return this.geometries[0];
        },
        enumerable: false,
        configurable: true
    });
    MarsMesh.prototype.setMaterial = function (mtl, destroyMtl) {
        if (destroyMtl !== exports.DestroyOptions.keep) {
            this.material.destroy(destroyMtl);
        }
        //@ts-expect-error set from internal safely
        this.material = mtl instanceof MarsMaterial ? mtl : new MarsMaterial(mtl);
        if (this.renderer) {
            this.material.assignRenderer(this.renderer);
        }
    };
    MarsMesh.prototype.setGeometries = function (geos, destroyGeometries) {
        var arr = this.geometries;
        if (destroyGeometries !== exports.DestroyOptions.keep) {
            arr.forEach(function (g) { return g.destroy(); });
        }
        arr.length = 0;
        var r = this.renderer;
        geos.forEach(function (g) {
            if (r) {
                g.assignRenderer(r);
            }
            arr.push(g);
        });
    };
    MarsMesh.prototype.destroy = function (options) {
        if (this._isDestroyed) {
            consoleError('call mesh.destroy multiple times', this);
        }
        if ((options === null || options === void 0 ? void 0 : options.geometries) !== exports.DestroyOptions.keep) {
            this.geometries.forEach(function (element) {
                element.destroy();
            });
        }
        this.geometries.length = 0;
        var materialDestroyOption = options === null || options === void 0 ? void 0 : options.material;
        if (materialDestroyOption !== exports.DestroyOptions.keep && this.material) {
            this.material.destroy(materialDestroyOption);
            // @ts-expect-error safe to assign
            this['material'] = undefined;
        }
        this.assignRenderer = throwDestroyedError;
        this._isDestroyed = true;
    };
    MarsMesh.prototype.assignRenderer = function (renderer) {
        this.geometries.forEach(function (element) {
            element.assignRenderer(renderer);
        });
        if (!this.material.materialInternal) {
            this.material.assignRenderer(renderer);
        }
        this.renderer = renderer;
        return this;
    };
    return MarsMesh;
}());
var MarsInstancedMesh = /** @class */ (function (_super) {
    __extends(MarsInstancedMesh, _super);
    function MarsInstancedMesh(options, renderer) {
        var _this = _super.call(this, options, renderer) || this;
        _this.instanceCount = options.instanceCount;
        return _this;
    }
    return MarsInstancedMesh;
}(MarsMesh));

var copyShaderId = '$mri-internal-copy';
var MarsExtWrap = /** @class */ (function () {
    function MarsExtWrap(renderer) {
        this.renderer = renderer;
        if ((renderer === null || renderer === void 0 ? void 0 : renderer.gpu.level) === 1) {
            this._copyRenderPass = this._createCopyRenderPass().assignRenderer(renderer);
            var shader = this._copyRenderPass.meshes[0].material.options.shader;
            renderer.shaderLibrary.addShader(shader);
            renderer.shaderLibrary.compileShader(copyShaderId);
        }
    }
    MarsExtWrap.prototype.resetColorAttachments = function (rp, colorTextures) {
        var r = this.renderer;
        if (r) {
            rp.resetColorAttachments(colorTextures);
        }
    };
    MarsExtWrap.prototype.copyTexture = function (source, tex) {
        var renderer = this.renderer;
        if (renderer) {
            source.assignRenderer(renderer);
            tex.assignRenderer(renderer);
            tex.updateSource({
                sourceType: exports.TextureSourceType.framebuffer,
                data: {
                    width: tex.width || source.width,
                    height: tex.height || source.height,
                },
            });
            if (renderer.gpu.level === 2) {
                this.copy2(source, tex);
            }
            else {
                this.copy1(source, tex);
            }
        }
    };
    MarsExtWrap.prototype.copy2 = function (source, target) {
        var _a;
        (_a = this.renderer) === null || _a === void 0 ? void 0 : _a.internal.copy2(source.internal, target.internal);
    };
    MarsExtWrap.prototype.copy1 = function (source, target) {
        var rp = this._copyRenderPass;
        if (rp) {
            var renderer = this.renderer;
            if (renderer) {
                var fb = rp.frameBuffer;
                fb.viewport[2] = target.width || source.width;
                fb.viewport[3] = target.height || source.height;
                renderer.internal.resetColorAttachments(fb, [target.internal]);
                var mesh = rp.meshes[0];
                mesh.material.defaultDataBlock.setUniformTexture('uTex', source);
                RenderFrameInternal.renderRenderPass(renderer, rp, { currentFrame: {} });
            }
        }
    };
    MarsExtWrap.prototype._createCopyRenderPass = function () {
        var name = 'mri-copy-mesh';
        return new MarsRenderPass({
            name: 'mri-copy-rp',
            loadAction: {
                colorAction: exports.TextureLoadAction.whatever,
            },
            attachments: [{ texture: { format: constants.RGBA } }],
            meshes: [new MarsMesh({
                    name: name,
                    priority: 0,
                    geometry: {
                        name: name,
                        mode: constants.TRIANGLE_STRIP,
                        attributes: {
                            aPos: {
                                type: constants.FLOAT,
                                size: 2,
                                data: new Float32Array([-1, 1, -1, -1, 1, 1, 1, -1]),
                            },
                        },
                        drawCount: 4,
                    },
                    material: {
                        states: {
                            depthTest: false,
                            cullFaceEnabled: false,
                            stencilTest: false,
                        },
                        name: name,
                        shader: {
                            cacheId: copyShaderId,
                            name: name,
                            vertex: "precision highp float;\n          attribute vec2 aPos;varying vec2 vTex;\n          void main(){\n             gl_Position = vec4(aPos,0.,1.0);\n             vTex = (aPos + vec2(1.))/2.;\n           }\n          ",
                            fragment: " precision highp float;\n          varying vec2 vTex;\n          uniform sampler2D uTex;\n          void main(){gl_FragColor = texture2D(uTex,vTex);}\n          ",
                        },
                    },
                })],
        });
    };
    MarsExtWrap.prototype.destroy = function () {
        var _a, _b;
        if (this.renderer) {
            (_a = this._copyRenderPass) === null || _a === void 0 ? void 0 : _a.meshes[0].material.defaultDataBlock.setUniformValue('uTex', undefined);
            (_b = this._copyRenderPass) === null || _b === void 0 ? void 0 : _b.destroy();
            this.renderer = undefined;
        }
    };
    return MarsExtWrap;
}());

var ERR_EXP = 'WebGL not available';
var MarsRenderer = /** @class */ (function () {
    function MarsRenderer(options) {
        var gl = options.gl;
        if (!gl) {
            var webglOptions = {
                preserveDrawingBuffer: options.willCaptureImage,
                alpha: true,
                stencil: true,
                antialias: true,
                depth: true,
                premultipliedAlpha: true,
            };
            var canvas = options.canvas;
            if (canvas) {
                var frameworks = options.frameworks || [getDefaultGPUCapability().type];
                for (var i = 0; i < frameworks.length; i++) {
                    gl = canvas === null || canvas === void 0 ? void 0 : canvas.getContext(frameworks[i], webglOptions);
                    if (gl) {
                        break;
                    }
                }
            }
        }
        if (gl) {
            this.gpu = new GLGPUCapability({ gl: gl });
            this.internal = new GLGPURenderer(gl);
            this.shaderLibrary = this.internal.shaderLibrary;
            this.canvas = gl.canvas;
        }
        else {
            this.gpu = new GPUCapabilityEmpty();
            this.shaderLibrary = new ShaderLibraryEmpty();
            this.canvas = new CanvasEmpty();
            consoleError(ERR_EXP);
        }
        this.extension = new MarsExtWrap(this);
    }
    Object.defineProperty(MarsRenderer.prototype, "isDestroyed", {
        get: function () {
            var internal = this.internal;
            return internal ? internal.isDestroyed : true;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderer.prototype, "height", {
        get: function () {
            var _a;
            return ((_a = this.internal) === null || _a === void 0 ? void 0 : _a.height) || 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(MarsRenderer.prototype, "width", {
        get: function () {
            var _a;
            return ((_a = this.internal) === null || _a === void 0 ? void 0 : _a.width) || 0;
        },
        enumerable: false,
        configurable: true
    });
    MarsRenderer.prototype.createBuffer = function (options) {
        var internal = this.internal;
        if (!internal) {
            throw Error(ERR_EXP);
        }
        return new GLGPUBuffer(options, internal);
    };
    MarsRenderer.prototype.createRenderFrame = function (options) {
        return new MarsRenderFrame(options || {}, this);
    };
    MarsRenderer.prototype.destroy = function (haltGL) {
        var _a;
        this.extension.destroy();
        (_a = this.internal) === null || _a === void 0 ? void 0 : _a.destroy(haltGL);
        // @ts-expect-error safe to assign
        this.gpu = new GPUCapabilityEmpty();
        // @ts-expect-error safe to assign
        this.shaderLibrary = new ShaderLibraryEmpty();
    };
    MarsRenderer.prototype.resize = function (width, height) {
        var internal = this.internal;
        if (internal) {
            if (this.width !== width || this.height !== height) {
                internal.resize(width, height);
            }
        }
    };
    MarsRenderer.prototype.cancelAnimationFrame = function (id) {
        return window.cancelAnimationFrame(id);
    };
    MarsRenderer.prototype.resume = function () {
    };
    MarsRenderer.prototype.getErrors = function () {
        var gl = this.internal.gl;
        var err = gl.getError();
        if (err) {
            return ['webgl error:' + err];
        }
        return [];
    };
    MarsRenderer.prototype.invalid = function () {
    };
    MarsRenderer.prototype.requestAnimationFrame = function (cb) {
        return window.requestAnimationFrame(cb);
    };
    return MarsRenderer;
}());

var MarsSharedGeometry = /** @class */ (function (_super) {
    __extends(MarsSharedGeometry, _super);
    function MarsSharedGeometry(opt, renderer) {
        var _this = _super.call(this, Object.assign({ attributes: {} }, opt)) || this;
        var indexData = opt.index ? opt.index.data : opt.geometry.getIndexData();
        if (indexData) {
            //@ts-expect-error safe to assign
            indexData = new indexData.constructor(indexData);
        }
        _this._index = indexData;
        _this._source = opt.geometry;
        _this._drawCount = opt.drawCount || 0;
        _this._drawStart = opt.drawStart || 0;
        _this._mode = opt.mode || 0;
        forEach(_this._source._attributes, function (attr, name) {
            _this._attributes[name] = Object.assign({}, attr);
        });
        if (renderer) {
            _this.assignRenderer(renderer);
        }
        return _this;
    }
    MarsSharedGeometry.prototype.assignRenderer = function (renderer) {
        if (!this.renderer) {
            var geometry = this._source;
            geometry.assignRenderer(renderer);
            var internal = geometry.internal;
            var glgeo = new GLGeometry(internal, renderer.internal);
            glgeo.drawCount = this.drawCount;
            glgeo.drawStart = this.drawStart;
            glgeo.mode = this.mode;
            if (this._index) {
                var ret = glgeo.createIndexBuffer(this._index, renderer.internal);
                glgeo.setIndexBuffer(ret[0], ret[1]);
            }
            //@ts-expect-error safe to assign
            this.internal = glgeo;
            this.renderer = geometry.renderer;
        }
        return this;
    };
    MarsSharedGeometry.prototype.getAttributeNames = function () {
        return this._source.getAttributeNames();
    };
    MarsSharedGeometry.prototype.getAttributeDataLength = function (name) {
        if (this._buffers[name]) {
            return _super.prototype.getAttributeDataLength.call(this, name);
        }
        return this._source.getAttributeDataLength(name);
    };
    MarsSharedGeometry.prototype.flush = function () {
        this._source.flush();
        return _super.prototype.flush.call(this);
    };
    MarsSharedGeometry.prototype.destroy = function () {
        if (this.internal) {
            //@ts-expect-error safe to assign
            this.internal.vaoMap = {};
        }
        _super.prototype.destroy.call(this);
    };
    return MarsSharedGeometry;
}(MarsGeometry));

consoleLog('version: ' + "0.3.3");
var ModuleMsg = 'RI Package: @predy-js/render-interface';

var RI = /*#__PURE__*/Object.freeze({
    __proto__: null,
    ModuleMsg: ModuleMsg,
    constants: constants,
    RenderFrame: MarsRenderFrame,
    Renderer: MarsRenderer,
    Mesh: MarsMesh,
    InstancedMesh: MarsInstancedMesh,
    Geometry: MarsGeometry,
    RenderPass: MarsRenderPass,
    Texture: MarsTexture,
    Material: MarsMaterial,
    MaterialDataBlock: MarsMaterialDataBlock,
    SharedGeometry: MarsSharedGeometry,
    getDefaultGPUCapability: getDefaultGPUCapability,
    getDefaultTextureFactory: getDefaultTextureFactory,
    setDefaultTextureFactory: setDefaultTextureFactory,
    MarsTextureFactory: MarsTextureFactory,
    get DestroyOptions () { return exports.DestroyOptions; },
    get PredyTextEncoding () { return exports.PredyTextEncoding; },
    get PredyVideoCodec () { return exports.PredyVideoCodec; },
    get PredyResourceCacheStatus () { return exports.PredyResourceCacheStatus; },
    get RenderPassDestroyAttachmentType () { return exports.RenderPassDestroyAttachmentType; },
    RenderPassPriorityPrepare: RenderPassPriorityPrepare,
    RenderPassPriorityNormal: RenderPassPriorityNormal,
    RenderPassPriorityPostprocess: RenderPassPriorityPostprocess,
    get TextureLoadAction () { return exports.TextureLoadAction; },
    get TextureStoreAction () { return exports.TextureStoreAction; },
    get RenderPassAttachmentStorageType () { return exports.RenderPassAttachmentStorageType; },
    get RenderPassMeshOrder () { return exports.RenderPassMeshOrder; },
    get TextureSourceType () { return exports.TextureSourceType; },
    GPUBufferOptionsMemoryShared: GPUBufferOptionsMemoryShared,
    get ShaderCompileResultStatus () { return exports.ShaderCompileResultStatus; },
    ShaderLibraryEmpty: ShaderLibraryEmpty
});

if (typeof window === 'object') {
    window.PredyRI = RI;
}
else if (typeof global === 'object') {
    global.PredyRI = RI;
}

exports.GPUBufferOptionsMemoryShared = GPUBufferOptionsMemoryShared;
exports.Geometry = MarsGeometry;
exports.InstancedMesh = MarsInstancedMesh;
exports.MarsTextureFactory = MarsTextureFactory;
exports.Material = MarsMaterial;
exports.MaterialDataBlock = MarsMaterialDataBlock;
exports.Mesh = MarsMesh;
exports.ModuleMsg = ModuleMsg;
exports.RenderFrame = MarsRenderFrame;
exports.RenderPass = MarsRenderPass;
exports.RenderPassPriorityNormal = RenderPassPriorityNormal;
exports.RenderPassPriorityPostprocess = RenderPassPriorityPostprocess;
exports.RenderPassPriorityPrepare = RenderPassPriorityPrepare;
exports.Renderer = MarsRenderer;
exports.ShaderLibraryEmpty = ShaderLibraryEmpty;
exports.SharedGeometry = MarsSharedGeometry;
exports.Texture = MarsTexture;
exports.constants = constants;
exports.getDefaultGPUCapability = getDefaultGPUCapability;
exports.getDefaultTextureFactory = getDefaultTextureFactory;
exports.setDefaultTextureFactory = setDefaultTextureFactory;
//# sourceMappingURL=index.js.map
